---------------------------------------------------------
-- RESSOURCE : Gamemode - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Gamemode main functions for the Airport Wars server.
---------------------------------------------------------
ready = {
	entries = false
}
------------------------------------- FUNCTIONS ---------------------------------------
RegisterNetEvent("airportwars:simplenotify")
AddEventHandler("airportwars:simplenotify", function(entry, color, elements, sound)
		if (color ~= -1) then
				SetNotificationBackgroundColor(color)
		end
		SetNotificationTextEntry(entry)
		for _, element in ipairs(elements) do
				AddTextComponentSubstringPlayerName(element)
		end
		DrawNotification(false, false)
		if (sound) then
				PlaySoundFrontend(-1, "Menu_Accept", "Phone_SoundSet_Default", 1)
		end
end)

RegisterNetEvent("airportwars:notify")
AddEventHandler("airportwars:notify", function(entry, color, elements, char, icon, sender, subject, duration, sound)
		if (color ~= -1) then
				SetNotificationBackgroundColor(color)
		end
		SetNotificationTextEntry(entry)
		for _, element in ipairs(elements) do
				AddTextComponentSubstringPlayerName(element)
		end
		SetNotificationMessage_4(char, char, true, icon, sender, subject, duration)
		DrawNotification_4(false, true)
		if (sound) then
				PlaySoundFrontend(-1, "Menu_Accept", "Phone_SoundSet_Default", 1)
		end
end)

RegisterNetEvent("airportwars:simpleoldnotify")
AddEventHandler("airportwars:simpleoldnotify", function(text, playsound, color)
		if color ~= nil then
				SetNotificationBackgroundColor(color)
		end
		SetNotificationTextEntry("STRING")
		AddTextComponentSubstringPlayerName(text)
		DrawNotification(false, false)
		if playsound then
				PlaySoundFrontend(-1, "Menu_Accept", "Phone_SoundSet_Default", 1)
		end
end)

RegisterNetEvent("airportwars:oldnotify")
AddEventHandler("airportwars:oldnotify", function(text, char, icon, sender, subject, duration, playsound, playcustomsound, soundname, soundsetname, color)
		if color ~= nil then
				SetNotificationBackgroundColor(color)
		end
		SetNotificationTextEntry("STRING")
		AddTextComponentSubstringPlayerName(text)
		SetNotificationMessage_4(char, char, true, icon, sender, subject, duration)
		DrawNotification_4(false, true)
		if playsound then
				PlaySoundFrontend(-1, "Menu_Accept", "Phone_SoundSet_Default", 1)
		end
		if playcustomsound then
				PlaySoundFrontend(-1, soundname, soundsetname, 1)
		end
end)

RegisterNetEvent("airportwars:subtitle")
AddEventHandler("airportwars:subtitle", function(text, time)
		ClearPrints()
		BeginTextCommandPrint("STRING")
		AddTextComponentSubstringPlayerName(text)
		EndTextCommandPrint(time, 1)
end)

RegisterNetEvent("airportwars:subtitlelooped")
AddEventHandler("airportwars:subtitlelooped", function(text)
		BeginTextCommandPrint("STRING")
		AddTextComponentSubstringPlayerName(text)
		EndTextCommandPrint(100, 1)
end)


RegisterNetEvent("airportwars:helptext")
AddEventHandler("airportwars:helptext", function(text)
		AddNextMessageToPreviousBriefs(0)
		BeginTextCommandDisplayHelp("STRING")
		AddTextComponentSubstringPlayerName(text)
		EndTextCommandDisplayHelp(0, 0, true, -1)
end)

RegisterNetEvent("airportwars:helptextfuture")
AddEventHandler("airportwars:helptextfuture", function(entry, beep, time, elements)
		BeginTextCommandDisplayHelp(entry)
		for _, element in ipairs(elements) do
				AddTextComponentSubstringPlayerName(element)
		end
		EndTextCommandDisplayHelp(0, 0, beep, time)
end)

RegisterNetEvent("airportwars:helptexttimed")
AddEventHandler("airportwars:helptexttimed", function(text, time)
		BeginTextCommandDisplayHelp("STRING")
		AddTextComponentSubstringPlayerName(text)
		EndTextCommandDisplayHelp(0, 0, true, time)
end)

RegisterNetEvent("airportwars:helptexttimedgxt")
AddEventHandler("airportwars:helptexttimedgxt", function(gxt, time)
		BeginTextCommandDisplayHelp(gxt)
		EndTextCommandDisplayHelp(0, 0, true, time)
end)

RegisterNetEvent("airportwars:loadingprompt")
AddEventHandler("airportwars:loadingprompt", function(text, time, type)
		BeginTextCommandBusyString("STRING")
		AddTextComponentSubstringPlayerName(text)
		EndTextCommandBusyString(type)
		SetTimeout(time, function()
				RemoveLoadingPrompt()
		end)
end)

RegisterNetEvent("airportwars:loadingpromptgxt")
AddEventHandler("airportwars:loadingpromptgxt", function(gxt, time, type)
		BeginTextCommandBusyString(gxt)
		EndTextCommandBusyString(type)
		SetTimeout(time, function()
				RemoveLoadingPrompt()
		end)
end)

RegisterNetEvent("airportwars:chatmessage")
AddEventHandler("airportwars:chatmessage", function(color, sender, tag, message)
    local mpchat = RequestScaleformMovie("multiplayer_chat")
    while not HasScaleformMovieLoaded(mpchat) do
      	Wait(0)
    end
    PushScaleformMovieFunction(mpchat, "ADD_MESSAGE")
    BeginTextCommandScaleformString("STRING")
    AddTextComponentScaleform(sender)
    EndTextCommandScaleformString()
    BeginTextCommandScaleformString("STRING")
    AddTextComponentScaleform(message)
    EndTextCommandScaleformString()
    BeginTextCommandScaleformString("STRING")
    AddTextComponentScaleform(tag)
    EndTextCommandScaleformString()
    PushScaleformMovieMethodParameterBool(false)
    PushScaleformMovieMethodParameterInt(color)
    PopScaleformMovieFunctionVoid()
    PushScaleformMovieFunction(mpchat, "SET_FOCUS")
    PushScaleformMovieMethodParameterInt(1)
    PopScaleformMovieFunctionVoid()
    DrawScaleformMovie(mpchat, 0.5, 0.5, 1.0, 1.0, 255, 255, 255, 255, 0)
end)

RegisterNetEvent("airportwars:closegame")
AddEventHandler("airportwars:closegame", function()
    SetTimeout(6666, function()
        ForceSocialClubUpdate()
    end)
end)

function hideMoney()
		N_0x95cf81bd06ee1887()
		RemoveMultiplayerBankCash()
end
---------------------------------------------------------------------------------------
