---------------------------------------------------------
-- RESSOURCE : Interaction Menu - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Interaction Menu for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local playername = ""
local doorsclosed = true
local menu = {
    {name="Quick GPS", desc="Select to place your waypoint at a set location.", type=4, call=false, list={"Objective", "Team Base", "Base Armory", "Vehicle Shop", "Skin Shop"}, event="airportwars:ampimenu:quickgps", id=1},
    {name="Vehicle", desc="View and change personal vehicle options.", type=5, event="airportwars:ampimenu:mainoption", id=2},
    {name="Profile (soon)", desc="Check your profile infos.", type=5, event="airportwars:ampimenu:mainoption", id=3},
    {name="Stats (soon)", desc="Check your statistics.", type=5, event="airportwars:ampimenu:mainoption", id=4},
    {name="Open free market (soon)", desc="Open the web trading market.", type=5, event="airportwars:ampimenu:mainoption", id=5},
    {name="Options (soon)", desc="More options here.", type=5, event="airportwars:ampimenu:mainoption", id=6},
    {name="Suicide", desc="Are you sure you want to do this?", type=0, event="airportwars:ampimenu:mainoption", id=7}
}
local vehicle = {
    --{name="Set as active vehicle", desc="Set your current vehicle as active.", type=0, event="airportwars:ampimenu:vehicle", id=1},
    --{name="Remove the vehicle", desc="Set as unactive the active vehicle.", type=0, event="airportwars:ampimenu:vehicle", id=2},
    {name="Vehicle doors", desc="Select which door of your Personal Vehicle to open and close.", type=4, call=false, list={"All", "Front left", "Front right", "Rear left", "Rear right", "Hood", "Trunk"}, event="airportwars:ampimenu:secondvehicle", id=3},
    {name="Limit the speed", desc="Limit the speed of your vehicle.", type=4, call=true, list={"Unlimited", "70km/h", "90km/h", "110km/h", "130km/h", "150km/h", "170km/h", "200km/h"}, event="airportwars:ampimenu:thirdvehicle", id=4},
    --{name="Engine", desc="Turn on/off your vehicle engine.", type=4, call=true, list={"With", "Without"}, event="airportwars:ampimenu:fourthvehicle", id=5},
    {name="Vehicle access", desc="Set who can access to your vehicle.", type=4, call=true, list={"Everyone", "Team only", "Me only"}, event="airportwars:ampimenu:fifthvehicle", id=6},
    {name="Radio", desc="Control the radio of your vehicle.", type=4, call=true, list={"Off", "Los Santos Rock Radio", "Non-Stop-Pop FM", "Radio Los Santos", "Channel X", "West Coast Talk Radio", "Rebel Radio", "Soulwax FM", "East Los FM", "West Coast Classics", "Blue Ark", "Worldwide FM", "FlyLo FM", "The Lowdown 91.1", "The Lab", "Radio Mirror Park", "Space 103.2", "Vinewood Boulevard Radio"}, event="airportwars:ampimenu:sixthvehicle", id=7}
}
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
local function InteractionMenu()
  	TriggerEvent("theftvrp:menu:create", "interaction", "player_name", "INTERACTION MENU", true)
  	local opts = {}
  	for k, v in pairs(menu) do
  		opts[k] = {
  			type = v.type,
  			text = v.name,
  			desc = v.desc,
        list = v.list,
        callHandlerEveryUpdate = v.call,
  			event = v.event
  		}
  	end
  	TriggerEvent("theftvrp:menu:setkeytoopen", "interaction", 244)
  	TriggerEvent("theftvrp:menu:setifusercanopenit", "interaction", true)
  	TriggerEvent("theftvrp:menu:setifusercancloseit", "interaction", true)
  	TriggerEvent("theftvrp:menu:setifcamcanmove", "interaction", true, false)
  	TriggerEvent("theftvrp:menu:gtaostyle", "interaction")
    TriggerEvent("theftvrp:menu:setmainlist", "interaction", "INTERACTION MENU", opts, 7)
end

local function GetPlayers()
    local players = {}
    for i = 0, 31 do
        if NetworkIsPlayerActive(i) then
            table.insert(players, i)
        end
    end
    return players
end

local function GetClosestPlayer()
  	local players = GetPlayers()
  	local closestDistance = -1
  	local closestPlayer = -1
  	local myPed = PlayerPedId()
  	local myPedCoords = GetEntityCoords(myPed, 0)
  	for k, v in ipairs(players) do
  		  if (GetPlayerPed(v) ~= myPed) then
  			    local targetCoords = GetEntityCoords(GetPlayerPed(v), 0)
  			    local distance = Vdist(targetCoords.x, targetCoords.y, targetCoords.z, myPedCoords.x, myPedCoords.y, myPedCoords.z)
      			if(closestDistance == -1 or closestDistance > distance) then
        				closestPlayer = v
        				closestDistance = distance
      			end
  		  end
  	end
  	return closestPlayer, closestDistance
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
-------------- MAIN --------------
AddEventHandler("airportwars:ampimenu:mainoption", function(opt, list)
    local ind = opt.data.index
    local item = menu[ind]
  	if item.id == 2 then
        local optsvehicle = {}
        for k, v in pairs(vehicle) do
            optsvehicle[k] = {
                type = v.type,
          			text = v.name,
          			desc = v.desc,
                list = v.list,
                callHandlerEveryUpdate = v.call,
          			event = v.event
            }
        end
        TriggerEvent("theftvrp:menu:setnextlist", "interaction", "VEHICLE", optsvehicle, 10)
  	elseif item.id == 3 then
    		--PROFILE
    elseif item.id == 4 then
        --STATS
  	elseif item.id == 5 then
        --MARKET
  	elseif item.id == 6 then
        --OPTIONS
  	elseif item.id == 7 then
        deathcontext = "DM_TK_KY1"
        issuicide = true
        TriggerEvent("theftvrp:menu:quit", "interaction")
        SetEntityHealth(PlayerPedId(), 0)
        TriggerServerEvent("airportwars:nm:playersuicide")
  	end
end)
----------------------------------

----------- QUICK GPS ------------
AddEventHandler("airportwars:ampimenu:quickgps", function(opt, list)
  	if opt.index == 1 then
        TriggerEvent("airportwars:objectives:setwaypoint")
  	elseif opt.index == 2 then
        if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
            SetNewWaypoint(SETTINGS.LOCATIONS.SPAWNS.PLAYERS.ZANCUDOTEAM[1], SETTINGS.LOCATIONS.SPAWNS.PLAYERS.ZANCUDOTEAM[2])
        elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
            SetNewWaypoint(SETTINGS.LOCATIONS.SPAWNS.PLAYERS.AIRPORTTEAM[1], SETTINGS.LOCATIONS.SPAWNS.PLAYERS.AIRPORTTEAM[2])
        end
    elseif opt.index == 3 then
        if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
            SetNewWaypoint(SETTINGS.LOCATIONS.SHOPS.ZANCUDO.WEAPONS[1][1], SETTINGS.LOCATIONS.SHOPS.ZANCUDO.WEAPONS[1][2])
        elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
            SetNewWaypoint(SETTINGS.LOCATIONS.SHOPS.AIRPORT.WEAPONS[1][1], SETTINGS.LOCATIONS.SHOPS.AIRPORT.WEAPONS[1][2])
        end
    elseif opt.index == 4 then
        if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
            SetNewWaypoint(SETTINGS.LOCATIONS.SHOPS.ZANCUDO.VEHICLES[1][1], SETTINGS.LOCATIONS.SHOPS.ZANCUDO.VEHICLES[1][2])
        elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
            SetNewWaypoint(SETTINGS.LOCATIONS.SHOPS.AIRPORT.VEHICLES[1][1], SETTINGS.LOCATIONS.SHOPS.AIRPORT.VEHICLES[1][2])
        end
    elseif opt.index == 5 then
        if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
            SetNewWaypoint(SETTINGS.LOCATIONS.SHOPS.ZANCUDO.SKINS[1][1], SETTINGS.LOCATIONS.SHOPS.ZANCUDO.SKINS[1][2])
        elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
            SetNewWaypoint(SETTINGS.LOCATIONS.SHOPS.AIRPORT.SKINS[1][1], SETTINGS.LOCATIONS.SHOPS.AIRPORT.SKINS[1][2])
        end
  	end
    TriggerEvent("theftvrp:menu:quit", "interaction")
end)
----------------------------------

------------ VEHICLES ------------
AddEventHandler("airportwars:ampimenu:vehicle", function(opt, list)
    local ind = opt.data.index
    local item = vehicle[ind]
  	if item.id == 1 then
  		  currentvehicle = GetVehiclePedIsUsing(PlayerPedId())
  		  --Blipcurrentvehicle = AddBlipForEntity(currentvehicle)
  			--SetBlipColour(Blipcurrentvehicle, 0)
  			--SetBlipDisplay(Blipcurrentvehicle, 4)
  			--SetBlipSprite(Blipcurrentvehicle, 225)
  			--BeginTextCommandSetBlipName("STRING")
  			--AddTextComponentString("Personal vehicle")
  			--EndTextCommandSetBlipName(Blipcurrentvehicle)
  	elseif item.id == 2 then
  		  currentvehicle = nil
  		  --if DoesBlipExist(Blipcurrentvehicle) then
  			--    RemoveBlip(Blipcurrentvehicle)
  		  --end
  	end
end)

AddEventHandler("airportwars:ampimenu:secondvehicle", function(opt, list)
    if (currentvehicle ~= nil) then
      	if opt.index == 1 then
        		doorsclosed = not doorsclosed
        		if (doorsclosed) then
                SetVehicleDoorOpen(currentvehicle, 0, false, false)
          			SetVehicleDoorOpen(currentvehicle, 1, false, false)
          			SetVehicleDoorOpen(currentvehicle, 2, false, false)
          			SetVehicleDoorOpen(currentvehicle, 3, false, false)
          			SetVehicleDoorOpen(currentvehicle, 4, false, false)
          			SetVehicleDoorOpen(currentvehicle, 5, false, false)
          			SetVehicleDoorOpen(currentvehicle, 6, false, false)
                SetVehicleDoorOpen(currentvehicle, 7, false, false)
        		else
                SetVehicleDoorShut(currentvehicle, 0, false)
          			SetVehicleDoorShut(currentvehicle, 1, false)
          			SetVehicleDoorShut(currentvehicle, 2, false)
          			SetVehicleDoorShut(currentvehicle, 3, false)
          			SetVehicleDoorShut(currentvehicle, 4, false)
          			SetVehicleDoorShut(currentvehicle, 5, false)
          			SetVehicleDoorShut(currentvehicle, 6, false)
                SetVehicleDoorShut(currentvehicle, 7, false)
        		end
      	elseif opt.index == 2 then
        		local angle = GetVehicleDoorAngleRatio(currentvehicle, 0)
        		if (angle == 0) then
        			SetVehicleDoorOpen(currentvehicle, 0, false, false)
        		else
        			SetVehicleDoorShut(currentvehicle, 0, false)
        		end
      	elseif opt.index == 3 then
        		local angle = GetVehicleDoorAngleRatio(currentvehicle, 1)
        		if (angle == 0) then
        			SetVehicleDoorOpen(currentvehicle, 1, false, false)
        		else
        			SetVehicleDoorShut(currentvehicle, 1, false)
        		end
      	elseif opt.index == 4 then
        		local angle = GetVehicleDoorAngleRatio(currentvehicle, 2)
        		if (angle == 0) then
        			SetVehicleDoorOpen(currentvehicle, 2, false, false)
        		else
        			SetVehicleDoorShut(currentvehicle, 2, false)
        		end
      	elseif opt.index == 5 then
        		local angle = GetVehicleDoorAngleRatio(currentvehicle, 3)
        		if (angle == 0) then
        			SetVehicleDoorOpen(currentvehicle, 3, false, false)
        		else
        			SetVehicleDoorShut(currentvehicle, 3, false)
        		end
      	elseif opt.index == 6 then
        		local angle = GetVehicleDoorAngleRatio(currentvehicle, 4)
        		if (angle == 0) then
        			SetVehicleDoorOpen(currentvehicle, 4, false, false)
        		else
        			SetVehicleDoorShut(currentvehicle, 4, false)
        		end
      	elseif opt.index == 7 then
        		local angle = GetVehicleDoorAngleRatio(currentvehicle, 5)
        		if (angle == 0) then
        			SetVehicleDoorOpen(currentvehicle, 5, false, false)
        		else
        			SetVehicleDoorShut(currentvehicle, 5, false)
        		end
      	end
    end
end)

AddEventHandler("airportwars:ampimenu:thirdvehicle", function(opt, list)
  	local vehicle = GetVehiclePedIsUsing(PlayerPedId())
  	if opt.index == 1 then
  		  SetEntityMaxSpeed(vehicle, GetVehicleModelMaxSpeed(GetEntityModel(vehicle)))
  	elseif opt.index == 2 then
    		if GetVehicleModelMaxSpeed(GetEntityModel(vehicle)) > 19.44 then
    			  SetEntityMaxSpeed(vehicle, 19.44)
        else
            SetEntityMaxSpeed(vehicle, GetVehicleModelMaxSpeed(GetEntityModel(vehicle)))
    		end
  	elseif opt.index == 3 then
    		if GetVehicleModelMaxSpeed(GetEntityModel(vehicle)) > 25.00 then
    			  SetEntityMaxSpeed(vehicle, 25.00)
        else
            SetEntityMaxSpeed(vehicle, GetVehicleModelMaxSpeed(GetEntityModel(vehicle)))
    		end
  	elseif opt.index == 4 then
    		if GetVehicleModelMaxSpeed(GetEntityModel(vehicle)) > 30.55 then
    			  SetEntityMaxSpeed(vehicle, 30.55)
        else
            SetEntityMaxSpeed(vehicle, GetVehicleModelMaxSpeed(GetEntityModel(vehicle)))
    		end
  	elseif opt.index == 5 then
    		if GetVehicleModelMaxSpeed(GetEntityModel(vehicle)) > 36.11 then
    			  SetEntityMaxSpeed(vehicle, 36.11)
        else
            SetEntityMaxSpeed(vehicle, GetVehicleModelMaxSpeed(GetEntityModel(vehicle)))
    		end
  	elseif opt.index == 6 then
    		if GetVehicleModelMaxSpeed(GetEntityModel(vehicle)) > 41.66 then
    			  SetEntityMaxSpeed(vehicle, 41.66)
        else
            SetEntityMaxSpeed(vehicle, GetVehicleModelMaxSpeed(GetEntityModel(vehicle)))
    		end
  	elseif opt.index == 7 then
    		if GetVehicleModelMaxSpeed(GetEntityModel(vehicle)) > 49.16 then
    			  SetEntityMaxSpeed(vehicle, 49.16)
        else
            SetEntityMaxSpeed(vehicle, GetVehicleModelMaxSpeed(GetEntityModel(vehicle)))
    		end
  	elseif opt.index == 8 then
    		if GetVehicleModelMaxSpeed(GetEntityModel(vehicle)) > 55.55 then
    			  SetEntityMaxSpeed(vehicle, 55.55)
        else
            SetEntityMaxSpeed(vehicle, GetVehicleModelMaxSpeed(GetEntityModel(vehicle)))
    		end
  	end
end)

AddEventHandler("airportwars:ampimenu:fourthvehicle", function(opt, list)
    if (currentvehicle ~= nil) then
      	if opt.index == 1 then
      		  SetVehicleEngineOn(currentvehicle, 1, 1, 0)
      	elseif opt.index == 2 then
      		  SetVehicleEngineOn(currentvehicle, 0, 1, 0)
      	end
    end
end)

AddEventHandler("airportwars:ampimenu:fifthvehicle", function(opt, list)
    if (currentvehicle ~= nil) then
      	if opt.index == 1 then
      		  SetVehicleDoorsLockedForAllPlayers(currentvehicle, false)
            SetVehicleDoorsLockedForTeam(currentvehicle, 1, false)
            SetVehicleDoorsLockedForTeam(currentvehicle, 2, false)
      	elseif opt.index == 2 then
            if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
      		      SetVehicleDoorsLockedForTeam(currentvehicle, 2, true)
                SetVehicleDoorsLockedForTeam(currentvehicle, 1, false)
            elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
                SetVehicleDoorsLockedForTeam(currentvehicle, 1, true)
                SetVehicleDoorsLockedForTeam(currentvehicle, 2, false)
            end
        elseif opt.index == 3 then
      		  SetVehicleDoorsLockedForAllPlayers(currentvehicle, true)
      	end
    end
end)

AddEventHandler("airportwars:ampimenu:sixthvehicle", function(opt, list)
    if (currentvehicle ~= nil) then
      	if opt.index == 1 then
      		  SetVehRadioStation(currentvehicle, "OFF")
      	elseif opt.index == 2 then
      		  SetVehRadioStation(currentvehicle, "RADIO_01_CLASS_ROCK")
      	elseif opt.index == 3 then
      		  SetVehRadioStation(currentvehicle, "RADIO_02_POP")
      	elseif opt.index == 4 then
      		  SetVehRadioStation(currentvehicle, "RADIO_03_HIPHOP_NEW")
      	elseif opt.index == 5 then
      		  SetVehRadioStation(currentvehicle, "RADIO_04_PUNK")
      	elseif opt.index == 6 then
      		  SetVehRadioStation(currentvehicle, "RADIO_05_TALK_01")
      	elseif opt.index == 7 then
      		  SetVehRadioStation(currentvehicle, "RADIO_06_COUNTRY")
      	elseif opt.index == 8 then
      		  SetVehRadioStation(currentvehicle, "RADIO_07_DANCE_01")
      	elseif opt.index == 9 then
      		  SetVehRadioStation(currentvehicle, "RADIO_08_MEXICAN")
      	elseif opt.index == 10 then
      		  SetVehRadioStation(currentvehicle, "RADIO_09_HIPHOP_OLD")
      	elseif opt.index == 11 then
      		  SetVehRadioStation(currentvehicle, "RADIO_12_REGGAE")
      	elseif opt.index == 12 then
      		  SetVehRadioStation(currentvehicle, "RADIO_13_JAZZ")
      	elseif opt.index == 13 then
      		  SetVehRadioStation(currentvehicle, "RADIO_14_DANCE_02")
      	elseif opt.index == 14 then
      		  SetVehRadioStation(currentvehicle, "RADIO_15_MOTOWN")
      	elseif opt.index == 15 then
      		  SetVehRadioStation(currentvehicle, "RADIO_20_THELAB")
      	elseif opt.index == 16 then
      		  SetVehRadioStation(currentvehicle, "RADIO_16_SILVERLAKE")
      	elseif opt.index == 17 then
      		  SetVehRadioStation(currentvehicle, "RADIO_17_FUNK")
      	elseif opt.index == 18 then
      		  SetVehRadioStation(currentvehicle, "RADIO_18_90S_ROCK")
      	end
    end
end)
-----------------------------
RegisterNetEvent("airportwars:ampimenu:start")
AddEventHandler("airportwars:ampimenu:start", function(pn)
    playername = pn
    if SETTINGS.FEATURES.PLAYER.ENABLE_INTERACTION_MENU then
        InteractionMenu()
    end
end)
---------------------------------------------------------------------------------------
ready.client_ampimenu = true
