---------------------------------------------------------
-- RESSOURCE : Noclip (SCA Module) - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Noclip addon for the SC Admin menu.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local noclip = false
local speeds = {0.05, 0.2, 0.8, 1.8, 3.6, 5.4}
local speeds_entries = {"Very Slow", "Slow", "Medium", "Fast", "Very Fast", "Extremely Fast"}
local speed = 3
local noclipcoords = {0.0, 0.0, 0.0}
local noclipheading = 0.0
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
local function NoClipState()
		return noclip
end

local function GetNoClipCoords()
		return noclipcoords
end

local function GetNoClipHeading()
		return noclipheading
end

local function SetNoClipCoords(coords)
		noclipcoords = coords
end

local function SetNoClipHeading(heading)
		noclipheading = heading
end

local function UpdateNoClipCoord(type, add, value)
		if (add) then
				if (type == "x") then
						noclipcoords = vector3(GetNoClipCoords().x + value , GetNoClipCoords().y, GetNoClipCoords().z)
				elseif (type == "y") then
						noclipcoords = vector3(GetNoClipCoords().x, GetNoClipCoords().y + value, GetNoClipCoords().z)
				elseif (type == "z") then
						noclipcoords = vector3(GetNoClipCoords().x, GetNoClipCoords().y, GetNoClipCoords().z + value)
				end
		else
				if (type == "x") then
						noclipcoords = vector3(GetNoClipCoords().x - value , GetNoClipCoords().y, GetNoClipCoords().z)
				elseif (type == "y") then
						noclipcoords = vector3(GetNoClipCoords().x, GetNoClipCoords().y - value, GetNoClipCoords().z)
				elseif (type == "z") then
						noclipcoords = vector3(GetNoClipCoords().x, GetNoClipCoords().y, GetNoClipCoords().z - value)
				end
		end
end

local function GetSpeedsAmount()
		return #speeds
end

local function GetSpeed()
		return speed
end

local function SetSpeed(newspeed)
		speed = newspeed
end

local function ToggleNoClip(toggle)
		if toggle then
				SetNoClipCoords(GetEntityCoords(PlayerPedId()))
				SetNoClipHeading(GetEntityHeading(PlayerPedId()))
				SetPlayerInvincible(NetworkPlayerIdToInt(), true)
		    SetEntityInvincible(PlayerPedId(), true)
				ClearPedTasksImmediately(PlayerPedId())
				if DoesAnimDictExist("amb@world_human_stand_impatient@male@no_sign@base") then
						RequestAnimDict("amb@world_human_stand_impatient@male@no_sign@base")
						while not HasAnimDictLoaded("amb@world_human_stand_impatient@male@no_sign@base") do
								Wait(0)
						end
						TaskPlayAnim(PlayerPedId(), "amb@world_human_stand_impatient@male@no_sign@base", "base", 8.0, 0.0, -1, 9, 0, 0, 0, 0)
				end
				PlaySoundFrontend(-1, "Hack_Success", "DLC_HEIST_BIOLAB_PREP_HACKING_SOUNDS", 1)
		else
				SetPlayerInvincible(NetworkPlayerIdToInt(), false)
		    SetEntityInvincible(PlayerPedId(), false)
				ClearPedTasksImmediately(PlayerPedId())
				if DoesAnimDictExist("amb@world_human_stand_impatient@male@no_sign@base") then
						RemoveAnimDict("amb@world_human_stand_impatient@male@no_sign@base")
				end
				PlaySoundFrontend(-1, "Hack_Failed", "DLC_HEIST_BIOLAB_PREP_HACKING_SOUNDS", 1)
		end
		noclip = toggle
end

function NoClip()
    CreateThread(function()
        while true do
            Wait(0)
            if IsControlJustPressed(0, 167) then
								ToggleNoClip(not NoClipState())
            end
            if NoClipState() then
								if IsEntityDead(PlayerPedId()) then
										ToggleNoClip(0)
								end
								TriggerEvent("airportwars:helptextfuture", "NOCLIP_HELPTEXT", false, -1, {speeds_entries[speed]})
								if IsControlJustPressed(0, 21) then
										if GetSpeed() < GetSpeedsAmount() then
												SetSpeed(GetSpeed() + 1)
										else
												SetSpeed(1)
										end
								end
								if IsControlPressed(0, 32) then
										UpdateNoClipCoord("x", true, speeds[speed] * math.sin(GetNoClipHeading() * 3.141592653589793 / 180) * -1.0)
										UpdateNoClipCoord("y", true, speeds[speed] * math.cos(GetNoClipHeading() * 3.141592653589793 / 180))
								end
								if IsControlPressed(0, 33) then
										UpdateNoClipCoord("x", false, speeds[speed] * math.sin(GetNoClipHeading() * 3.141592653589793 / 180) * -1.0)
										UpdateNoClipCoord("y", false, speeds[speed] * math.cos(GetNoClipHeading() * 3.141592653589793 / 180))
								end
								if IsControlPressed(0, 34) then
										SetNoClipHeading(GetNoClipHeading() + 2.5)
								end
								if IsControlPressed(0, 35) then
										SetNoClipHeading(GetNoClipHeading() - 2.5)
								end
								if IsControlPressed(0, 10) then
										UpdateNoClipCoord("z", true, speeds[speed] / 2)
								end
								if IsControlPressed(0, 11) then
										UpdateNoClipCoord("z", false, speeds[speed] / 2)
								end
								if not IsPedInAnyVehicle(PlayerPedId(), true) then
										SetEntityCoordsNoOffset(PlayerPedId(), GetNoClipCoords(), 1, 1, 1)
		                SetEntityHeading(PlayerPedId(), GetNoClipHeading())
								else
										SetEntityCoordsNoOffset(GetVehiclePedIsIn(PlayerPedId(), false), GetNoClipCoords(), 1, 1, 1)
										SetEntityHeading(GetVehiclePedIsIn(PlayerPedId(), false), GetNoClipHeading())
								end
            end
        end
    end)
end
---------------------------------------------------------------------------------------
