---------------------------------------------------------
-- RESSOURCE : Admin Menu - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Admin Menu for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local playerselected = -1
local menu = {
		{name="Get Players List", desc="Get a list of all active players.", type=0, event="airportwars:scadminmenu:mainoption", id=1},
    {name="Online Players", desc="Options to manage a player.", type=5, event="airportwars:scadminmenu:mainoption", id=2},
    {name="Network Options", desc="Options for all players.", type=5, event="airportwars:scadminmenu:mainoption", id=3},
    {name="Self Options", desc="Manage yourself.", type=5, event="airportwars:scadminmenu:mainoption", id=4},
    --{name="Vehicle Options", desc="Vehicle options.", type=0, event="airportwars:scadminmenu:mainoption", id=5},
    {name="Misc Options", desc="Other options.", type=5, event="airportwars:scadminmenu:mainoption", id=6}
}

local onlineplayer = {
    {name="Kill Player", desc="Kill the selected player.", type=0, event="airportwars:scadminmenu:onlineoption", id=1},
    {name="Spectate Player", desc="Spectate the selected player.", type=2, event="airportwars:scadminmenu:onlineoption", id=2},
    {name="Teleport to Player", desc="Teleport to the selected player.", type=0, event="airportwars:scadminmenu:onlineoption", id=3},
    {name="Kick Player", desc="Kick the selected player.", type=0, event="airportwars:scadminmenu:onlineoption", id=98},
    {name="Ban Player", desc="Ban the selected player.", type=0, event="airportwars:scadminmenu:onlineoption", id=99}
}

local networkoptions = {
		{name="Freeze Time", desc="Freeze or unfreeze time.", type=2, event="airportwars:scadminmenu:networkoption", id=1},
    {name="Time", desc="Change the time for all players.", type=4, call=false, list={"0.0", "1.0", "2.0", "3.0", "4.0", "5.0", "6.0", "7.0", "8.0", "9.0", "10.0", "11.0", "12.0", "13.0", "14.0", "15.0", "16.0", "17.0", "18.0", "19.0", "20.0", "21.0", "22.0", "23.0"}, event="airportwars:scadminmenu:networkoption", id=2},
    {name="Weather", desc="Change the weather for all players.", type=4, call=false, list={"EXTRASUNNY", "CLEAR", "NEUTRAL", "SMOG", "FOGGY", "OVERCAST", "CLOUDS", "CLEARING", "RAIN", "THUNDER", "SNOW", "BLIZZARD", "SNOWLIGHT", "XMAS", "HALLOWEEN"}, event="airportwars:scadminmenu:networkoption", id=3},
		{name="Drop a crate", desc="Trigger a crate drop on the map.", type=0, event="airportwars:scadminmenu:networkoption", id=4},
		{name="Drop a vehicle", desc="Trigger a vehicle drop on the map.", type=0, event="airportwars:scadminmenu:networkoption", id=5}
}

local selfoptions = {
    {name="Godmode", desc="Enable or disable Godmode.", type=2, event="airportwars:scadminmenu:selfoption", id=1},
    {name="Invisible", desc="Enable or disable Invisibility.", type=2, event="airportwars:scadminmenu:selfoption", id=2}
}

local miscoptions = {
    {name="Restart Objectives Script", desc="Restart the objectives script.", type=0, event="airportwars:scadminmenu:miscoption", id=1},
		{name="Patch Objectives HUD", desc="Patch the HUD for the objectives script.", type=0, event="airportwars:scadminmenu:miscoption", id=2}
}
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
function AdminMenu()
  	TriggerEvent("theftvrp:menu:create", "scadmin", "SC Admin", "SC ADMIN MANAGEMENT", true)
  	local opts = {}
  	for k, v in pairs(menu) do
	  		opts[k] = {
		  			type = v.type,
		  			text = v.name,
		  			desc = v.desc,
		        list = v.list,
		        callHandlerEveryUpdate = v.call,
		  			event = v.event
	  		}
  	end
  	TriggerEvent("theftvrp:menu:setkeytoopen", "scadmin", 166)
  	TriggerEvent("theftvrp:menu:setifusercanopenit", "scadmin", true)
  	TriggerEvent("theftvrp:menu:setifusercancloseit", "scadmin", true)
  	TriggerEvent("theftvrp:menu:setifcamcanmove", "scadmin", false, true)
		TriggerEvent("theftvrp:menu:setheaderbartextcolor", "scadmin", 255, 255, 255, 255)
		TriggerEvent("theftvrp:menu:spritecolor", "scadmin", {0, 0, 0, 225})
		TriggerEvent("theftvrp:menu:setheadertodosprite", "scadmin", false)
  	TriggerEvent("theftvrp:menu:scadminstyle", "scadmin")
    TriggerEvent("theftvrp:menu:setmaxelements", "scadmin", 10)
    TriggerEvent("theftvrp:menu:setmainlist", "scadmin", "SC ADMIN MANAGEMENT", opts, 7)
end

local function GetPlayersList()
		for i = 0, 32 do
				if NetworkIsPlayerActive(i) then
						SetNotificationTextEntry("STRING")
						AddTextComponentSubstringPlayerName("<C>"..tostring(i).." : "..NetworkPlayerGetName(i).."</C>")
						DrawNotification(0, 1)
				end
		end
		PlaySoundFrontend(-1, "Menu_Accept", "Phone_SoundSet_Default", 1)
end

local function SelectPlayer()
    DisplayOnscreenKeyboard(1, "FMMC_ENTER_PLAYERID", "", "", "", "", "", 2)
    while (UpdateOnscreenKeyboard() == 0) do
				Wait(0)
        DisableAllControlActions(0)
    end
    if GetOnscreenKeyboardResult() then
				if not GetOnscreenKeyboardResult() == "" or not (tostring(tonumber(GetOnscreenKeyboardResult())) ~= GetOnscreenKeyboardResult()) then
		        local result  = tonumber(GetOnscreenKeyboardResult())
						if NetworkIsPlayerActive(result) then
								playerselected = result
								local opts = {}
				        for k, v in pairs(onlineplayer) do
				            opts[k] = {
				                type = v.type,
				          			text = v.name,
				          			desc = v.desc,
				                list = v.list,
				                callHandlerEveryUpdate = v.call,
				          			event = v.event
				            }
				        end
				        TriggerEvent("theftvrp:menu:setnextlist", "scadmin", "PLAYER: "..string.upper(NetworkPlayerGetName(playerselected)), opts, 10)
						else
								TriggerEvent("airportwars:notify", "SCADMIN_BAD_ID", -1, {}, "CHAR_MP_FM_CONTACT", 0, "SC Admin", "Error", 0.5, true)
						end
        else
						TriggerEvent("airportwars:notify", "SCADMIN_BAD_ID", -1, {}, "CHAR_MP_FM_CONTACT", 0, "SC Admin", "Error", 0.5, true)
				end
    end
end

local function KillPlayer(player)
		SetEntityHealth(GetPlayerPed(player), 0)
end

local function SpectatePlayer(player, toggle)
		NetworkSetInSpectatorMode(toggle, GetPlayerPed(player))
end

local function TeleportToPlayer(player)
		SetEntityCoords(PlayerPedId(), GetEntityCoords(GetPlayerPed(player)) + 0.35, 0.0, 0.0, 0.0, false)
end

local function KickPlayer(player)
		DisplayOnscreenKeyboard(1, "SCADMIN_ENTER_KICKREASON", "", "", "", "", "", 255)
		while (UpdateOnscreenKeyboard() == 0) do
				Wait(0)
				DisableAllControlActions(0)
		end
		if GetOnscreenKeyboardResult() then
				local reason = GetOnscreenKeyboardResult()
				TriggerServerEvent("airportwars:scadmin:kickplayer", GetPlayerServerId(player), reason)
		end
end

local function BanPlayer(player)
		DisplayOnscreenKeyboard(1, "SCADMIN_ENTER_BANREASON", "", "", "", "", "", 255)
		while (UpdateOnscreenKeyboard() == 0) do
				Wait(0)
				DisableAllControlActions(0)
		end
		if GetOnscreenKeyboardResult() then
				local reason = GetOnscreenKeyboardResult()
				TriggerServerEvent("airportwars:scadmin:banplayer", GetPlayerServerId(player), reason)
		end
end

local function SelfOptions()
		local opts = {}
    for k, v in pairs(selfoptions) do
        opts[k] = {
            type = v.type,
      			text = v.name,
      			desc = v.desc,
            list = v.list,
            callHandlerEveryUpdate = v.call,
      			event = v.event
        }
    end
    TriggerEvent("theftvrp:menu:setnextlist", "scadmin", "SELF OPTIONS", opts, 10)
end

local function SetLocalPlayerInvincible(toggle)
		SetEntityInvincible(PlayerPedId(), toggle)
		SetPlayerInvincible(NetworkPlayerIdToInt(), toggle)
end

local function SetLocalPlayerInvisible(toggle)
		if (toggle) then
				SetEntityAlpha(PlayerPedId(), 0, 0)
		else
				SetEntityAlpha(PlayerPedId(), 255, 0)
		end
end

local function NetworkOptions()
		local opts = {}
    for k, v in pairs(networkoptions) do
        opts[k] = {
            type = v.type,
      			text = v.name,
      			desc = v.desc,
            list = v.list,
            callHandlerEveryUpdate = v.call,
      			event = v.event
        }
    end
    TriggerEvent("theftvrp:menu:setnextlist", "scadmin", "NETWORK OPTIONS", opts, 10)
end

local function NetworkSetFreezeTime(freeze)
		TriggerServerEvent("airportwars:scadmin:freezetime", freeze)
end

local function NetworkSetOverrideClockTime(time)
		TriggerServerEvent("airportwars:scadmin:overridetime", time)
end

local function NetworkSetOverrideWeather(weather)
		TriggerServerEvent("airportwars:scadmin:overrideweather", weather)
end

local function NetworkDropCrate()
		TriggerServerEvent("airportwars:scadmin:dropcrate")
end

local function NetworkDropVehicle()
		TriggerServerEvent("airportwars:scadmin:dropvehicle")
end

local function MiscOptions()
		local opts = {}
    for k, v in pairs(miscoptions) do
        opts[k] = {
            type = v.type,
      			text = v.name,
      			desc = v.desc,
            list = v.list,
            callHandlerEveryUpdate = v.call,
      			event = v.event
        }
    end
    TriggerEvent("theftvrp:menu:setnextlist", "scadmin", "MISC OPTIONS", opts, 10)
end

local function RestartObjectivesScript()
		TriggerServerEvent("airportwars:scadmin:restartobjectives")
end

local function PatchObjectivesHud()
		TriggerServerEvent("airportwars:scadmin:patchhudobjectives")
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
-------------- MAIN --------------
AddEventHandler("airportwars:scadmin:enablemenu", function()
    AdminMenu()
		NoClip()
end)

AddEventHandler("airportwars:scadminmenu:mainoption", function(opt, list)
    local ind = opt.data.index
    local item = menu[ind]
  	if item.id == 1 then
				GetPlayersList()
  	elseif item.id == 2 then
				SelectPlayer()
  	elseif item.id == 3 then
				NetworkOptions()
  	elseif item.id == 4 then
				SelfOptions()
  	elseif item.id == 5 then

  	elseif item.id == 6 then
				MiscOptions()
  	end
end)

AddEventHandler("airportwars:scadminmenu:onlineoption", function(opt, list)
    local ind = opt.data.index
    local item = onlineplayer[ind]
  	if item.id == 1 then
				KillPlayer(playerselected)
  	elseif item.id == 2 then
				SpectatePlayer(playerselected, opt.value)
  	elseif item.id == 3 then
				TeleportToPlayer(playerselected)
  	elseif item.id == 4 then

  	elseif item.id == 5 then

  	elseif item.id == 98 then
				KickPlayer(playerselected)
  	elseif item.id == 99 then
				BanPlayer(playerselected)
  	end
end)

AddEventHandler("airportwars:scadminmenu:networkoption", function(opt, list)
    local ind = opt.data.index
    local item = networkoptions[ind]
		if item.id == 1 then
				NetworkSetFreezeTime(opt.value)
		elseif item.id == 2 then
				NetworkSetOverrideClockTime(math.ceil(tonumber(opt.options[opt.index])))
  	elseif item.id == 3 then
				NetworkSetOverrideWeather(opt.options[opt.index])
		elseif item.id == 4 then
				NetworkDropCrate()
		elseif item.id == 5 then
				NetworkDropVehicle()
  	end
end)

AddEventHandler("airportwars:scadminmenu:selfoption", function(opt, list)
    local ind = opt.data.index
    local item = selfoptions[ind]
  	if item.id == 1 then
				SetLocalPlayerInvincible(opt.value)
  	elseif item.id == 2 then
				SetLocalPlayerInvisible(opt.value)
  	end
end)

AddEventHandler("airportwars:scadminmenu:miscoption", function(opt, list)
    local ind = opt.data.index
    local item = miscoptions[ind]
  	if item.id == 1 then
				RestartObjectivesScript()
		elseif item.id == 2 then
				PatchObjectivesHud()
  	end
end)
----------------------------------
---------------------------------------------------------------------------------------
