iFruit = {
		Scaleform = -1,
		CurrentMenu = 1,
		CurrentSelection = 1,
		Opened = false,
		IsPhoneAboutToGetOpened = false,
		IsPhoneAboutToGetClosed = false,
		Settings = {
				mobile = 0,
				scaleform = "cellphone_ifruit",
				soundset = "Phone_SoundSet_Default",
				theme = 1,
				background = 13,
				scale = 500.0,
				position = vector3(99.62, -114.305, -113.0),
				rotation = vector3(-90.0, 0.0, 0.0)
		},
		Initialize = function(self)
				self.Functions.PatchPhoneInfos(self)
				DestroyMobilePhone()
				CreateMobilePhone(self.Settings.mobile)
				SetMobilePhoneScale(self.Settings.scale)
				SetMobilePhonePosition(self.Settings.position)
				SetMobilePhoneRotation(self.Settings.rotation, 0)
				self.Scaleform = RequestScaleformMovie(self.Settings.scaleform)
				while not HasScaleformMovieLoaded(self.Scaleform) do
						Wait(0)
				end
				for k, v in pairs(self.Menus[1].Options) do
						self.Menus[1].AddApp(self, v.index, v.icon, v.label)
				end
				for k, v in pairs(self.Menus[22].Options) do
						self.Menus[22].AddSetting(self, v.index, v.icon, v.label)
				end
				SetTimeout(500, function()
						self.Functions.SetPhoneMenu(self, self.CurrentMenu)
				end)
		end,
		Menus = {
				[1] = {
						Header = "iFruit",
						WriteHeader = false,
						ScrollMethod = 1,
						Options = {
								{index = 0, icon = 4, label = "Email"},
								{index = 1, icon = 2, label = "SMS"},
								{index = 2, icon = 5, label = "Contacts"},
								{index = 3, icon = 1, label = "Snapmatic"},
								{index = 4, icon = 6, label = "Internet"},
								{index = 5, icon = 24, label = "Settings"}
						},
						AddApp = function(self, index, icon, label)
								BeginScaleformMovieMethod(self.Scaleform, "SET_DATA_SLOT")
								PushScaleformMovieFunctionParameterInt(1)
								PushScaleformMovieFunctionParameterInt(index)
								PushScaleformMovieFunctionParameterInt(icon)
								PushScaleformMovieFunctionParameterInt(0)
								PushScaleformMovieFunctionParameterString(label)
								PushScaleformMovieFunctionParameterInt(255)
								EndScaleformMovieMethod()
						end
				},
				[22] = {
						Header = "Settings",
						WriteHeader = true,
						ScrollMethod = 2,
						Options = {
								{index = 0, icon = 23, label = "Background"},
								{index = 1, icon = 25, label = "Profile"},
								{index = 2, icon = 23, label = "Theme"}
						},
						AddSetting = function(self, index, icon, label)
								BeginScaleformMovieMethod(self.Scaleform, "SET_DATA_SLOT")
								PushScaleformMovieFunctionParameterInt(22)
								PushScaleformMovieFunctionParameterInt(index)
								PushScaleformMovieFunctionParameterInt(icon)
								PushScaleformMovieFunctionParameterString(label)
								PushScaleformMovieFunctionParameterInt(255)
								EndScaleformMovieMethod()
						end
				},
		},
		Functions = {
				PatchPhoneInfos = function(self)
						if (self.Settings.mobile == 0) then
								self.Settings.scaleform = "cellphone_ifruit"
								self.Settings.soundset = "Phone_SoundSet_Michael"
						elseif (self.Settings.mobile == 1) then
								self.Settings.scaleform = "cellphone_facade"
								self.Settings.soundset = "Phone_SoundSet_Trevor"
						elseif (self.Settings.mobile == 2) then
								self.Settings.scaleform = "cellphone_badger"
								self.Settings.soundset = "Phone_SoundSet_Franklin"
						elseif (self.Settings.mobile == 4) then
								self.Settings.scaleform = "cellphone_prologue"
								self.Settings.soundset = "Phone_SoundSet_Prologue"
						end
				end,
				UsePhone = function(self)
						if not self.IsPhoneAboutToGetOpened and not self.IsPhoneAboutToGetClosed and not IsPauseMenuActive() and not IsSystemUiBeingDisplayed() and not IsWarningMessageActive() and not NetworkIsTextChatActive() and not IsPlayerSwitchInProgress() and not IsAnyMenuOpened() and not IsPlayerDead(NetworkPlayerIdToInt()) and not IsPlayerInIntroduction() then
								if (self.Opened) then
										self.IsPhoneAboutToGetClosed = true
										SetPedConfigFlag(PlayerPedId(), 244, true)
										SetPedConfigFlag(PlayerPedId(), 243, true)
										SetPedConfigFlag(PlayerPedId(), 242, true)
										Citizen.InvokeNative(0xBD2A8EC3AF4DE7DB, PlayerPedId(), 0, 1)
										PlaySoundFrontend(-1, "Pull_Out", self.Settings.soundset, true)
										while GetMobilePhonePosition().y > -114.305 do
												Wait(0)
												SetMobilePhonePosition(GetMobilePhonePosition().x, GetMobilePhonePosition().y-0.14*2*15, GetMobilePhonePosition().z)
										end
										self.Opened = false
								else
										self.IsPhoneAboutToGetOpened = true
										SetPedConfigFlag(PlayerPedId(), 244, false)
										SetPedConfigFlag(PlayerPedId(), 243, false)
										SetPedConfigFlag(PlayerPedId(), 242, false)
										Citizen.InvokeNative(0xBD2A8EC3AF4DE7DB, PlayerPedId(), 1, 1)
										PlaySoundFrontend(-1, "Hang_Up", self.Settings.soundset, true)
										while GetMobilePhonePosition().y < -52.305 do
												Wait(0)
												SetMobilePhonePosition(GetMobilePhonePosition().x, GetMobilePhonePosition().y+0.14*2*15, GetMobilePhonePosition().z)
										end
										self.Opened = true
								end
								self.IsPhoneAboutToGetClosed = false
								self.IsPhoneAboutToGetOpened = false
						end
				end,
				PhoneAction = function(self, method)
						if (method == "select") then
								PlaySoundFrontend(-1, "Menu_Accept", self.Settings.soundset, true)
								TriggerEvent("airportwars:notify", "STRING", -1, {"Cellphone features will be available soon."}, "CHAR_MP_FM_CONTACT", 0, "iFruit", "", 0.45, true)
						elseif (method == "cancel") then
								PlaySoundFrontend(-1, "Put_Away", self.Settings.soundset, true)
						end
						MoveFinger(5)
				end,
				PhoneNavigate = function(self, method)
						local direction = 0
						if (method == "up") then
								direction = 1
								MoveFinger(1)
						elseif (method == "down") then
								direction = 3
								MoveFinger(2)
						elseif (method == "left") then
								direction = 4
								MoveFinger(3)
						elseif (method == "right") then
								direction = 2
								MoveFinger(4)
						end
						PlaySoundFrontend(-1, "Menu_Navigate", self.Settings.soundset, true)
						BeginScaleformMovieMethod(self.Scaleform, "SET_INPUT_EVENT")
						PushScaleformMovieFunctionParameterInt(direction)
						EndScaleformMovieMethod()
				end,
				CheckInputsThisFrame = function(self)
						if (self.Opened) then
								if IsControlJustPressed(2, 181) then
										if (self.Menus[self.CurrentMenu].ScrollMethod == 1) then
												if self.CurrentSelection == 0 then
														self.Functions.PhoneNavigate(self, "down")
														self.Functions.PhoneNavigate(self, "down")
														self.Functions.PhoneNavigate(self, "left")
												elseif self.CurrentSelection == 1 then
														self.Functions.PhoneNavigate(self, "left")
												elseif self.CurrentSelection == 2 then
														self.Functions.PhoneNavigate(self, "left")
												elseif self.CurrentSelection == 3 then
														self.Functions.PhoneNavigate(self, "left")
														self.Functions.PhoneNavigate(self, "up")
												elseif self.CurrentSelection == 4 then
														self.Functions.PhoneNavigate(self, "left")
												elseif self.CurrentSelection == 5 then
														self.Functions.PhoneNavigate(self, "left")
												elseif self.CurrentSelection == 6 then
														self.Functions.PhoneNavigate(self, "left")
														self.Functions.PhoneNavigate(self, "up")
												elseif self.CurrentSelection == 7 then
														self.Functions.PhoneNavigate(self, "left")
												elseif self.CurrentSelection == 8 then
														self.Functions.PhoneNavigate(self, "left")
												end
										else
												self.Functions.PhoneNavigate(self, "up")
										end
								end
								if IsControlJustPressed(2, 180) then
										if (self.Menus[self.CurrentMenu].ScrollMethod == 1) then
												if not (self.CurrentSelection == #self.Menus[self.CurrentMenu].Options-1) then
														if self.CurrentSelection == 0 then
																self.Functions.PhoneNavigate(self, "right")
														elseif self.CurrentSelection == 1 then
																self.Functions.PhoneNavigate(self, "right")
														elseif self.CurrentSelection == 2 then
																self.Functions.PhoneNavigate(self, "right")
																self.Functions.PhoneNavigate(self, "down")
														elseif self.CurrentSelection == 3 then
																self.Functions.PhoneNavigate(self, "right")
														elseif self.CurrentSelection == 4 then
																self.Functions.PhoneNavigate(self, "right")
														elseif self.CurrentSelection == 5 then
																self.Functions.PhoneNavigate(self, "right")
																self.Functions.PhoneNavigate(self, "down")
														elseif self.CurrentSelection == 6 then
																self.Functions.PhoneNavigate(self, "right")
														elseif self.CurrentSelection == 7 then
																self.Functions.PhoneNavigate(self, "right")
														elseif self.CurrentSelection == 8 then
																self.Functions.PhoneNavigate(self, "right")
																self.Functions.PhoneNavigate(self, "up")
																self.Functions.PhoneNavigate(self, "up")
														end
												else
														if self.CurrentSelection == 5 then
																self.Functions.PhoneNavigate(self, "right")
																self.Functions.PhoneNavigate(self, "up")
														elseif self.CurrentSelection == 8 then
																self.Functions.PhoneNavigate(self, "right")
																self.Functions.PhoneNavigate(self, "up")
																self.Functions.PhoneNavigate(self, "up")
														end
												end
										else
												self.Functions.PhoneNavigate(self, "down")
										end
								end
								if IsControlJustPressed(2, 172) then
										self.Functions.PhoneNavigate(self, "up")
								end
								if IsControlJustPressed(2, 173) then
										self.Functions.PhoneNavigate(self, "down")
								end
								if IsControlJustPressed(2, 174) then
										self.Functions.PhoneNavigate(self, "left")
								end
								if IsControlJustPressed(2, 175) then
										self.Functions.PhoneNavigate(self, "right")
								end
						end
				end,
				DisableInputsAndHudThisFrame = function(self)
						if (IsInputDisabled(2)) then
								SetInputExclusive(2, 237)
								SetInputExclusive(2, 238)
								SetInputExclusive(2, 241)
								SetInputExclusive(2, 242)
								SetInputExclusive(2, 239)
								SetInputExclusive(2, 240)
								SetInputExclusive(2, 172)
								SetInputExclusive(2, 173)
								SetInputExclusive(2, 174)
								SetInputExclusive(2, 175)
								EnableControlAction(2, 176, 1)
						else
								SetInputExclusive(2, 176)
								SetInputExclusive(2, 177)
								SetInputExclusive(2, 172)
								SetInputExclusive(2, 173)
								SetInputExclusive(2, 174)
								SetInputExclusive(2, 175)
						end
						DisableControlAction(0, 37, 1)
						DisableControlAction(0, 157, 1)
						DisableControlAction(0, 158, 1)
						DisableControlAction(0, 159, 1)
						DisableControlAction(0, 160, 1)
						DisableControlAction(0, 161, 1)
						DisableControlAction(0, 162, 1)
						DisableControlAction(0, 163, 1)
						DisableControlAction(0, 164, 1)
						DisableControlAction(0, 165, 1)
						DisableControlAction(0, 14, 1)
						DisableControlAction(0, 15, 1)
						DisableControlAction(0, 53, 1)
						DisableControlAction(0, 54, 1)
						DisableControlAction(0, 140, 1)
						DisableControlAction(0, 141, 1)
						DisableControlAction(0, 143, 1)
						DisableControlAction(0, 47, 1)
						DisableControlAction(0, 74, 1)
						DisableControlAction(0, 85, 1)
						DisableControlAction(0, 73, 1)
						DisableControlAction(0, 51, 1)
						DisableControlAction(0, 45, 1)
						DisableControlAction(0, 55, 1)
						DisableControlAction(0, 80, 1)
						DisableControlAction(0, 25, 1)
						DisableControlAction(0, 24, 1)
						DisableControlAction(0, 257, 1)
						DisableControlAction(0, 56, 1)
						DisableControlAction(0, 68, 1)
						DisableControlAction(0, 69, 1)
						DisableControlAction(0, 70, 1)
						DisableControlAction(0, 91, 1)
						DisableControlAction(0, 92, 1)
						DisableControlAction(2, 199, 1)
						DisableControlAction(2, 189, 1)
						DisableControlAction(2, 190, 1)
						DisableControlAction(2, 187, 1)
						EnableControlAction(0, 1, 1)
						EnableControlAction(0, 2, 1)
						EnableControlAction(2, 180, 1)
						EnableControlAction(2, 181, 1)
						HideHudComponentThisFrame(6)
						HideHudComponentThisFrame(7)
						HideHudComponentThisFrame(9)
						HideHudComponentThisFrame(8)
				end,
				GetCurrentTimeForiFruit = function()
						local minutes = GetClockMinutes()
						local hours = GetClockHours()
						local day = GetClockDayOfWeek()
						local daystring = ""
						if (day == 0) then
								daystring = "CELL_920"
						elseif (day == 1) then
								daystring = "CELL_921"
						elseif (day == 2) then
								daystring = "CELL_922"
						elseif (day == 3) then
								daystring = "CELL_923"
						elseif (day == 4) then
								daystring = "CELL_924"
						elseif (day == 5) then
								daystring = "CELL_925"
						elseif (day == 6) then
								daystring = "CELL_926"
						else
								daystring = "CELL_206"
						end
						return minutes, hours, daystring
				end,
				UpdatePhoneHeaderThisFrame = function(self)
						local minutes, hours, day = self.Functions.GetCurrentTimeForiFruit()
						BeginScaleformMovieMethod(self.Scaleform, "SET_TITLEBAR_TIME")
						PushScaleformMovieFunctionParameterInt(hours)
						PushScaleformMovieFunctionParameterInt(minutes)
						BeginTextCommandScaleformString(day)
						EndTextCommandScaleformString()
						EndScaleformMovieMethod()
						BeginScaleformMovieMethod(self.Scaleform, "SET_PROVIDER_ICON")
						PushScaleformMovieFunctionParameterInt(1)
						PushScaleformMovieFunctionParameterInt(GetZoneScumminess(GetZoneAtCoords(GetEntityCoords(PlayerPedId(), 1))))
						EndScaleformMovieMethod()
				end,
				SetHeaderTitleThisFrame = function(self)
						if (self.Menus[self.CurrentMenu].WriteHeader) then
								BeginScaleformMovieMethod(self.Scaleform, "SET_HEADER")
								PushScaleformMovieFunctionParameterString(self.Menus[self.CurrentMenu].Header)
								EndScaleformMovieMethod()
						end
				end,
				SetThemeThisFrame = function(self)
						BeginScaleformMovieMethod(self.Scaleform, "SET_THEME")
						PushScaleformMovieFunctionParameterInt(self.Settings.theme)
						EndScaleformMovieMethod()
				end,
				SetBackgroundImageThisFrame = function(self)
						BeginScaleformMovieMethod(self.Scaleform, "SET_BACKGROUND_IMAGE")
						PushScaleformMovieFunctionParameterInt(self.Settings.background)
						PushScaleformMovieFunctionParameterBool(false)
						EndScaleformMovieMethod()
				end,
				SetPhoneMenu = function(self, menu)
						BeginScaleformMovieMethod(self.Scaleform, "DISPLAY_VIEW")
						PushScaleformMovieFunctionParameterInt(menu)
						EndScaleformMovieMethod()
				end,
				GetCurrentSelection = function(self)
						BeginScaleformMovieMethod(self.Scaleform, "GET_CURRENT_SELECTION")
						local result = EndScaleformMovieMethodReturn()
						while not (GetScaleformMovieFunctionReturnBool(result)) do
								Wait(0)
						end
						self.CurrentSelection = GetScaleformMovieFunctionReturnInt(result)
				end,
				DrawCellphone = function(self)
						DrawScaleformMovie(self.Scaleform, 0.1, 0.179, 0.2, 0.356, 255, 255, 255, 255, 0)
				end,
				GoToMenu = function(self, menuid)
						self.CurrentMenu = menuid
						self.Functions.SetPhoneMenu(self, self.CurrentMenu)
				end
		}
}

local function Cellphone()
  	SetTextRenderId(GetMobilePhoneRenderId())
    iFruit.Functions.UpdatePhoneHeaderThisFrame(iFruit)
		iFruit.Functions.SetHeaderTitleThisFrame(iFruit)
    iFruit.Functions.SetBackgroundImageThisFrame(iFruit)
    iFruit.Functions.SetThemeThisFrame(iFruit)
		iFruit.Functions.CheckInputsThisFrame(iFruit)
		iFruit.Functions.DisableInputsAndHudThisFrame(iFruit)
  	iFruit.Functions.DrawCellphone(iFruit)
    SetTextRenderId(GetDefaultScriptRendertargetRenderId())
end

CreateThread(function()
		while not StartedPlaying do
				Wait(0)
		end
		while true do
				Wait(0)
				if IsControlJustPressed(0, 27) then
						--iFruit.Functions.UsePhone(iFruit)
				end
				if (iFruit.Opened) then
						if IsControlJustPressed(2, 176) or IsControlJustPressed(2, 237) then
								--iFruit.Functions.PhoneAction(iFruit, "select")
						end
						if IsControlJustPressed(2, 177) or IsControlJustPressed(2, 238) then
								--iFruit.Functions.PhoneAction(iFruit, "cancel")
								if (iFruit.CurrentMenu == 1) then
										--iFruit.Functions.UsePhone(iFruit)
								end
						end
				end
		end
end)

CreateThread(function()
		while not StartedPlaying do
				Wait(0)
		end
		--iFruit.Initialize(iFruit)
    while true do
        Wait(0)
				if (iFruit.Opened) or (iFruit.IsPhoneAboutToGetOpened) then
    	  		--Cellphone()
				end
    end
end)

CreateThread(function()
		while not StartedPlaying do
				Wait(0)
		end
		while true do
				Wait(0)
				if (iFruit.Opened) or (iFruit.IsPhoneAboutToGetOpened) then
						--iFruit.Functions.GetCurrentSelection(iFruit)
				end
		end
end)

--[[local function SetPhoneKeyThisFrame(buttonSpot, unk1, icon, unk3)
	PushPhoneData_2(iFruit.Scaleform, "SET_SOFT_KEYS", buttonSpot, unk1, icon, -1.0, -1.0, unk3, 0, 0, 0, 0)
end
SetPhoneKeyThisFrame(3, 1, 6, "CELL_202")
SetPhoneKeyThisFrame(2, 1, 3, "CELL_225")
SetPhoneKeyThisFrame(1, 1, 4, "CELL_206")]]
