---------------------------------------------------------
-- RESSOURCE : Events - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Events Management script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local TunablesUpdated = false
local AnyEventActive = false
local event_firstweeklaunch = {
    title = {"First week launch!"},
    infos = {
        title = "First week launch!",
        desc = "The first week launch of Airport Wars, thanks for playing! Double GTA$ and Score on everything.",
        tunables = {"CASH_MULTIPLIER", "SCORE_MULTIPLAYER"},
        tunablesvalues = {2.0, 2.0},
        stats = {"apw_firstweek_helptext"},
        statsvalues = {true}
    },
    date = {
        start = "APRIL 23 2018",
        finish = "APRIL 30 2018"
    },
    active = {
        value = true
    }
}
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
function IsAnyEventActive()
    return AnyEventActive
end

function UpdateTunablesEvents()
    exports["mysql"]:QueryResultAsync("SELECT * FROM apw_events", {}, function(result)
        for k, v in pairs(result) do
            if (json.decode(result[k].active).value) then
                AnyEventActive = true
                print('APW_EVENTS: The event "'..json.decode(result[k].title)[1]..'" is now active! Tunables updated for this event.')
                SetTimeout(1500, function()
                    TriggerEvent("airportwars:discord:message", "The special event **"..json.decode(result[k].title)[1].."** is now active! Double GTA$ & Score (April 23 - April 30 2018).", true)
                end)
                local tunables = json.decode(result[k].infos).tunables
                local tunablesvalues = json.decode(result[k].infos).tunablesvalues
                local newtunables = {}
                for k, v in pairs(tunables) do
                    newtunables[tunables[k]] = tunablesvalues[k]
                end
                TriggerEvent("airportwars:tunables:update", newtunables)
            end
        end
        TunablesUpdated = true
    end)
end

function CheckEventsStats(source)
    while not TunablesUpdated do
        Wait(0)
    end
    exports["mysql"]:QueryResultAsync("SELECT * FROM apw_events", {}, function(result)
        if (json.decode(result[1].active).value) then
            local stats = json.decode(result[1].infos).stats
            local statsvalues = json.decode(result[1].infos).statsvalues
            TriggerEvent("airportwars:events:triggerstats", source, stats, statsvalues)
        end
    end)
end

function CreateEvent(title, infos, date, active)
    exports["mysql"]:QueryAsync("INSERT INTO apw_events (title, infos, date, active) VALUES (@title, @infos, @date, @active)", {['@title'] = json.encode(title), ['@infos'] = json.encode(infos), ['@date'] = json.encode(date), ['@active'] = json.encode(active)})
end
---------------------------------------------------------------------------------------

-------------------------------------- EVENTS -----------------------------------------
AddEventHandler("airportwars:events:updatetunables", function(newlist)
    UpdateTunablesEvents()
end)

AddEventHandler("airportwars:events:checkstats", function(source)
    CheckEventsStats(source)
end)

AddEventHandler("airportwars:events:triggerstats", function(source, stats, statsvalues)
    TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
        for k, v in pairs(stats) do
            if (v == "apw_firstweek_helptext") then
                local done = (statsvalues[k] == Network.GetStatFromString("APW_FIRSTWEEK_HELPTEXT"))
                if not done then
                    TriggerClientEvent("airportwars:events:triggerstat", source, 1)
                end
            end
        end
    end)
end)

RegisterServerEvent("airportwars:events:stateventdone")
AddEventHandler("airportwars:events:stateventdone", function(stat)
    TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
        Network.SetStat(stat, true)
    end)
end)
---------------------------------------------------------------------------------------

--[[CreateThread(function()
    CreateEvent(event_firstweeklaunch.title, event_firstweeklaunch.infos, event_firstweeklaunch.date, event_firstweeklaunch.active)
end)]]
