---------------------------------------------------------
-- RESSOURCE : Introduction - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Introduction script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
havetopassintro = nil
local isinintroduction = false
local introstep = 0
local timer = 0
local inputgroups = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31}
local infos = {
    "Welcome to Airport Wars, a neverending fight between two airports.",
    "Steal the enemy's plane in order to gain score and money for you and your team.",
    "Protect your base from intruders who want to steal your plane.",
    "Rare military vehicles will spawn randomly, check the map when they do, to acquire it!",
    "A titan is kept at the abandoned airport base, gather your team for an epic drop on the enemy",
    "The team with the better equipment, vehicles, and strategy will win more and gain more cash flow.",
    "To purchase permanent arms, go to ~y~dashboard.airportwars.com~w~ and visit the Arms Market.",
    "Join the Discord, remember to report any cheaters and feel free to publish ideas."
}
local tips = {
  	"Remember to press ~INPUT_MULTIPLAYER_INFO~ to see the scoreboard.",
    "Send messages to global chat using ~INPUT_MP_TEXT_CHAT_ALL~",
  	"Talk to your team members using ~INPUT_MP_TEXT_CHAT_TEAM~",
    "Voice chat is enabled, make sure to communicate with your team!",
  	"Purchase permanent weapons for your character on the Arms Market at ~y~dashboard.airportwars.com",
  	"Report all cheaters or abusers in the Discord! ~y~discord.io/airportwars",
    "Stealing the enemy plane grants you $10,000 and money for your entire team!",
    "Random crates and military vehicles will drop throughout the game.",
    "Killing enemies grants you money, but make sure you focus on the objective!",
    "Team killing, spawn killing, and base vehicle destroying is bannable.",
  	"Link your Discord to your game account at ~y~airportwars.com~w~ to get $3,000 and join the Cool Cat Club!"
}
---------------------------------------------------------------------------------------
function IsPlayerInIntroduction()
    return isinintroduction
end

function TriggerIntroduction()
    CreateThread(function()
        local introcam
        SetEntityVisible(PlayerPedId(), false, 0)
        SetEntityInvincible(PlayerPedId(), true)
        SetEntityCoords(PlayerPedId(), 925.329, 46.152, 80.908)
        SetEntityCollision(PlayerPedId(), false)
        FreezeEntityPosition(PlayerPedId(), true)
        TriggerEvent("airportwars:weather:updatepermissions", true)
        PrepareMusicEvent("FM_INTRO_START")
        Wait(2000)
        SetOverrideWeather("EXTRASUNNY")
        NetworkOverrideClockTime(19, 0, 0)
        BeginSrl()
        introstep = 1
        isinintroduction = true
        Wait(10000)
        DoScreenFadeIn(500)
        while true do
            Wait(0)
            if introstep == 1 then
                TriggerMusicEvent("FM_INTRO_START")
                introcam = CreateCam("DEFAULT_SCRIPTED_CAMERA", false)
                SetCamActive(introcam, true)
                SetFocusArea(754.2219, 1226.831, 356.5081, 0.0, 0.0, 0.0)
                SetCamParams(introcam, 754.2219, 1226.831, 356.5081, -14.367, 0.0, 157.3524, 42.2442, 0, 1, 1, 2)
                SetCamParams(introcam, 740.7797, 1193.923, 351.1997, -9.6114, 0.0, 157.8659, 44.8314, 7200, 0, 0, 2)
                ShakeCam(introcam, "HAND_SHAKE", 0.15)
                RenderScriptCams(true, false, 3000, 1, 1)
                timer = GetNetworkTime() + 6700
                introstep = 1.5
            elseif introstep == 1.5 then
                Wait(800)
                while GetNetworkTime() < timer do
                    Wait(0)
                    TriggerEvent("airportwars:helptext", infos[1])
                end
                introstep = 2
            elseif introstep == 2 then
                DoScreenFadeOut(800)
                Wait(800)
                SetFocusArea(-1161.669, -3138.265, 19.17101, 0.0, 0.0, 0.0)
                NetworkOverrideClockTime(19, 0, 0)
                Wait(320)
                DoScreenFadeIn(800)
                SetCamParams(introcam, -1161.669, -3138.265, 19.17101, -5.8529, -0.5186, -120.8262, 45.0069, 0, 1, 1, 2)
                SetCamParams(introcam, -1163.629, -3149.033, 17.1717, -20.1245, -0.5186, -90.8262, 45.0069, 8800, 0, 0, 2)
                timer = GetNetworkTime() + 8000
                introstep = 2.5
            elseif introstep == 2.5 then
                Wait(800)
                while GetNetworkTime() < timer do
                    Wait(0)
                    TriggerEvent("airportwars:helptext", infos[2])
                end
                introstep = 3
            elseif introstep == 3 then
                DoScreenFadeOut(800)
                Wait(800)
                SetFocusArea(-1071.044, -2979.413, 42.35216, 0.0, 0.0, 0.0)
                NetworkOverrideClockTime(19, 0, 0)
                Wait(320)
                DoScreenFadeIn(800)
                SetCamParams(introcam, -1071.044, -2979.413, 42.35216, -2.3097, 0.0, 266.7306, 40.033, 0, 1, 1, 2)
                SetCamParams(introcam, -1060.444, -2979.405, 30.95214, -2.3097, 0.0, 266.7306, 40.033, 8800, 0, 0, 2)
                timer = GetNetworkTime() + 8000
                introstep = 3.5
            elseif introstep == 3.5 then
                Wait(800)
                while GetNetworkTime() < timer do
                    Wait(0)
                    TriggerEvent("airportwars:helptext", infos[3])
                end
                introstep = 4
            elseif introstep == 4 then
                DoScreenFadeOut(800)
                Wait(800)
                SetFocusArea(-1798.041, 2968.413, 39.19867, 0.0, 0.0, 0.0)
                NetworkOverrideClockTime(19, 0, 0)
                Wait(320)
                DoScreenFadeIn(800)
                SetCamParams(introcam, -1798.041, 2968.413, 39.19867, -30.3097, 0.0, 240.7306, 40.033, 0, 1, 1, 2)
                SetCamParams(introcam, -1806.035, 2953.417, 42.79868, -30.3097, 0.0, 240.7306, 40.033, 8800, 0, 0, 2)
                timer = GetNetworkTime() + 8000
                introstep = 4.5
            elseif introstep == 4.5 then
                Wait(800)
                while GetNetworkTime() < timer do
                    Wait(0)
                    TriggerEvent("airportwars:helptext", infos[4])
                end
                introstep = 5
            elseif introstep == 5 then
                DoScreenFadeOut(800)
                Wait(800)
                SetFocusArea(1666.09, 3220.119, 59.05996, 0.0, 0.0, 0.0)
                NetworkOverrideClockTime(19, 0, 0)
                Wait(320)
                DoScreenFadeIn(800)
                SetCamParams(introcam, 1666.09, 3220.119, 59.05996, -20.3097, 2.3615, -50.7306, 40.033, 0, 1, 1, 2)
                SetCamParams(introcam, 1674.471, 3236.45, 50.05993, -12.3097, -2.3615, -50.7306, 40.033, 8800, 0, 0, 2)
                timer = GetNetworkTime() + 8000
                introstep = 5.5
            elseif introstep == 5.5 then
                Wait(800)
                while GetNetworkTime() < timer do
                    Wait(0)
                    TriggerEvent("airportwars:helptext", infos[5])
                end
                introstep = 6
            elseif introstep == 6 then
                DoScreenFadeOut(800)
                Wait(800)
                SetFocusArea(-1306.851, -391.109, 38.2952, 0.0, 0.0, 0.0)
                NetworkOverrideClockTime(19, 0, 0)
                Wait(320)
                DoScreenFadeIn(800)
                SetCamParams(introcam, -1306.851, -391.109, 38.2952, 0.7142, 0.3156, -105.7306, 40.033, 0, 1, 1, 2)
                SetCamParams(introcam, -1306.379, -394.0717, 37.6959, 0.9614, 0.5214, -120.7306, 40.033, 8800, 0, 0, 2)
                timer = GetNetworkTime() + 8000
                introstep = 6.5
            elseif introstep == 6.5 then
                Wait(800)
                while GetNetworkTime() < timer do
                    Wait(0)
                    TriggerEvent("airportwars:helptext", infos[6])
                end
                introstep = 7
            elseif introstep == 7 then
                DoScreenFadeOut(800)
                Wait(800)
                SetFocusArea(-1066.286, -243.3144, 46.19627, 0.0, 0.0, 0.0)
                NetworkOverrideClockTime(19, 0, 0)
                Wait(320)
                DoScreenFadeIn(800)
                SetCamParams(introcam, -1066.286, -243.3144, 46.19627, -5.7142, 0.3156, -170.7306, 60.033, 0, 1, 1, 2)
                SetCamParams(introcam, -1057.979, -239.101, 44.79618, -5.9614, 0.5214, -120.7306, 60.033, 8800, 0, 0, 2)
                timer = GetNetworkTime() + 8000
                introstep = 7.5
            elseif introstep == 7.5 then
                Wait(800)
                while GetNetworkTime() < timer do
                    Wait(0)
                    TriggerEvent("airportwars:helptext", infos[7])
                end
                introstep = 8
            elseif introstep == 8 then
                DoScreenFadeOut(800)
                Wait(800)
                SetFocusArea(-4.6668, -900.9736, 184.887, 0.0, 0.0, 0.0)
                NetworkOverrideClockTime(19, 0, 0)
                Wait(320)
                DoScreenFadeIn(800)
                SetCamParams(introcam, -4.6668, -900.9736, 184.887, -1.6106, -0.5186, 78.3786, 45.0069, 0, 1, 1, 2)
                SetCamParams(introcam, -23.0087, -896.4288, 184.1939, -2.8529, -0.5186, 81.8262, 45.0069, 8800, 0, 0, 2)
                timer = GetNetworkTime() + 8000
                introstep = 8.5
            elseif introstep == 8.5 then
                Wait(800)
                while GetNetworkTime() < timer do
                    Wait(0)
                    TriggerEvent("airportwars:helptext", infos[8])
                end
                introstep = 9
            elseif introstep == 9 then
                DoScreenFadeOut(1500)
                StopCamShaking(introcam, 1)
                DetachCam(introcam)
                DestroyCam(introcam, 0)
                isinintroduction = false
                ClearFocus()
                TriggerEvent("airportwars:weather:updatepermissions", false)
                CancelMusicEvent("FM_INTRO_START")
                Wait(23500)
                SetEntityCoords(PlayerPedId(), 925.329, 46.152, 80.908)
                TriggerServerEvent("airportwars:intro:finished")
                return
            end
        end
    end)
end

CreateThread(function()
    while true do
        Wait(0)
        if IsPlayerInIntroduction() then
            for i, v in ipairs(inputgroups) do
                DisableAllControlActions(v)
            end
            DisableMenusThisFrame()
        end
    end
end)
-------------------------------------- EVENTS -----------------------------------------
RegisterNetEvent("airportwars:intro:update")
AddEventHandler("airportwars:intro:update", function(bool)
    havetopassintro = bool
end)

RegisterNetEvent("airportwars:intro:done")
AddEventHandler("airportwars:intro:done", function()
    havetopassintro = false
    canaccesstostores = true
    canstartevent = true
    isfirstspawnafterintro = true
    TriggerFirstSpawn()
end)

RegisterNetEvent("airportwars:intro:showtips")
AddEventHandler("airportwars:intro:showtips", function()
    local tip = 1
    while IsHelpMessageBeingDisplayed() do
        Wait(0)
    end
    local timer = GetNetworkTime()
    while GetTimeDifference(GetNetworkTime(), timer) <= 130000 do
        Wait(0)
        if (tips[tip] ~= nil) then
            TriggerEvent("airportwars:helptext", tips[tip])
        end
        if ((GetTimeDifference(GetNetworkTime(), timer) > 0) and (GetTimeDifference(GetNetworkTime(), timer) < 9000)) then
          if (tip ~= 1) then
              tip = 1
          end
        elseif ((GetTimeDifference(GetNetworkTime(), timer) > 10000) and (GetTimeDifference(GetNetworkTime(), timer) < 19000)) then
            if (tip ~= 2) then
                tip = 2
            end
        elseif ((GetTimeDifference(GetNetworkTime(), timer) > 20000) and (GetTimeDifference(GetNetworkTime(), timer) < 29000)) then
            if (tip ~= 3) then
                tip = 3
            end
        elseif ((GetTimeDifference(GetNetworkTime(), timer) > 30000) and (GetTimeDifference(GetNetworkTime(), timer) < 39000)) then
            if (tip ~= 4) then
                tip = 4
            end
        elseif ((GetTimeDifference(GetNetworkTime(), timer) > 40000) and (GetTimeDifference(GetNetworkTime(), timer) < 49000)) then
            if (tip ~= 5) then
                tip = 5
            end
        elseif ((GetTimeDifference(GetNetworkTime(), timer) > 50000) and (GetTimeDifference(GetNetworkTime(), timer) < 59000)) then
            if (tip ~= 6) then
                tip = 6
            end
         elseif ((GetTimeDifference(GetNetworkTime(), timer) > 60000) and (GetTimeDifference(GetNetworkTime(), timer) < 69000)) then
            if (tip ~= 7) then
                tip = 7
            end
         elseif ((GetTimeDifference(GetNetworkTime(), timer) > 70000) and (GetTimeDifference(GetNetworkTime(), timer) < 79000)) then
            if (tip ~= 8) then
                tip = 8
            end
         elseif ((GetTimeDifference(GetNetworkTime(), timer) > 80000) and (GetTimeDifference(GetNetworkTime(), timer) < 89000)) then
            if (tip ~= 9) then
                tip = 9
            end
         elseif ((GetTimeDifference(GetNetworkTime(), timer) > 90000) and (GetTimeDifference(GetNetworkTime(), timer) < 99000)) then
            if (tip ~= 10) then
                tip = 10
            end
         elseif ((GetTimeDifference(GetNetworkTime(), timer) > 100000) and (GetTimeDifference(GetNetworkTime(), timer) < 109000)) then
            if (tip ~= 11) then
                tip = 11
            end
        elseif ((GetTimeDifference(GetNetworkTime(), timer) > 110000) and (GetTimeDifference(GetNetworkTime(), timer) < 119000)) then
            TriggerServerEvent("airportwars:intro:confirmtips")
            return
        end
    end
end)
---------------------------------------------------------------------------------------
ready.client_intro = true
