--Config
local minimumPlayersOnline = 3 -- to start a lottery
local lotteryInterval = 35 --  in minutes
local lotteryDuration = 5 --  minutes
local chances = {
{ percent = 80, rangeLow = 200, rangeHigh = 2500 },
{ percent = 15, rangeLow = 200, rangeHigh = 4500 },
{ percent = 4, rangeLow = 200, rangeHigh = 7500 },
{ percent = 1, rangeLow = 200, rangeHigh = 11000 }
}
local minPlayersOnForWin = 3 --min entries to not cancel lottery
--
local lotteryEntries = {}
local lotteryTime = 0
local lotteryEndTime = 0
local lotteryRunning = false
local amount = {} --lottery details

local chanceTable = {}

for i, val in ipairs(chances) do
		local times = val.percent
		while (times > 0) do
				table.insert(chanceTable, i)
				times = times - 1
		end
end


local function getLotteryAmount()
		local index = chanceTable[math.random(1,#chanceTable)]
		local low = chances[index].rangeLow
		local high = chances[index].rangeHigh
		return {math.random(low, high), low, high}
end

local function sendLotteryMessage(to, message, subject, jackpot)
		if (title == nil and jackpot) then
				TriggerClientEvent("airportwars:notify", to, "STRING", -1, {message}, "CHAR_BANK_MAZE", 0, "Airport Wars Lottery", "Jackpot: $"..jackpot, 1.0, true)
				SetTimeout(200, function()
						TriggerClientEvent("airportwars:lottery:keynotification", -1)
				end)
		else
				TriggerClientEvent("airportwars:notify", to, msg, "CHAR_BANK_MAZE", 0, "Airport Wars Lottery", subject, 1.0, true)
		end
end

--Thread--
AirportWarsThread(60, function()
	if (#GetAllConnectedPlayers() >= minimumPlayersOnline) then
			lotteryTime = lotteryTime + 1
			if (lotteryTime >= lotteryInterval and not lotteryRunning) then
					--Lottery has started
					lotteryRunning = true
					TriggerClientEvent("airportwars:lottery:status", -1, true)
					amount = getLotteryAmount()
					print("[AW-LOTTERY] A lottery of jackpot: $"..amount[1].." is being run")
					sendLotteryMessage(-1, "A ~g~lottery~w~ has begun! Lottery is open for "..(lotteryDuration-lotteryEndTime).." minutes.", nil, amount[2].." - $"..amount[3])
					SendDiscordMessage("A lottery has begun! Lottery is open for "..(lotteryDuration-lotteryEndTime).." minutes.", true)
			end
			if lotteryRunning then
					TriggerClientEvent("airportwars:lottery:status", -1, true)
					if lotteryEndTime > 0 then
							sendLotteryMessage(-1, "A lottery is ~g~active~w~. Lottery is open for "..(lotteryDuration-lotteryEndTime).." more minutes.", nil, amount[2].." - $"..amount[3])
					end
					lotteryEndTime = lotteryEndTime + 1
					SendDiscordMessage("A lottery is active. Lottery is open for "..(lotteryDuration-lotteryEndTime).." more minutes.", true)
			end
			if (lotteryEndTime >= lotteryDuration) then
					--Lottery has ended
					print("[AW-LOTTERY] The lottery has ended with "..#lotteryEntries.." ticket entries")
					if (#lotteryEntries >= 3) then --minimum entries
							TriggerClientEvent("airportwars:lottery:status", -1, false)
							local winner = math.random(1,#lotteryEntries)
							sendLotteryMessage(-1, "~g~"..GetPlayerName(winner).." has won the lottery, congratulations!", "~g~We have a winner!")
							TriggerClientEvent("airportwars:simplenotify", winner, "~g~$"..amount.." was given to you for winning the lottery!", true)
							lotteryEntries = {}
							SendDiscordMessage("**"..GetPlayerName(winner).."** won the lottery!", true)
					else
							TriggerClientEvent("airportwars:lottery:status", -1, false)
							sendLotteryMessage(-1, "There were not enough ticket entries for the lottery! Tickets refunded.", "~r~Not enough entries")
							SendDiscordMessage("Not enough players entered into the lottery.", true)
							for i, entrysrc in ipairs(lotteryEntries) do
									TriggerEvent("airportwars:sys:getuserfromid", entrysrc, function(Network)
											Network.AddToWalletBalance(1000)
				 					end)
				 					sendLotteryMessage(entrysrc, "You have been refunded ~g~$1000", "Ticket refund")
							end
							lotteryEntries = {}
					end
					lotteryRunning = false
					lotteryEndTime = 0
					lotteryTime = 0
				end
		end
end)

--Events--
RegisterServerEvent("airportwars:lottery:add")
AddEventHandler("airportwars:lottery:add", function()
		if lotteryRunning then
				if (tablecontains(lotteryEntries, tonumber(source)) == false) then
						table.insert(lotteryEntries, tonumber(source))
						sendLotteryMessage(source, "You have entered the Airport Wars lottery. $1,000 has been taken from your balance.", "~g~Ticket purchased!")
						SendDiscordMessage( GetPlayerName(source).." has entered into the lottery! ("..#lotteryEntries.." entries)", true)
						TriggerClientEvent("airportwars:simplenotify", -1, "~p~"..GetPlayerName(source).." ~w~has purchased a lottery ticket! ("..#lotteryEntries.." entries)", true)
						TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
								Network.RemoveFromWalletBalance(1000)
					 	end)
				else
				    --Already in the lottery ticket
				    sendLotteryMessage(source, "You are already entered into the lottery.", "~r~Already entered!")
				end
		end
end)
