---------------------------------------------------------
-- RESSOURCE : Market - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Market for the Airport Wars server.
---------------------------------------------------------
--------------------------------- VARIABLES/FUNCTIONS ---------------------------------
local Events = {
    Client = {
        AddPermWeapon = function(player, id, weapon)
            TriggerClientEvent("airportwars:webmarket:triggerevent", player, id, "ADD_PERM", weapon)
        end,
        RemovePermWeapon = function(player, id, weapon)
            TriggerClientEvent("airportwars:webmarket:triggerevent", player, id, "REMOVE_PERM", weapon)
        end,
        SendNotification = function(player, id, notification)
            TriggerClientEvent("airportwars:webmarket:triggerevent", player, id, "NOTIFICATION", notification)
        end,
    },
    IsPlayerOnline = function(identifier)
        local players = GetAllConnectedPlayers()
        for _, player in ipairs(players) do
            if (GetPlayerIdentifiers(player)[1] == identifier) then
                return true, playerid
            end
        end
        return false, nil
    end,
    AddMoney = function(identifier, amount)
        local current_wallet_balance = exports["mysql"]:QueryScalar("SELECT wallet_balance FROM apw_stats WHERE identifier = @identifier", {["@identifier"] = identifier})
        local new_wallet_balance = json.decode(current_wallet_balance).value + tonumber(amount)
        local new_wallet_balance_table = {value = new_wallet_balance}
        exports["mysql"]:QueryAsync("UPDATE apw_stats SET wallet_balance = '"..json.encode(new_wallet_balance_table).."' WHERE identifier = @identifier", {["@identifier"] = identifier})
    end,
    RemoveMoney = function(identifier, amount)
        local current_wallet_balance = exports["mysql"]:QueryScalar("SELECT wallet_balance FROM apw_stats WHERE identifier = @identifier", {["@identifier"] = identifier})
        local new_wallet_balance = json.decode(current_wallet_balance).value - tonumber(amount)
        local new_wallet_balance_table = {value = new_wallet_balance}
        exports["mysql"]:QueryAsync("UPDATE apw_stats SET wallet_balance = '"..json.encode(new_wallet_balance_table).."' WHERE identifier = @identifier", {["@identifier"] = identifier})
    end,
    AddPermWeapon = function(identifier, weapon)
        local current_perm_weapons = exports["mysql"]:QueryScalar("SELECT perm_weapons FROM apw_weapons WHERE identifier = @identifier", {["@identifier"] = identifier})
        local new_perm_weapons = json.decode(current_perm_weapons)
        table.insert(new_perm_weapons, weapon)
        local new_perm_weapons_json = json.encode(new_perm_weapons)
        exports["mysql"]:QueryAsync("UPDATE apw_weapons SET perm_weapons = '"..new_perm_weapons_json.."' WHERE identifier = @identifier", {["@identifier"] = identifier})
    end,
    RemovePermWeapon = function(identifier, weapon)
        local current_perm_weapons = exports["mysql"]:QueryScalar("SELECT perm_weapons FROM apw_weapons WHERE identifier = @identifier", {["@identifier"] = identifier})
        local new_perm_weapons = json.decode(current_perm_weapons)
        for k, v in pairs(new_perm_weapons) do
            if (v == weapon) then
                table.remove(new_perm_weapons, k)
            end
        end
        local new_perm_weapons_json = json.encode(new_perm_weapons)
        exports["mysql"]:QueryAsync("UPDATE apw_weapons SET perm_weapons = '"..new_perm_weapons_json.."' WHERE identifier = @identifier", {["@identifier"] = identifier})
    end,
    ConfirmJob = function(id)
        exports["mysql"]:QueryAsync("UPDATE apweb_eventqueue SET job_completed = '1' WHERE id = @id", {["@id"] = id})
    end
}

local function CheckMarketQueue()
		CreateThread(function()
        local marketqueue = exports["mysql"]:QueryResult("SELECT * FROM apweb_eventqueue")
        for i, v in ipairs(marketqueue) do
            if not (v.job_completed) then
                local isplayeronline, source = Events.IsPlayerOnline(v.identifier)
                if isplayeronline then
                    TriggerEvent("airportwars:webmarket:triggerevent", true, source, v.id, v.identifier, v.event, v.value)
                else
                    TriggerEvent("airportwars:webmarket:triggerevent", false, source, v.id, v.identifier, v.event, v.value)
                end
            end
        end
    end)
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
AddEventHandler("airportwars:webmarket:triggerevent", function(isonline, source, id, identifier, event, value)
    if (isonline) then
        TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
            if (event == "ADD_MONEY") then
                Network.AddToWalletBalance(tonumber(value), false)
                Events.ConfirmJob(id)
            elseif (event == "REMOVE_MONEY") then
                Network.RemoveFromWalletBalance(tonumber(value))
                Events.ConfirmJob(id)
            elseif (event == "ADD_PERM") then
                Events.AddPermWeapon(identifier, value)
                Events.Client.AddPermWeapon(source, id, value)
            elseif (event == "REMOVE_PERM") then
                Events.RemovePermWeapon(identifier, value)
                Events.Client.RemovePermWeapon(source, id, value)
            elseif (event == "SEND_PLAYER_MESSAGE") then
                Events.Client.SendNotification(source, id, value)
            end
        end)
    else
        if (event == "ADD_MONEY") then
            Events.AddMoney(identifier, value)
            Events.ConfirmJob(id)
        elseif (event == "REMOVE_MONEY") then
            Events.RemoveMoney(identifier, value)
            Events.ConfirmJob(id)
        elseif (event == "ADD_PERM") then
            Events.AddPermWeapon(identifier, value)
            Events.ConfirmJob(id)
        elseif (event == "REMOVE_PERM") then
            Events.RemovePermWeapon(identifier, value)
            Events.ConfirmJob(id)
        end
    end
end)

RegisterServerEvent("airportwars:webmarket:confirmjob")
AddEventHandler("airportwars:webmarket:confirmjob", function(id)
    Events.ConfirmJob(id)
end)
---------------------------------------------------------------------------------------
AirportWarsThread(20, CheckMarketQueue)
