---------------------------------------------------------
-- RESSOURCE : Objectives - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Objectives script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local ZancudoPlaneNetID = nil
local AirportPlaneNetID = nil
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:objectives:initialize")
AddEventHandler("airportwars:objectives:initialize", function(ishost)
    local source = source
    if ishost then
        TriggerClientEvent("airportwars:objectives:create", GetHostId())
        print("APW-OBJECTIVES: "..GetPlayerName(GetHostId()).." created the 2 first objectives as host.")
        return
    else
        while (ZancudoPlaneNetID == nil) and (AirportPlaneNetID == nil) do
            Wait(0)
        end
        TriggerClientEvent("airportwars:objectives:get", source, ZancudoPlaneNetID, AirportPlaneNetID)
        print("APW-OBJECTIVES: "..GetPlayerName(source).." received the objectives informations.")
    end
end)

RegisterServerEvent("airportwars:objectives:created")
AddEventHandler("airportwars:objectives:created", function(netidzancudo, netidairport)
    ZancudoPlaneNetID = netidzancudo
    AirportPlaneNetID = netidairport
    TriggerClientEvent("airportwars:objectives:get", source, ZancudoPlaneNetID, AirportPlaneNetID)
    print("APW-OBJECTIVES: "..GetPlayerName(GetHostId()).." confirmed the creation of the objectives with the ID "..netidzancudo.." for the Zancudo Plane and the ID "..netidairport.." for the Airport Plate, objectives informations sent.")
end)

RegisterServerEvent("airportwars:objectives:respawn")
AddEventHandler("airportwars:objectives:respawn", function(type, reason, hostswitch)
    if (reason == "delivered") then
        TriggerClientEvent("airportwars:objectives:prevent", GetHostId(), true, false, false)
    elseif (reason == "destroyed") then
        TriggerClientEvent("airportwars:objectives:prevent", GetHostId(), false, true, false)
    elseif (reason == "abandoned") then
        TriggerClientEvent("airportwars:objectives:prevent", GetHostId(), false, false, true)
    end
    TriggerClientEvent("airportwars:objectives:hud", -1, type, reason, true)
    TriggerClientEvent("airportwars:objectives:clear", -1, type)
    TriggerClientEvent("airportwars:objectives:respawn", GetHostId(), type, hostswitch)
    print("APW-OBJECTIVES: Respawn of the "..type.." plane requested for the following reason : "..reason..".")
end)

RegisterServerEvent("airportwars:objectives:respawned")
AddEventHandler("airportwars:objectives:respawned", function(netid, planetype)
    if (planetype == "zancudo") then
        ZancudoPlaneNetID = netid
        TriggerClientEvent("airportwars:objectives:reget", -1, ZancudoPlaneNetID, "zancudo")
    elseif (planetype == "airport") then
        AirportPlaneNetID = netid
        TriggerClientEvent("airportwars:objectives:reget", -1, AirportPlaneNetID, "airport")
    end
    print("APW-OBJECTIVES: Host of the session confirmed : Plane "..planetype.." has been spawned and informations sent to other clients.")
end)

RegisterServerEvent("airportwars:objectives:delivered")
AddEventHandler("airportwars:objectives:delivered", function(teamofattacker)
    local source = source
    local players = GetAllConnectedPlayers()
    if (#players >= 2) then
        local score = 10
        local cash = 3000
        local cashteam = 300
        TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
            Network.AddToStat("SCORE", score, "score", true)
            Network.AddToWalletBalance(cash, true)
            TriggerClientEvent("airportwars:notify", source, "PLYSRC_SCORE_CASH", -1, {tostring(round(score * NetworkAccessTunable("SCORE_MULTIPLIER"))), tostring(round(cash * NetworkAccessTunable("CASH_MULTIPLIER")))}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
        end)
        for ereth in ipairs(players) do
            if (i ~= source) then
                if teamofattacker == 1 then
                    TriggerClientEvent("airportwars:notify", i, "PLY_DELIV_PLANE_LS", -1, {GetPlayerName(source)}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                elseif teamofattacker == 2 then
                    TriggerClientEvent("airportwars:notify", i, "PLY_DELIV_PLANE_ZC", -1, {GetPlayerName(source)}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                end
                TriggerEvent("airportwars:sys:getuserfromid", i, function(Network)
                    if (Network.GetInfo("TEAM") == teamofattacker) then
                        Network.AddToWalletBalance(cashteam, true)
                        TriggerClientEvent("airportwars:notify", i, "TEAM_DELIV_PLANE_AWRD", {"<C>"..GetPlayerName(source).."</C>", tostring(round(cashteam * NetworkAccessTunable("CASH_MULTIPLIER")))}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                    end
                end)
            end
        end
        if teamofattacker == 1 then
            TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(source).."** has just delivered a plane from the Los Santos Airport! (earned $"..tostring(round(cash * NetworkAccessTunable("CASH_MULTIPLIER"))).."!, all players on his team have earned $"..tostring(round(cashteam * NetworkAccessTunable("CASH_MULTIPLIER")))..")", true)
        elseif teamofattacker == 2 then
            TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(source).."** has just delivered a plane from the Fort Zancudo Airbase! (earned $"..tostring(round(cash * NetworkAccessTunable("CASH_MULTIPLIER"))).."!, all players on his team have earned $"..tostring(round(cashteam * NetworkAccessTunable("CASH_MULTIPLIER")))..")", true)
        end
    else
        TriggerClientEvent("airportwars:notify", source, "PLY_DELIV_NORWRD", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
        if teamofattacker == 1 then
            TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(source).."** has just delivered a plane from the Los Santos Airport! (earned nothing: objectives are not rewarded unless there are more than 2 players online)", true)
        elseif teamofattacker == 2 then
            TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(source).."** has just delivered a plane from the Fort Zancudo Airbase! (earned nothing: objectives are not rewarded unless there are more than 2 players online)", true)
        end
        for i, v in ipairs(players) do
            if (i ~= source) then
                if teamofattacker == 1 then
                    TriggerClientEvent("airportwars:notify", i, "PLY_DELIV_PLANE_LS", -1, {"<C>"..GetPlayerName(source).."</C>"}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                elseif teamofattacker == 2 then
                    TriggerClientEvent("airportwars:notify", i, "PLY_DELIV_PLANE_ZC", -1, {"<C>"..GetPlayerName(source).."</C>"}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                end
            end
        end
    end
end)

RegisterServerEvent("airportwars:objectives:update")
AddEventHandler("airportwars:objectives:update", function(type, state)
    TriggerClientEvent("airportwars:objectives:hud", -1, type, state, false)
    print("APW-OBJECTIVES: Host requested an HUD update to everyone with the informations : plane = "..type..", state = "..state.." .")
end)
---------------------------------------------------------------------------------------
