---------------------------------------------------------
-- RESSOURCE : Random Crates Spawner - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Random crates spawner for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local LastSpawn = 0
local LastTaken = 0
local SpawnTime = 25
local FirstSpawn = true
local SpecialCrateSpawned = false
local HasTriggeredTwentyMinutesAccounce = false
local HasTriggeredTenMinutesAccounce = false
local HasTriggeredTwoMinutesAccounce = false
local Infos = {X = 0, Y = 0, Z = 0, H = 0, NetID = 0, Stuff = 0}
local CratesContent = {
    {notification = "RDM_SCC1"}
}
local CratesLocations = {
    {x=1069.58, y=2366.363, z=43.0396},
    {x=-1979.781, y=2584.161, z=2.2587},
    {x=1915.902, y=563.9669, z=174.4925},
    {x=1458.393, y=1113.066, z=113.334},
    {x=817.5361, y=1316.57, z=362.0491},
    {x=1402.858, y=-2148.418, z=57.9675},
    {x=1104.815, y=-3142.335, z=4.901},
    {x=545.7347, y=-3025.327, z=5.0591},
    {x=1376.037, y=-740.2166, z=66.2331},
    {x=1147.162, y=126.3452, z=80.8693},
    {x=-3163.364, y=756.8276, z=2.1183},
    {x=-1731.085, y=-989.8386, z=4.4152},
    {x=-799.6782, y=885.0139, z=202.1319},
    {x=-401.2717, y=1211.677, z=324.9297},
    {x=728.2132, y=-1532.48, z=18.7348},
    {x=1140.923, y=-1285.639, z=33.6091},
    {x=585.3987, y=2893.778, z=38.5297},
    {x=-1706.013, y=-183.4387, z=56.3712},
    {x=-134.0402, y=-869.4509, z=43.2175},
    {x=1098.246, y=-544.2941, z=56.4061}
}
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
local function GetSpawnTime()
    return math.floor(SpawnTime*60000)
end

local function IsFirstSpawn()
		return FirstSpawn
end

local function IsSpecialCrateSpawned()
    return SpecialCrateSpawned
end

local function GetRandomPosition()
    local Position = CratesLocations[math.random(1, Count(CratesLocations))]
    return Position
end

local function GetRandomStuffId()
    local StuffID = math.random(1, Count(CratesContent))
    return StuffID
end

local function ConfirmSpawn(x, y, z, time, netid, stuff)
		Infos.X, Infos.Y, Infos.Z, Infos.SpawnTime, Infos.NetID, Infos.Stuff = x, y, z, time, netid, stuff
    HasTriggeredTwentyMinutesAccounce = false
    HasTriggeredTenMinutesAccounce = false
		HasTriggeredTwoMinutesAccounce = false
		SpecialCrateSpawned = true
		LastSpawn = GetGameTimer()
		TriggerClientEvent("airportwars:randoms:crates:here", -1, x, y, z, netid)
		SendDiscordMessage("A **Special Crate** was dropped on the map.", true)
end

local function GetLastSpawnNetworkTime()
		return LastSpawn
end

local function GetLastTakenNetworkTime()
		return LastTaken
end

local function TriggeredTwoMinutesAccounce()
		return HasTriggeredTwoMinutesAccounce
end

local function TriggeredTenMinutesAccounce()
    return HasTriggeredTenMinutesAccounce
end

local function TriggeredTwentyMinutesAccounce()
		return HasTriggeredTwentyMinutesAccounce
end

local function ResetInfos()
		Infos = {X = 0, Y = 0, Z = 0, H = 0, SpawnTime = 0, NetID = 0, Stuff = 0}
end

local function TriggerCrateTaken(player, stuff)
    local player = player
    TriggerEvent("airportwars:sys:getuserfromid", player, function(Network)
        if (stuff == 1) then
            Network.AddToWalletBalance(5000)
            TriggerClientEvent("airportwars:randoms:crates:givestuff", player, stuff)
            TriggerClientEvent("airportwars:simplenotify", player, CratesContent[1].notification, -1, {}, true)
        end
    end)
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:randoms:crates:dropped")
AddEventHandler("airportwars:randoms:crates:dropped", function(position, time, netid, stuff)
		ConfirmSpawn(position.x, position.y, position.z, time, netid, stuff)
end)

RegisterServerEvent("airportwars:randoms:crates:taken")
AddEventHandler("airportwars:randoms:crates:taken", function(time)
    for _, player in ipairs(GetAllConnectedPlayers()) do
        if (player ~= source) then
            TriggerClientEvent("airportwars:simplenotify", player, "RDM_SCTKN", -1, {"<C>"..GetPlayerName(source).."</C>"}, true)
        end
    end
    TriggerCrateTaken(source, Infos.Stuff)
    SendDiscordMessage("**"..GetPlayerName(source).."** picked up the Special Crate.", true)
    ResetInfos()
    LastTaken = GetGameTimer()
    SpecialCrateSpawned = false
    HasTriggeredTwoMinutesAccounce = false
    HasTriggeredTenMinutesAccounce = false
    HasTriggeredTwentyMinutesAccounce = false
end)
---------------------------------------------------------------------------------------


-------------------------------------- THREADS ----------------------------------------
AirportWarsThread(10, function()
    if (#GetAllConnectedPlayers() > 0) then
      	if not IsSpecialCrateSpawned() then
            if not IsFirstSpawn() then
                if GetGameTimer() - GetLastTakenNetworkTime() >= GetSpawnTime() - 1200000 and not TriggeredTwentyMinutesAccounce() then
                    TriggerClientEvent("airportwars:simplenotify", -1, "RDM_SC20M", -1, {}, true)
                    SendDiscordMessage("Special Crate Drop in 20 minutes.", true)
                    HasTriggeredTwentyMinutesAccounce = true
                end
                if GetGameTimer() - GetLastTakenNetworkTime() >= GetSpawnTime() - 600000 and not TriggeredTenMinutesAccounce() then
                    TriggerClientEvent("airportwars:simplenotify", -1, "RDM_SC10M", -1, {}, true)
                    SendDiscordMessage("Special Crate Drop in 10 minutes.", true)
                    HasTriggeredTenMinutesAccounce = true
                end
        				if GetGameTimer() - GetLastTakenNetworkTime() >= GetSpawnTime() - 120000 and not TriggeredTwoMinutesAccounce() then
        						TriggerClientEvent("airportwars:simplenotify", -1, "RDM_SC2M", -1, {}, true)
                    SendDiscordMessage("Special Crate Drop inbound.", true)
        						HasTriggeredTwoMinutesAccounce = true
        				end
        				if GetGameTimer() - GetLastTakenNetworkTime() >= GetSpawnTime() then
                    if (GetHostId() ~= nil) then
        						    TriggerClientEvent("airportwars:randoms:crates:drop", GetHostId(), GetRandomPosition(), GetRandomStuffId())
                    end
        				end
            else
                LastTaken = GetGameTimer() + (GetSpawnTime()/2)
                FirstSpawn = false
            end
    		end
    end
end)

AirportWarsThread(30, function()
  	if IsSpecialCrateSpawned() then
				if GetGameTimer() - GetLastSpawnNetworkTime() >= GetSpawnTime() then
            if (GetHostId() ~= nil) then
                TriggerClientEvent("airportwars:randoms:crates:delete", GetHostId())
    						TriggerClientEvent("airportwars:simplenotify", -1, "RDM_SCDAX", -1, {tostring(SpawnTime)}, true)
                SendDiscordMessage("Special Crate Drop destroyed after "..tostring(SpawnTime).." minutes.", true)
                ResetInfos()
                LastTaken = GetGameTimer()
                SpecialCrateSpawned = false
                HasTriggeredTwoMinutesAccounce = false
                HasTriggeredTenMinutesAccounce = false
                HasTriggeredTwentyMinutesAccounce = false
            end
				end
		end
end)
---------------------------------------------------------------------------------------
