---------------------------------------------------------
-- RESSOURCE : Scoreboard - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Scoreboard script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local scoreboard = {}
local showglobal = true
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
function DisplayScoreboardThisFrame()
		local scaleform = RequestScaleformMovie("SC_LEADERBOARD")
    while not HasScaleformMovieLoaded(scaleform) do
        Wait(0)
    end
    local position = 0
    PushScaleformMovieFunction(scaleform, "SET_DISPLAY_TYPE")
    PushScaleformMovieFunctionParameterInt(0)
    PopScaleformMovieFunctionVoid()
    PushScaleformMovieFunction(scaleform, "SET_MULTIPLAYER_TITLE")
    PushScaleformMovieFunctionParameterString("Airport Wars")
    PopScaleformMovieFunctionVoid()
    PushScaleformMovieFunction(scaleform, "SET_TITLE")
    PushScaleformMovieFunctionParameterString("POSITION")
    PushScaleformMovieFunctionParameterString("TEAM")
    PushScaleformMovieFunctionParameterString("SCORE")
    PushScaleformMovieFunctionParameterString("KILLS")
    PushScaleformMovieFunctionParameterString("DEATHS")
    PushScaleformMovieFunctionParameterString("CASH")
    PopScaleformMovieFunctionVoid()
    if (showglobal) then
        PushScaleformMovieFunction(scaleform, "SET_SLOT")
        PushScaleformMovieFunctionParameterInt(0)
        PushScaleformMovieFunctionParameterInt(17)
        PushScaleformMovieFunctionParameterString("ONLINE PLAYERS ("..GetNumberOfPlayers().."/32)") --NetworkGetNumConnectedPlayers
        PopScaleformMovieFunctionVoid()
        position = 1
    end
    for i = 1, math.min(16, #scoreboard) do
        PushScaleformMovieFunction(scaleform, "SET_SLOT")
        PushScaleformMovieFunctionParameterInt(position)
        PushScaleformMovieFunctionParameterInt(1)
        if not (showglobal) then
            PushScaleformMovieFunctionParameterString(tostring(math.ceil(position) + 1))
        else
            PushScaleformMovieFunctionParameterString(tostring(math.ceil(position)))
        end
        PushScaleformMovieFunctionParameterString(scoreboard[i].name)
				if not IsStringNullOrEmpty(scoreboard[i].rank) then
        		PushScaleformMovieFunctionParameterString("   "..scoreboard[i].rank)
				else
						PushScaleformMovieFunctionParameterString("")
				end
        if (scoreboard[i].team == 1) then
            PushScaleformMovieFunctionParameterString("Fort Zancudo")
        elseif (scoreboard[i].team == 2) then
            PushScaleformMovieFunctionParameterString("Los Santos Airport")
        else
            PushScaleformMovieFunctionParameterString("None")
        end
        PushScaleformMovieFunctionParameterString(scoreboard[i].score)
        PushScaleformMovieFunctionParameterString(scoreboard[i].kills)
        PushScaleformMovieFunctionParameterString(scoreboard[i].deaths)
        PushScaleformMovieFunctionParameterString(scoreboard[i].money)
        PopScaleformMovieFunctionVoid()
        position = position + 1
    end
    DrawScaleformMovieFullscreen(scaleform, 255, 255, 255, 255, 0)
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterNetEvent("airportwars:scoreboard:refresh")
AddEventHandler("airportwars:scoreboard:refresh", function(newscoreboard)
    scoreboard = newscoreboard
end)
---------------------------------------------------------------------------------------
ready.client_scoreboard = true
