---------------------------------------------------------
-- RESSOURCE : Weapon Shop - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Weapon Shop for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local nettimer = 0
local datapushed = false
local categories = nil
local melee = nil
local handgun = nil
local shotgun = nil
local submachine = nil
local assault = nil
local sniper = nil
local heavy = nil
local thrown = nil
local special_ammo = nil
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
local function GetOpt(cat, ind)
		if (cat == "melee") then
				return melee[ind]
		elseif (cat == "handgun") then
				return handgun[ind]
		elseif (cat == "shotgun") then
				return shotgun[ind]
		elseif (cat == "submachine") then
				return submachine[ind]
		elseif (cat == "assault") then
				return assault[ind]
		elseif (cat == "sniper") then
				return sniper[ind]
		elseif (cat == "heavy") then
				return heavy[ind]
		elseif (cat == "thrown") then
				return thrown[ind]
		elseif (cat == "special_ammo") then
				return special_ammo[ind]
		end
end

local function GetEvent(cat)
		if (cat == "melee") then
				return "airportwars:weapons:buymelee"
		elseif (cat == "handgun") then
				return "airportwars:weapons:buyhandgun"
		elseif (cat == "shotgun") then
				return "airportwars:weapons:buyshotgun"
		elseif (cat == "submachine") then
				return "airportwars:weapons:buymachinegun"
		elseif (cat == "assault") then
				return "airportwars:weapons:buyassaultrifle"
		elseif (cat == "sniper") then
				return "airportwars:weapons:buysniperrifle"
		elseif (cat == "heavy") then
				return "airportwars:weapons:buyheavyweapon"
		elseif (cat == "thrown") then
				return "airportwars:weapons:buythrownweapon"
		elseif (cat == "special_ammo") then
				return "airportwars:weapons:buyspecialammo"
		end
end

local function ch(hash)
		if (type(hash) == "string") then
				return GetHashKey(hash)
		end
		return hash
end

local function GetIntFromBlob(b, s, o)
		r = 0
		for i=1,s,1 do
				r = r | (string.byte(b,o+i)<<(i-1)*8)
		end
		return r
end

function FGetWeaponHudStats(weaponHash, none)
		blob = '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0'
		retval = Citizen.InvokeNative(0xD92C739EE34C9EBA, ch(weaponHash), blob, Citizen.ReturnResultAnyway())
		hudDamage = GetIntFromBlob(blob,8,0)
		hudSpeed = GetIntFromBlob(blob,8,8)
		hudCapacity = GetIntFromBlob(blob,8,16)
		hudAccuracy = GetIntFromBlob(blob,8,24)
		hudRange = GetIntFromBlob(blob,8,32)
		return retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange
end

local function TriggerWeaponPurchased(gxtname, model, ind, opt)
    CreateThread(function()
				datapushed = false
				nettimer = nettimer + 5000
				weaponpurchasedscaleform = RequestScaleformMovie("MP_BIG_MESSAGE_FREEMODE")
				TriggerEvent("theftvrp:menu:updateoption", "buy_wea", ind, opt)
        while true do
            Wait(0)
            if HasScaleformMovieLoaded(weaponpurchasedscaleform) then
								if not datapushed then
                    PushScaleformMovieFunction(weaponpurchasedscaleform, "SHOW_WEAPON_PURCHASED")
                    BeginTextCommandScaleformString("SHOP_PURCH")
                    EndTextCommandScaleformString()
										BeginTextCommandScaleformString(gxtname)
                    EndTextCommandScaleformString()
										if (type(model) == "string") then
												PushScaleformMovieMethodParameterInt(GetHashKey(model))
										elseif (type(model) == "number") then
												PushScaleformMovieMethodParameterInt(model)
										end
                    PopScaleformMovieFunctionVoid()
										nettimer = GetNetworkTime()
										datapushed = true
								end
								DrawScaleformMovieFullscreen(weaponpurchasedscaleform, 255, 255, 255, 255)
						end
            if IsTimeMoreThan(GetNetworkTime(), GetTimeOffset(nettimer, 5000)) then
                SetScaleformMovieAsNoLongerNeeded(bigmessagescaleform)
                nettimer = 0
								datapushed = false
                return
            end
        end
    end)
end

local function BaseArmoryMenu()
		TriggerEvent("theftvrp:menu:create", "buy_wea", "Base Armory", "WEAPONS CATEGORIES", true, true, true)
		local opts = {}
		for k, v in pairs(categories) do
				opts[k] = {
						type = v.type,
						text = v.name,
						desc = v.desc,
						event = v.event,
						callHandlerEveryUpdate = true,
            list = v.list
				}
		end
    TriggerEvent("theftvrp:menu:setmainlist", "buy_wea", "WEAPONS CATEGORIES", opts, 10)
    TriggerEvent("theftvrp:menu:setheaderscaleform", "buy_wea", false)
    --TriggerEvent("theftvrp:menu:setheadertodosprite", "buy_wea", false)
    --TriggerEvent("theftvrp:menu:spritecolor", "buy_wea", {209, 52, 52})
		TriggerEvent("theftvrp:menu:setheadersprite", "buy_wea", "shopui_title_gr_gunmod", "shopui_title_gr_gunmod")
		TriggerEvent("theftvrp:menu:writeText", "buy_wea", false)
    TriggerEvent("theftvrp:menu:setheaderbartextcolor", "buy_wea", 255, 255, 255, 255)
end

local function BuyWeapon(gxtname, model, category, ammo, ind, price)
    if (HasPedGotWeapon(PlayerPedId(), model, false)) and (category ~= "thrown") then
        --TriggerEvent("airportwars:notify", "AMMU_OWN_WEP", -1, {}, "CHAR_AMMUNATION", 0, "Base Armory", "", 0.3, false)
				TriggerEvent("airportwars:notify", "STRING", -1, {"Upgrades are coming soon..."}, "CHAR_AMMUNATION", 0, "Base Armory", "", 0.3, false)
        PlaySoundFrontend(-1, "ERROR", "HUD_AMMO_SHOP_SOUNDSET", 1)
    else
    		TriggerServerEvent("airportwars:weapons:checkmoney", gxtname, model, category, ammo, ind, price)
    end
end

local function BuyAmmo(list, category, ind, price)
    CreateThread(function()
        for k, v in pairs(list) do
            if HasPedGotWeapon(PlayerPedId(), v, false) then
    				    TriggerServerEvent("airportwars:weapons:checkmoneyammo", v, category, ind, false, price)
								return
            end
        end
    end)
end

local function BuySpecialAmmo(list, category, model, price)
    if HasPedGotWeapon(PlayerPedId(), model, false) then
		    TriggerServerEvent("airportwars:weapons:checkmoneyammo", model, category, ind, true, price)
    else
        TriggerEvent("airportwars:notify", "AMMU_NOWEP_FORAMMO", -1, {}, "CHAR_AMMUNATION", 0, "Base Armory", "", 0.3, false)
    end
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterNetEvent("airportwars:weapons:getlist")
AddEventHandler("airportwars:weapons:getlist", function(a, b, c, d, e, f, g, h, i, j)
    categories = a
    melee = b
    handgun = c
    shotgun = d
    submachine = e
    assault = f
    sniper = g
    heavy = h
    thrown = i
    special_ammo = j
end)

AddEventHandler("airportwars:weapons:menurequest", function()
    TriggerEvent("theftvrp:menu:isopened", "buy_wea", function(response, menu)
        TriggerEvent("airportwars:weapons:menuanswer", response, menu)
    end)
end)

AddEventHandler("airportwars:weapons:menuanswer", function(response, menu)
		if canaccesstostores then
		    if not (response) then
						if IsPedOnFoot(PlayerPedId()) then
					      TriggerEvent("airportwars:helptext", "Press ~INPUT_CONTEXT~ to browse weapons.")
					      if (IsControlJustPressed(0, 51)) then
					          TriggerEvent("theftvrp:menu:open", "buy_wea")
					      end
						else
								TriggerEvent("airportwars:helptext", "Get out of your vehicle in order to access the Base Armory.")
						end
		    end
		end
end)

AddEventHandler("airportwars:weapons:fastammo", function(opt, list)
		if opt.index == 1 then

    elseif opt.index == 2 then

    elseif opt.index == 3 then

    elseif opt.index == 4 then

    elseif opt.index == 5 then

    end
end)

AddEventHandler("airportwars:weapons:categories", function(opt, list)
		local ind = opt.data.index
		local item = categories[ind]
    if item.id == 2 then
			local opts_melee = {}
			for k, v in pairs(melee) do
					local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = nil, nil, nil, nil, nil, nil
					if (v.model ~= nil) then
							if HasPedGotWeapon(PlayerPedId(), v.model, false) then
									v.type = 3
							else
									v.type = 1
							end
					end
					opts_melee[k] = {
							type = v.type,
							text = v.name,
							desc = v.desc,
							event = "airportwars:weapons:buymelee",
							righttext = "$"..tostring(v.price),
							spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
							sprite = {"commonmenu", "shop_gunclub_icon_a"},
							barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
					}
			end
			TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "MELEE WEAPONS", opts_melee, 10)
		elseif item.id == 3 then
				local opts_handgun = {}
				for k, v in pairs(handgun) do
						local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = nil, nil, nil, nil, nil, nil
						if (v.model ~= nil) then
								if HasPedGotWeapon(PlayerPedId(), v.model, false) then
										v.type = 3
								else
										v.type = 1
								end
				        retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = FGetWeaponHudStats(v.model)
						end
						opts_handgun[k] = {
								type = v.type,
								text = v.name,
								desc = v.desc,
								event = "airportwars:weapons:buyhandgun",
								righttext = "$"..tostring(v.price),
								spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
								sprite = {"commonmenu", "shop_gunclub_icon_a"},
								barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
						}
				end
				TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "HANDGUNS", opts_handgun, 10)
		elseif item.id == 4 then
				local opts_shotgun = {}
				for k, v in pairs(shotgun) do
						local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = nil, nil, nil, nil, nil, nil
						if (v.model ~= nil) then
								if HasPedGotWeapon(PlayerPedId(), v.model, false) then
										v.type = 3
								else
										v.type = 1
								end
								retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = FGetWeaponHudStats(v.model)
						end
						opts_shotgun[k] = {
								type = v.type,
								text = v.name,
								desc = v.desc,
								event = "airportwars:weapons:buyshotgun",
								righttext = "$"..tostring(v.price),
								spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
								sprite = {"commonmenu", "shop_gunclub_icon_a"},
								barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
						}
				end
				TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "SHOTGUNS", opts_shotgun, 10)
		elseif item.id == 5 then
				local opts_submachine = {}
				for k, v in pairs(submachine) do
						local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = nil, nil, nil, nil, nil, nil
						if (v.model ~= nil) then
								if HasPedGotWeapon(PlayerPedId(), v.model, false) then
										v.type = 3
								else
										v.type = 1
								end
								retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = FGetWeaponHudStats(v.model)
						end
						opts_submachine[k] = {
								type = v.type,
								text = v.name,
								desc = v.desc,
								event = "airportwars:weapons:buymachinegun",
								righttext = "$"..tostring(v.price),
								spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
								sprite = {"commonmenu", "shop_gunclub_icon_a"},
								barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
						}
				end
				TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "MACHINE GUNS", opts_submachine, 10)
		elseif item.id == 6 then
				local opts_assault = {}
				for k, v in pairs(assault) do
						local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = nil, nil, nil, nil, nil, nil
						if (v.model ~= nil) then
								if HasPedGotWeapon(PlayerPedId(), v.model, false) then
										v.type = 3
								else
										v.type = 1
								end
								retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = FGetWeaponHudStats(v.model)
						end
						opts_assault[k] = {
								type = v.type,
								text = v.name,
								desc = v.desc,
								event = "airportwars:weapons:buyassaultrifle",
								righttext = "$"..tostring(v.price),
								spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
								sprite = {"commonmenu", "shop_gunclub_icon_a"},
								barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
						}
				end
				TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "ASSAULT RIFLES", opts_assault, 10)
		elseif item.id == 7 then
				local opts_sniper = {}
				for k, v in pairs(sniper) do
						local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = nil, nil, nil, nil, nil, nil
						if (v.model ~= nil) then
								if HasPedGotWeapon(PlayerPedId(), v.model, false) then
										v.type = 3
								else
										v.type = 1
								end
								retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = FGetWeaponHudStats(v.model)
						end
						opts_sniper[k] = {
								type = v.type,
								text = v.name,
								desc = v.desc,
								event = "airportwars:weapons:buysniperrifle",
								righttext = "$"..tostring(v.price),
								spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
								sprite = {"commonmenu", "shop_gunclub_icon_a"},
								barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
						}
				end
				TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "SNIPER RIFLES", opts_sniper, 10)
		elseif item.id == 8 then
				local opts_heavy = {}
				for k, v in pairs(heavy) do
						local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = nil, nil, nil, nil, nil, nil
						if (v.model ~= nil) then
								if HasPedGotWeapon(PlayerPedId(), v.model, false) then
										v.type = 3
								else
										v.type = 1
								end
								retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = FGetWeaponHudStats(v.model)
						end
						opts_heavy[k] = {
								type = v.type,
								text = v.name,
								desc = v.desc,
								event = "airportwars:weapons:buyheavyweapon",
								righttext = "$"..tostring(v.price),
								spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
								sprite = {"commonmenu", "shop_gunclub_icon_a"},
								barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
						}
				end
				TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "HEAVY WEAPONS", opts_heavy, 10)
    elseif item.id == 9 then
        local opts_thrown = {}
        for k, v in pairs(thrown) do
						local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = nil, nil, nil, nil, nil, nil
						if (v.model ~= nil) then
								if HasPedGotWeapon(PlayerPedId(), v.model, false) then
										v.type = 3
								else
										v.type = 1
								end
								retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = FGetWeaponHudStats(v.model)
						end
            opts_thrown[k] = {
                type = v.type,
                text = v.name,
                desc = v.desc,
                event = "airportwars:weapons:buythrownweapon",
                righttext = "$"..tostring(v.price),
								spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
								sprite = {"commonmenu", "shop_gunclub_icon_a"},
								barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
            }
        end
        TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "THROWN WEAPONS", opts_thrown, 10)
    elseif item.id == 10 then
				local opts_special_ammo = {}
				for k, v in pairs(special_ammo) do
						opts_special_ammo[k] = {
								type = v.type,
								text = v.name,
								desc = v.desc,
								event = "airportwars:weapons:buyspecialammo",
								righttext = "$"..tostring(v.price)
						}
				end
				TriggerEvent("theftvrp:menu:setnextlist", "buy_wea", "SPECIAL AMMO", opts_special_ammo, 10)
    end
end)

AddEventHandler("airportwars:weapons:buymelee", function(opt, list)
    local ind = opt.data.index
    local item = melee[ind]
		BuyWeapon(item.gxtname, item.model, "melee", 30, ind, item.price)
end)

AddEventHandler("airportwars:weapons:buyhandgun", function(opt, list)
    local ind = opt.data.index
    local item = handgun[ind]
    if item.id ~= 5 then
		    BuyWeapon(item.gxtname, item.model, "handgun", 30, ind, item.price)
    else
        BuyAmmo(item.list, "handgun", ind, item.price)
    end
end)

AddEventHandler("airportwars:weapons:buyshotgun", function(opt, list)
    local ind = opt.data.index
    local item = shotgun[ind]
    if item.id ~= 5 then
		    BuyWeapon(item.gxtname, item.model, "shotgun", 30, ind, item.price)
    else
        BuyAmmo(item.list, "shotgun", ind, item.price)
    end
end)

AddEventHandler("airportwars:weapons:buymachinegun", function(opt, list)
    local ind = opt.data.index
    local item = submachine[ind]
    if item.id ~= 6 then
		    BuyWeapon(item.gxtname, item.model, "submachine", 30, ind, item.price)
    else
        BuyAmmo(item.list, "submachine", ind, item.price)
    end
end)

AddEventHandler("airportwars:weapons:buyassaultrifle", function(opt, list)
    local ind = opt.data.index
    local item = assault[ind]
    if item.id ~= 4 then
		    BuyWeapon(item.gxtname, item.model, "assault", 30, ind, item.price)
    else
        BuyAmmo(item.list, "assault", ind, item.price)
    end
end)

AddEventHandler("airportwars:weapons:buysniperrifle", function(opt, list)
    local ind = opt.data.index
    local item = sniper[ind]
    if item.id ~= 3 then
		    BuyWeapon(item.gxtname, item.model, "sniper", 30, ind, item.price)
    else
        BuyAmmo(item.list, "sniper", ind, item.price)
    end
end)

AddEventHandler("airportwars:weapons:buyheavyweapon", function(opt, list)
    local ind = opt.data.index
    local item = heavy[ind]
		BuyWeapon(item.gxtname, item.model, "heavy", 3, ind, item.price)
end)

AddEventHandler("airportwars:weapons:buythrownweapon", function(opt, list)
    local ind = opt.data.index
    local item = thrown[ind]
		BuyWeapon(item.gxtname, item.model, "thrown", 1, ind, item.price)
end)

AddEventHandler("airportwars:weapons:buyspecialammo", function(opt, list)
    local ind = opt.data.index
    local item = special_ammo[ind]
		BuySpecialAmmo(item.list, "special_ammo", ind, item.price)
end)

RegisterNetEvent("airportwars:weapons:playerhavemoney")
AddEventHandler("airportwars:weapons:playerhavemoney", function(gxtname, model, doscaleform, ammo, ind, category)
		local originalopt = GetOpt(category, ind)
		local originalev = GetEvent(category)
		local retval, hudDamage, hudSpeed, hudCapacity, hudAccuracy, hudRange = FGetWeaponHudStats(originalopt.model)
    local opt = {
        type = 3,
        text = originalopt.name,
        desc = originalopt.desc,
        event = originalev,
        spriteactive = {"commonmenu", "shop_gunclub_icon_b"},
        sprite = {"commonmenu", "shop_gunclub_icon_a"},
				barsinfos = {hudDamage, hudSpeed, hudAccuracy, hudRange}
    }
		GiveWeaponToPed(PlayerPedId(), model, ammo, false, false)
		if (doscaleform) then
				TriggerWeaponPurchased(gxtname, model, ind, opt)
		end
		PlaySoundFrontend(-1, "WEAPON_PURCHASE", "HUD_AMMO_SHOP_SOUNDSET", 1)
end)

RegisterNetEvent("airportwars:weapons:playerhavemoneyforammo")
AddEventHandler("airportwars:weapons:playerhavemoneyforammo", function(weamodel, giveone)
		PlaySoundFrontend(-1, "WEAPON_AMMO_PURCHASE", "HUD_AMMO_SHOP_SOUNDSET", 1)
    if (giveone) then
		    AddAmmoToPed(PlayerPedId(), weamodel, 1)
    else
        AddAmmoToPed(PlayerPedId(), weamodel, 100)
    end
end)

RegisterNetEvent("airportwars:weapons:giveweapon")
AddEventHandler("airportwars:weapons:giveweapon", function(type, model)
		if (type == "temp") then
				GiveWeaponToPed(PlayerPedId(), model, 30, false, false)
		elseif (type == "perm") then
				GiveWeaponToPed(PlayerPedId(), model, 250, false, false)
		end
end)
---------------------------------------------------------------------------------------


-------------------------------------- THREADS ----------------------------------------
CreateThread(function()
		if (SETTINGS.FEATURES.SHOPS.ENABLE_WEAPONS) then
		    while true do
		        Wait(0)
		        local ammunation = nil
						if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
				        for i in ipairs(SETTINGS.LOCATIONS.SHOPS.ZANCUDO.WEAPONS) do
										ZWS = SETTINGS.LOCATIONS.SHOPS.ZANCUDO.WEAPONS[i]
										if (GetZoneAtCoords(GetEntityCoords(PlayerPedId())) == GetZoneAtCoords(ZWS[1], ZWS[2], ZWS[3])) then
												DrawMarker(0, ZWS[1], ZWS[2], ZWS[3], 0, 0, 0, 0, 0, 0, 0.75, 0.75, 0.75, SETTINGS.COLORS.ZANCUDOTEAM[1], SETTINGS.COLORS.ZANCUDOTEAM[2], SETTINGS.COLORS.ZANCUDOTEAM[3], 220, true, 0, 0, 0)
						            if Vdist(GetEntityCoords(PlayerPedId()), ZWS[1], ZWS[2], ZWS[3]) < 2 then
						                TriggerEvent("airportwars:weapons:menurequest")
						                ammunation = i
						            end
										end
				        end
						elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
								for i in ipairs(SETTINGS.LOCATIONS.SHOPS.AIRPORT.WEAPONS) do
										AWS = SETTINGS.LOCATIONS.SHOPS.AIRPORT.WEAPONS[i]
										if (GetZoneAtCoords(GetEntityCoords(PlayerPedId())) == GetZoneAtCoords(AWS[1], AWS[2], AWS[3])) then
												DrawMarker(0, AWS[1], AWS[2], AWS[3], 0, 0, 0, 0, 0, 0, 0.75, 0.75, 0.75, SETTINGS.COLORS.AIRPORTTEAM[1], SETTINGS.COLORS.AIRPORTTEAM[2], SETTINGS.COLORS.AIRPORTTEAM[3], 220, true, 0, 0, 0)
												if Vdist(GetEntityCoords(PlayerPedId()), AWS[1], AWS[2], AWS[3]) < 2 then
														TriggerEvent("airportwars:weapons:menurequest")
														ammunation = i
												end
										end
								end
						end
						if (ammunation == nil) then
							  TriggerEvent("theftvrp:menu:quit", "buy_wea")
						end
		    end
		end
end)

CreateThread(function()
    TriggerServerEvent("airportwars:stores:initialize", "ammunation")
    while (categories == nil) and (melee == nil) and (handgun == nil) and (shotgun == nil) and (submachine == nil) and (assault == nil) and (sniper == nil) and (heavy == nil) and (thrown == nil) and (special_ammo == nil) do
        Wait(0)
    end
		BaseArmoryMenu()
end)
---------------------------------------------------------------------------------------
ready.client_ammunation = true
