---------------------------------------------------------
-- RESSOURCE : Skin Shop - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Skin Shop for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local skinmodel = nil
local general = nil
local special = nil
local weaponsList = {-1568386805, -1312131151, 1834241177, 1672152130, 1305664598, 125959754, -1074790547, 961495388, -2084633992, 4208062921, -1357824103, -1063057011, 2132975508, 1649403952, 453432689, 3219281620, 1593441988, -1716589765, -1076751822, -771403250, 137902532, -598887786, 324215364, -619010992, 736523883, 2024373456, -270015777, 1121678507, 171789620, -1660422300, 2144741730, 3686625920, 1627465347, 100416529, 205991906, 177293209, -952879014, 487013001, 2017895192, -1654528753, -494615257, -1466123874, 984333226, -275439685, 317205821, -1569615261, -1716189206, 1737195953, 1317494643, -1786099057, -2067956739, 1141786504, -102323637, -1834847097, -102973651, -656458692, -581044007, -1951375401, -538741184, -1810795771, 419712736, -853065399, -1600701090, 615608432, 883325847, 1169823560, -1813897027, 741814745, -1420407917, 1119849093}
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
local function SkinShopMenu()
    TriggerEvent("theftvrp:menu:create", "buy_skin", "Outfit Changer", "SKINS", true)
    local opts = {}
    for k, v in pairs(general) do
        opts[k] = {
            type = v.type,
            text = v.name,
            desc = v.description,
            event = v.event,
            righttext = "$"..tostring(v.price)
        }
    end
    TriggerEvent("theftvrp:menu:setheaderscaleform", "buy_skin", false)
    --TriggerEvent("theftvrp:menu:setheadertodosprite", "buy_skin", false)
    --TriggerEvent("theftvrp:menu:spritecolor", "buy_skin", {73, 214, 101})
    TriggerEvent("theftvrp:menu:setheadersprite", "buy_skin", "shopui_title_lowendfashion2", "shopui_title_lowendfashion2")
		TriggerEvent("theftvrp:menu:writeText", "buy_skin", false)
    TriggerEvent("theftvrp:menu:setheaderbartextcolor", "buy_skin", 255, 255, 255, 255)
    TriggerEvent("theftvrp:menu:setmainlist", "buy_skin", "SKINS", opts, 10)
end

local function GetPedWeapons()
  	local playerWeapons = {}
    local ind = 0
		for k, v in pairs(weaponsList) do
  			local wep = HasPedGotWeapon(PlayerPedId(), v)
  			if wep then
            ind = ind + 1
            playerWeapons[ind] = {v, GetAmmoInPedWeapon(PlayerPedId(), v)}
            if (playerWeapons[GetWeapontypeGroup(v)] == nil) then
                playerWeapons[GetWeapontypeGroup(v)] = 0
            end
            playerWeapons[GetWeapontypeGroup(v)] = playerWeapons[GetWeapontypeGroup(v)] + 1
  			end
		end
  	return playerWeapons
end

local function GivePedWeapons(weaponsList)
    for k, v in pairs(weaponsList) do
        if (type(v) == "table") then
            GiveWeaponToPed(PlayerPedId(), v[1], math.floor(v[2]/weaponsList[GetWeapontypeGroup(v[1])]), 0, false)
        end
    end
end

local function SetSkin(skinmodel, reason)
    CreateThread(function()
        local weapons = GetPedWeapons()
        if (reason ~= "defaultskin") then
            skinmodel = tonumber(skinmodel)
        end
        RequestModel(skinmodel)
        while not HasModelLoaded(skinmodel) do
            Wait(0)
        end
        SetPlayerModel(NetworkPlayerIdToInt(), skinmodel)
        SetModelAsNoLongerNeeded(skinmodel)
        SetPedDefaultComponentVariation(PlayerPedId())
        SetTimeout(1000, function()
            PatchPlayer()
            GivePedWeapons(weapons)
        end)
        if (reason == "login") then
            --TriggerEvent("airportwars:notify", "BIN_PREVSKIN_APPLIED", -1, {}, "CHAR_HITCHER_GIRL", 0, "Outfit Changer", "", 0.3, false)
        elseif (reason == "purchased") then
            TriggerEvent("airportwars:notify", "BIN_NEWSKIN_APPLIED", -1, {}, "CHAR_HITCHER_GIRL", 0, "Outfit Changer", "", 0.3, true)
        elseif (reason == "defaultskin") then
            TriggerEvent("airportwars:notify", "BIN_DEFSKIN_APPLIED", -1, {}, "CHAR_HITCHER_GIRL", 0, "Outfit Changer", "", 0.3, true)
        end
    end)
end

local function RequestAllModels()
    local models = {}
    if ((general ~= nil) and (type(general) == "table")) then
        for k, v in pairs(general) do
            table.insert(models, v.model)
        end
    end
    if ((special ~= nil) and (type(special) == "table")) then
        for k, v in pairs(special) do
            table.insert(models, v.model)
        end
    end
    for i, v in ipairs(models) do
        RequestModel(v)
    end
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterNetEvent("airportwars:skinshop:getlist")
AddEventHandler("airportwars:skinshop:getlist", function(a, b)
    general = a
    special = b
end)

AddEventHandler("airportwars:skins:menurequest", function()
    TriggerEvent("theftvrp:menu:isopened", "buy_skin", function(response, menu)
        TriggerEvent("airportwars:skins:menuanswer", response, menu)
    end)
end)

AddEventHandler("airportwars:skins:menuanswer", function(response, menu)
    if canaccesstostores then
        if not (response) then
    				if IsPedOnFoot(PlayerPedId()) then
    			      TriggerEvent("airportwars:helptext", "Press ~INPUT_CONTEXT~ to browse skins.")
    			      if (IsControlJustPressed(0, 51)) then
    			          TriggerEvent("theftvrp:menu:open", "buy_skin")
    			      end
    				else
    						TriggerEvent("airportwars:helptext", "Get out of your vehicle in order to access the Outfit Changer.")
    				end
        end
    end
end)

AddEventHandler("airportwars:skinshop:specialcategorie", function(opt, list)
  	local ind = opt.data.index
  	local opts_specialskins = {}
  	for k, v in pairs(special) do
  			opts_specialskins[k] = {
  					type = v.type,
  					text = v.name,
  					desc = v.description,
  					event = v.event,
            max = 10,
  					righttext = "$" .. tostring(v.price)
  			}
  	end
  	TriggerEvent("theftvrp:menu:setnextlist", "buy_skin", "SPECIAL SKINS", opts_specialskins, 10)
end)

RegisterNetEvent("airportwars:skinshop:setdefaultskin")
AddEventHandler("airportwars:skinshop:setdefaultskin", function()
		if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
        SetSkin("S_M_Y_Marine_01", "defaultskin")
        TriggerServerEvent("airportwars:skinshop:resetlastskin", "S_M_Y_Marine_01")
    elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
        SetSkin("S_M_Y_Swat_01", "defaultskin")
        TriggerServerEvent("airportwars:skinshop:resetlastskin", "S_M_Y_Swat_01")
    end
end)

RegisterNetEvent("airportwars:skinshop:buyskin")
AddEventHandler("airportwars:skinshop:buyskin", function(opt, list)
    local ind = opt.data.index
    local item = general[ind]
		TriggerServerEvent("airportwars:skinshop:checkmoney", item.model, item.price, "general", ind)
end)

RegisterNetEvent("airportwars:skinshop:buyspecialskin")
AddEventHandler("airportwars:skinshop:buyspecialskin", function(opt, list)
    local ind = opt.data.index
    local item = special[ind]
		TriggerServerEvent("airportwars:skinshop:checkmoney", item.model, item.price, "special", ind)
end)

RegisterNetEvent("airportwars:skinshop:playerhavemoney")
AddEventHandler("airportwars:skinshop:playerhavemoney", function(skinmodel)
    PlaySoundFrontend(-1, "WEAPON_PURCHASE", "HUD_AMMO_SHOP_SOUNDSET", 1)
		SetSkin(skinmodel, "purchased")
end)

RegisterNetEvent("airportwars:skinshop:setlastskin")
AddEventHandler("airportwars:skinshop:setlastskin", function(skinmodel)
	  SetSkin(skinmodel, "login")
end)
---------------------------------------------------------------------------------------


-------------------------------------- THREADS ----------------------------------------
CreateThread(function()
		if (SETTINGS.FEATURES.SHOPS.ENABLE_SKINS) then
		    while true do
		        Wait(0)
		        local binco = nil
						if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
				        for i in ipairs(SETTINGS.LOCATIONS.SHOPS.ZANCUDO.SKINS) do
										ZSS = SETTINGS.LOCATIONS.SHOPS.ZANCUDO.SKINS[i]
                    if (GetZoneAtCoords(GetEntityCoords(PlayerPedId())) == GetZoneAtCoords(ZSS[1], ZSS[2], ZSS[3])) then
    										DrawMarker(0, ZSS[1], ZSS[2], ZSS[3], 0, 0, 0, 0, 0, 0, 0.75, 0.75, 0.75, SETTINGS.COLORS.ZANCUDOTEAM[1], SETTINGS.COLORS.ZANCUDOTEAM[2], SETTINGS.COLORS.ZANCUDOTEAM[3], 220, true, 0, 0, 0)
    				            if Vdist(GetEntityCoords(PlayerPedId()), ZSS[1], ZSS[2], ZSS[3]) < 2 then
    				                TriggerEvent("airportwars:skins:menurequest")
    				                binco = i
    				            end
                    end
				        end
						elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
								for i in ipairs(SETTINGS.LOCATIONS.SHOPS.AIRPORT.SKINS) do
										ASS = SETTINGS.LOCATIONS.SHOPS.AIRPORT.SKINS[i]
                    if (GetZoneAtCoords(GetEntityCoords(PlayerPedId())) == GetZoneAtCoords(ASS[1], ASS[2], ASS[3])) then
    										DrawMarker(0, ASS[1], ASS[2], ASS[3], 0, 0, 0, 0, 0, 0, 0.75, 0.75, 0.75, SETTINGS.COLORS.AIRPORTTEAM[1], SETTINGS.COLORS.AIRPORTTEAM[2], SETTINGS.COLORS.AIRPORTTEAM[3], 220, true, 0, 0, 0)
    										if Vdist(GetEntityCoords(PlayerPedId()), ASS[1], ASS[2], ASS[3]) < 2 then
    												TriggerEvent("airportwars:skins:menurequest")
    												binco = i
    										end
                    end
								end
						end
						if (binco == nil) then
							TriggerEvent("theftvrp:menu:quit", "buy_skin")
						end
		    end
		end
end)

CreateThread(function()
    TriggerServerEvent("airportwars:stores:initialize", "binco")
    while (general == nil) and (special == nil) do
        Wait(0)
    end
		SkinShopMenu()
    RequestAllModels()
end)
---------------------------------------------------------------------------------------
ready.client_binco = true
