---------------------------------------------------------
-- RESSOURCE : Vehicle Shop - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Vehicle Shop for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
currentvehicle = nil
blipcurrentvehicle = nil
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
local function VehicleShopMenu()
    TriggerEvent("theftvrp:menu:create", "buy_veh", "Vehicle Shop", "VEHICLES CATEGORIES", true)
    local opts = {}
    for k, v in pairs(categories) do
        opts[k] = {
            type = v.type,
            text = v.name,
            desc = v.desc,
            event = v.event,
            max = 10
        }
    end
    TriggerEvent("theftvrp:menu:setmainlist", "buy_veh", "VEHICLES CATEGORIES", opts, 10)
    TriggerEvent("theftvrp:menu:setheaderscaleform", "buy_veh", false)
    --TriggerEvent("theftvrp:menu:setheadertodosprite", "buy_veh", false)
    --TriggerEvent("theftvrp:menu:spritecolor", "buy_veh", {64, 156, 237})
    TriggerEvent("theftvrp:menu:setheadersprite", "buy_veh", "shopui_title_ie_modgarage", "shopui_title_ie_modgarage")
		TriggerEvent("theftvrp:menu:writeText", "buy_veh", false)
    TriggerEvent("theftvrp:menu:setheaderbartextcolor", "buy_veh", 255, 255, 255, 255)
end

local function GetVehSpawnLocation(type)
    if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
        if (type == "car") then
            return {-1804.163, 2990.953, 32.456, 107.233}
        elseif (type == "motorcycle") then
            return {-1859.404, 2950.740, 32.286, 17.182}
        elseif (type == "guncar") then
            return {-1789.764, 2990.335, 32.739, 95.039}
        elseif (type == "tank") then
            return {-1832.660, 2947.604, 33.362, 12.133}
        elseif (type == "plane") then
            return {-1964.383, 2834.337, 33.615, 62.906}
        elseif (type == "heli") then
            return {-1896.907, 2796.486, 33.190, 333.170}
        end
    elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
        if (type == "car") then
            return {-1005.012, -3014.289, 13.591, 25.316}
        elseif (type == "motorcycle") then
            return {-970.271, -3035.100, 13.418, 20.757}
        elseif (type == "guncar") then
            return {-960.410, -2962.299, 13.875, 93.768}
        elseif (type == "tank") then
            return {-959.347, -2990.852, 13.897, 146.986}
        elseif (type == "plane") then
            return {-874.990, -3215.012, 14.746, 61.311}
        elseif (type == "heli") then
            return {-892.124, -3039.183, 14.333, 141.060}
        end
    end
end

local function SpawnVehicle(type, model, blipid)
    CreateThread(function()
        TriggerEvent("theftvrp:menu:quit", "buy_veh")
        TriggerEvent("airportwars:notify", "PEG_VEH_COMING", -1, {}, "CHAR_PEGASUS_DELIVERY", 0, "Pegasus", "", 0.5, true)
        if (currentvehicle ~= nil) then
            if DoesEntityExist(currentvehicle) then
                DeleteEntity(currentvehicle)
            end
            currentvehicle = nil
        end
        if (blipcurrentvehicle ~= nil) then
            if DoesBlipExist(blipcurrentvehicle) then
                RemoveBlip(blipcurrentvehicle)
            end
            blipcurrentvehicle = nil
        end
        math.randomseed(tonumber(tostring(GetGameTimer()):reverse():sub(1,6)))
        local time = tonumber(tostring(math.random(10, 25)).."000")
        SetTimeout(time, function()
            RequestModel(model)
            while not HasModelLoaded(model) do
                Wait(0)
            end
            local spawnlocation = GetVehSpawnLocation(type)
            local vehiclebought = CreateVehicle(model, spawnlocation[1], spawnlocation[2], spawnlocation[3], spawnlocation[4], true, false)
            SetModelAsNoLongerNeeded(model)
            SetVehicleOnGroundProperly(vehiclebought)
            local netid = NetworkGetNetworkIdFromEntity(vehiclebought)
      			NetworkRegisterEntityAsNetworked(vehiclebought)
      			SetEntityAsMissionEntity(vehiclebought)
      			SetNetworkIdCanMigrate(netid, true)
      			SetNetworkIdExistsOnAllMachines(netid, true)
      			NetworkRequestControlOfEntity(vehiclebought)
            blipcurrentvehicle = AddBlipForEntity(vehiclebought)
            SetBlipSprite(blipcurrentvehicle, blipid)
            SetBlipColour(blipcurrentvehicle, 5)
            SetBlipDisplay(blipcurrentvehicle, 4)
            BeginTextCommandSetBlipName("STRING")
            AddTextComponentSubstringPlayerName("Personal Vehicle")
            EndTextCommandSetBlipName(blipcurrentvehicle)
            TriggerEvent("airportwars:notify", "PEG_VEH_DELIVERED", -1, {}, "CHAR_PEGASUS_DELIVERY", 0, "Pegasus", "", 1.0, true)
            currentvehicle = vehiclebought
        end)
    end)
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterNetEvent("airportwars:pegasus:getlist")
AddEventHandler("airportwars:pegasus:getlist", function(a, b, c, d, e, f, g, h)
    categories = a
    free = b
    armored = c
    military = d
    sports = e
    motorcycles = f
    planes = g
    helicopters = h
end)

AddEventHandler("airportwars:vehicles:menurequest", function()
    TriggerEvent("theftvrp:menu:isopened", "buy_veh", function(response, menu)
        TriggerEvent("airportwars:vehicles:menuanswer", response, menu)
    end)
end)

AddEventHandler("airportwars:vehicles:menuanswer", function(response, menu)
    if canaccesstostores then
        if not (response) then
    				if IsPedOnFoot(PlayerPedId()) then
    			      TriggerEvent("airportwars:helptext", "Press ~INPUT_CONTEXT~ to browse vehicles.")
    			      if (IsControlJustPressed(0, 51)) then
    			          TriggerEvent("theftvrp:menu:open", "buy_veh")
    			      end
    				else
    						TriggerEvent("airportwars:helptext", "Get out of your vehicle in order to access the Vehicle Shop.")
    				end
        end
    end
end)

AddEventHandler("airportwars:pegasus:categories", function(opt, list)
		local ind = opt.data.index
		local item = categories[ind]
    if item.id == 1 then
				local opts_free = {}
				for k, v in pairs(free) do
						opts_free[k] = {
								type = 1,
								text = v.name,
								desc = v.desc,
								event = v.event,
								righttext = v.showprice,
                max = 10
						}
				end
				TriggerEvent("theftvrp:menu:setnextlist", "buy_veh", "FREE VEHICLES", opts_free, 10)
		elseif item.id == 2 then
        local opts_armored = {}
        for k, v in pairs(armored) do
            opts_armored[k] = {
                type = 1,
                text = v.name,
                desc = v.desc,
                event = v.event,
                righttext = "$"..tostring(v.price),
                max = 10
            }
        end
        TriggerEvent("theftvrp:menu:setnextlist", "buy_veh", "ARMORED VEHICLES", opts_armored, 10)
		elseif item.id == 3 then
        local opts_military = {}
        for k, v in pairs(military) do
            opts_military[k] = {
                type = 1,
                text = v.name,
                desc = v.desc,
                event = v.event,
                righttext = "$"..tostring(v.price),
                max = 10
            }
        end
        TriggerEvent("theftvrp:menu:setnextlist", "buy_veh", "MILITARY VEHICLES", opts_military, 10)
		elseif item.id == 4 then
        local opts_sports = {}
        for k, v in pairs(sports) do
            opts_sports[k] = {
                type = 1,
                text = v.name,
                desc = v.desc,
                event = v.event,
                righttext = "$"..tostring(v.price),
                max = 10
            }
        end
        TriggerEvent("theftvrp:menu:setnextlist", "buy_veh", "SPORTS VEHICLES", opts_sports, 10)
		elseif item.id == 5 then
        local opts_motorcycles = {}
        for k, v in pairs(motorcycles) do
            opts_motorcycles[k] = {
                type = 1,
                text = v.name,
                desc = v.desc,
                event = v.event,
                righttext = "$"..tostring(v.price),
                max = 10
            }
        end
        TriggerEvent("theftvrp:menu:setnextlist", "buy_veh", "MOTORCYCLES", opts_motorcycles, 10)
		elseif item.id == 6 then
        local opts_planes = {}
        for k, v in pairs(planes) do
            opts_planes[k] = {
                type = 1,
                text = v.name,
                desc = v.desc,
                event = v.event,
                righttext = "$"..tostring(v.price),
                max = 10
            }
        end
        TriggerEvent("theftvrp:menu:setnextlist", "buy_veh", "PLANES", opts_planes, 10)
		elseif item.id == 7 then
        local opts_helicopters = {}
        for k, v in pairs(helicopters) do
            opts_helicopters[k] = {
                type = 1,
                text = v.name,
                desc = v.desc,
                event = v.event,
                righttext = "$"..tostring(v.price),
                max = 10
            }
        end
        TriggerEvent("theftvrp:menu:setnextlist", "buy_veh", "HELICOPTERS", opts_helicopters, 10)
    end
end)

AddEventHandler("airportwars:pegasus:buyfreevehicle", function(opt, list)
    local ind = opt.data.index
    local item = free[ind]
		TriggerServerEvent("airportwars:pegasus:checkmoney", "free", ind, item.type, item.model, item.blipid, item.price)
end)

AddEventHandler("airportwars:pegasus:buyarmoredvehicle", function(opt, list)
    local ind = opt.data.index
    local item = armored[ind]
		TriggerServerEvent("airportwars:pegasus:checkmoney", "armored", ind, item.type, item.model, item.blipid, item.price)
end)

AddEventHandler("airportwars:pegasus:buymilitaryvehicle", function(opt, list)
    local ind = opt.data.index
    local item = military[ind]
		TriggerServerEvent("airportwars:pegasus:checkmoney", "military", ind, item.type, item.model, item.blipid, item.price)
end)

AddEventHandler("airportwars:pegasus:buysportvehicle", function(opt, list)
    local ind = opt.data.index
    local item = sports[ind]
		TriggerServerEvent("airportwars:pegasus:checkmoney", "sports", ind, item.type, item.model, item.blipid, item.price)
end)

AddEventHandler("airportwars:pegasus:buymotorcycle", function(opt, list)
    local ind = opt.data.index
    local item = motorcycles[ind]
		TriggerServerEvent("airportwars:pegasus:checkmoney", "motorcycles", ind, item.type, item.model, item.blipid, item.price)
end)

AddEventHandler("airportwars:pegasus:buyplane", function(opt, list)
    local ind = opt.data.index
    local item = planes[ind]
		TriggerServerEvent("airportwars:pegasus:checkmoney", "planes", ind, item.type, item.model, item.blipid, item.price)
end)

AddEventHandler("airportwars:pegasus:buyhelicopter", function(opt, list)
    local ind = opt.data.index
    local item = helicopters[ind]
		TriggerServerEvent("airportwars:pegasus:checkmoney", "helicopters", ind, item.type, item.model, item.blipid, item.price)
end)

RegisterNetEvent("airportwars:pegasus:playerhavemoney")
AddEventHandler("airportwars:pegasus:playerhavemoney", function(type, model, blipid)
		SpawnVehicle(type, model, blipid)
end)
---------------------------------------------------------------------------------------


-------------------------------------- THREADS ----------------------------------------
CreateThread(function()
		if (SETTINGS.FEATURES.SHOPS.ENABLE_VEHICLES) then
		    while true do
		        Wait(0)
		        local pegasus = nil
						if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
				        for i in ipairs(SETTINGS.LOCATIONS.SHOPS.ZANCUDO.VEHICLES) do
										ZVS = SETTINGS.LOCATIONS.SHOPS.ZANCUDO.VEHICLES[i]
                    if (GetZoneAtCoords(GetEntityCoords(PlayerPedId())) == GetZoneAtCoords(ZVS[1], ZVS[2], ZVS[3])) then
    										DrawMarker(0, ZVS[1], ZVS[2], ZVS[3], 0, 0, 0, 0, 0, 0, 0.75, 0.75, 0.75, SETTINGS.COLORS.ZANCUDOTEAM[1], SETTINGS.COLORS.ZANCUDOTEAM[2], SETTINGS.COLORS.ZANCUDOTEAM[3], 220, true, 0, 0, 0)
    				            if Vdist(GetEntityCoords(PlayerPedId()), ZVS[1], ZVS[2], ZVS[3]) < 2 then
    				                TriggerEvent("airportwars:vehicles:menurequest")
    				                pegasus = i
    				            end
                    end
				        end
						elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
								for i in ipairs(SETTINGS.LOCATIONS.SHOPS.AIRPORT.VEHICLES) do
										AVS = SETTINGS.LOCATIONS.SHOPS.AIRPORT.VEHICLES[i]
                    if (GetZoneAtCoords(GetEntityCoords(PlayerPedId())) == GetZoneAtCoords(AVS[1], AVS[2], AVS[3])) then
    										DrawMarker(0, AVS[1], AVS[2], AVS[3], 0, 0, 0, 0, 0, 0, 0.75, 0.75, 0.75, SETTINGS.COLORS.AIRPORTTEAM[1], SETTINGS.COLORS.AIRPORTTEAM[2], SETTINGS.COLORS.AIRPORTTEAM[3], 220, true, 0, 0, 0)
    										if Vdist(GetEntityCoords(PlayerPedId()), AVS[1], AVS[2], AVS[3]) < 2 then
    												TriggerEvent("airportwars:vehicles:menurequest")
    												pegasus = i
    										end
                    end
								end
						end
						if (pegasus == nil) then
							  TriggerEvent("theftvrp:menu:quit", "buy_veh")
						end
		    end
		end
end)

CreateThread(function()
    while true do
        Wait(0)
        if (currentvehicle ~= nil) then
            if DoesEntityExist(currentvehicle) then
                if IsEntityAVehicle(currentvehicle) then
                    if not IsVehicleDriveable(currentvehicle, 0) then
                        SetEntityAsNoLongerNeeded(currentvehicle)
                        RemoveBlip(blipcurrentvehicle)
                        currentvehicle = nil
                        blipcurrentvehicle = nil
                        TriggerEvent("airportwars:notify", "PEG_VEH_DESTROYED", -1, {}, "CHAR_PEGASUS_DELIVERY", 0, "Pegasus", "", 0.5, true)
                    end
                end
            end
        end
    end
end)

CreateThread(function()
    TriggerServerEvent("airportwars:stores:initialize", "pegasus")
    while (categories == nil) and (free == nil) and (armored == nil) and (military == nil) and (sports == nil) and (motorcycles == nil) and (planes == nil) and (helicopters == nil) do
        Wait(0)
    end
		VehicleShopMenu()
end)
---------------------------------------------------------------------------------------
ready.client_pegasus = true
