---------------------------------------------------------
-- RESSOURCE : Interiors - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Add interiors enter/exit animations for the
-- Airport Wars server.
---------------------------------------------------------
local up = false
local dynamix = {}
local interiors = {
    {
        helptext = "Press ~INPUT_CONTEXT~ to access Bahamas Mamas.",
        maintext = "Bahamas Mamas",
        secondarytext = {
            text = "Entrée",
            r = 245,
            g = 80,
            b = 255,
        },
        initial = {
            x = -1388.642,
            y = -586.3759,
            z = 30.2188,
            zone = 321,
        },
        final = {
            x = -1387.484,
            y = -588.2400,
            z = 30.3195,
            h = 213.8071,
        },
        marker = {
            type = 0,
            r = 255,
            g = 18,
            b = 216,
        },
    },
    {
        helptext = "Press ~INPUT_CONTEXT~ to leave Bahamas Mamas.",
        maintext = "Los Santos",
        secondarytext = {
            text = GetLabelText(GetNameOfZone(GetEntityCoords(PlayerPedId()))),
            r = 93,
            g = 182,
            b = 229,
        },
        initial = {
            x = -1387.484,
            y = -588.2400,
            z = 30.3195,
            zone = 321,
        },
        final = {
            x = -1388.642,
            y = -586.3759,
            z = 30.2188,
            h = 33.9566,
        },
        marker = {
            type = 0,
            r = 255,
            g = 18,
            b = 216,
        },
    },
}

function StartTp(x, y, z, h)
    CreateThread(function()
        isintp = true
        DoScreenFadeOut(1000)
        NetworkFadeOutEntity(PlayerPedId(), true, false)
        Wait(1000)
        infos = true
        DoScreenFadeIn(0)
        SetEntityCoords(PlayerPedId(), x, y, z)
        SetEntityHeading(PlayerPedId(), h)
        Wait(2500)
        NetworkFadeInEntity(PlayerPedId(), true, false)
        Wait(500)
        infos = false
        DoScreenFadeOut(0)
        Wait(1000)
        DoScreenFadeIn(1000)
        Wait(1000)
        isintp = false
        mtext = nil
        stext = nil
        sr = nil
        sg = nil
        sb = nil
    end)
end

function MainText(text)
    Set_2dLayer(2)
    SetTextScale(0.0, 2.0)
    SetTextFont(6)
    SetTextColour(255, 255, 255, 255)
    SetTextRightJustify(1)
    SetTextWrap(0.60, 0.90)
    BeginTextCommandDisplayText("STRING")
    AddTextComponentSubstringPlayerName(text)
    EndTextCommandDisplayText(1.0, 0.70)
end

function SecondaryText(text)
    Set_2dLayer(2)
    SetTextScale(0.0, 2.0)
    SetTextFont(1)
    SetTextColour(sr, sg, sb, 255)
    SetTextRightJustify(1)
    SetTextWrap(0.65, 0.95)
    BeginTextCommandDisplayText("STRING")
    AddTextComponentSubstringPlayerName(text)
    EndTextCommandDisplayText(1.0, 0.77)
end

CreateThread(function()
    while true do
        Wait(0)
        for k, v in ipairs(interiors) do
            if (dynamix[v] == nil) then
                dynamix[v] = v.initial.z
            end
            if (GetZoneAtCoords(GetEntityCoords(PlayerPedId())) == v.initial.zone) then
                DrawMarker(v.marker.type, v.initial.x, v.initial.y, dynamix[v], 0, 0, 0, 0, 0, 0, 0.75, 0.75, 0.75, v.marker.r, v.marker.g, v.marker.b, 220, 0, 0, 0, 0)
                if dynamix[v] <= v.initial.z - 0.200 then
					up = true
				elseif dynamix[v] >= v.initial.z + 0.275 then
					up = false
				end
                if not up then
                    dynamix[v] = dynamix[v] - 0.005
                elseif up then
					dynamix[v] = dynamix[v] + 0.005
                end
                if Vdist(GetEntityCoords(PlayerPedId()), v.initial.x, v.initial.y, v.initial.z) < 1 then
                    TriggerEvent("airportwars:helptext", v.helptext)
                    if IsControlJustPressed(0, 51) then
                        mtext = v.maintext
                        stext = v.secondarytext.text
                        sr = v.secondarytext.r
                        sg = v.secondarytext.g
                        sb = v.secondarytext.b
                        StartTp(v.final.x, v.final.y, v.final.z, v.final.h)
                    end
                end
            end
        end
        if infos then
            if (mtext ~= nil) then
                MainText(mtext)
            end
            if (stext ~= nil) then
                SecondaryText(stext)
            end
            DrawRect(0.0, 0.0, 2.0, 2.0, 0, 0, 0, 255)
        end
        if isintp then
            HideHudAndRadarThisFrame()
            HideHelpTextThisFrame()
            DisableAllControlActions(0)
            DisableAllControlActions(1)
            DisableAllControlActions(2)
        end
    end
end)

ready.client_interiors = true
