-- Menu script

local player_name_gui = ""
local DisplayMenusThisFrame = true

-- functions

local function tablelength(table)
    if (type(table) == "table") then
        local t = 0
        for k, v in pairs(table) do
            t = t + 1
        end
        return t
    else
        return 0
    end
end

local function GetSafeZone()
    local resolution = {}
    local safezone = {}
    resolution.x, resolution.y = GetActiveScreenResolution()
    safezone.x = ((1.0 / resolution.x) * (resolution.x * ((1.0 / 20.0) * ((math.abs(GetSafeZoneSize() - 1.0)) * 10))))
    safezone.y = ((1.0 / resolution.y) * (resolution.y * ((1.0 / 20.0) * ((math.abs(GetSafeZoneSize() - 1.0)) * 10))))
    return safezone
end

local function GetGoodParameterForMenuGlare(fParam0, fParam1, fParam2)
  	local fVar0
  	if (fParam1 == fParam2) then
  		return fParam1
  	end
  	fVar0 = (fParam2 - fParam1)
  	fParam0 = (fParam0 - (ToFloat(Round(((fParam0 - fParam1) / fVar0))) * fVar0))
  	if (fParam0 < fParam1) then
  		fParam0 = (fParam0 + fVar0)
  	end
  	return fParam0
end

local function GetWidthOfPlayerName(name)
    BeginTextCommandWidth("STRING")
    SetTextFont(1)
    SetTextScale(0.0, 1.0)
    AddTextComponentSubstringPlayerName(name)
    return EndTextCommandGetWidth(1)
end

function DisableMenusThisFrame()
    DisplayMenusThisFrame = false
end

function IsPhoneOpened()
    if (iFruit == nil) or (iFruit.isOpened == nil) then
        return false
    end
		return iFruit.isOpened
end

CreateThread(function()
    while true do
        Wait(0)
        if not DisplayMenusThisFrame then
            DisplayMenusThisFrame = true
        end
    end
end)

function GetCorrectPlayerName()
    local name = NetworkPlayerGetName(NetworkPlayerIdToInt())
    local textwidth = GetWidthOfPlayerName(name)
    while textwidth > 0.225 + GetSafeZone().x do
        Wait(0)
        name = string.sub(name, 0, string.len(name)-1)
        textwidth = GetWidthOfPlayerName(name)
    end
    player_name_gui = name
end

-- Header
Header = {}
Header.__index = Header

function Header.create()
    local header = {}
    setmetatable(header, Header)
    header.doSprite = true
    header.sprite = {
        dict = "commonmenu",
        name = "interaction_bgd"
    }
    header.doScaleform = true
    header.scaleform = "mp_menu_glare"
    header.titleScale = 1.0
    header.height = 0.1
    header.showTitle = true
    header.fontType = 1
    header.centreTitle = true
	  header.doOffset = false
    header.spriteColor = false
    header.spriteColors = {}
    header.writeCount = true
    header.teamSelectionSettings = false
    return header
end

function Header.draw(self, y, Draw, Menu)
    if (self.spriteColor) then
        ScreenDrawPositionBegin(76, 84)
        ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
        Draw.rect(Menu.x, y + 0.0075, Menu.width, self.height-0.002, self.spriteColors[1], self.spriteColors[2], self.spriteColors[3], 255)
        ScreenDrawPositionEnd()
    end

    if (self.doSprite) then
        self.height = 0.093
        ScreenDrawPositionBegin(76, 84)
        ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
        Draw.sprite(self.sprite.dict, self.sprite.name, Menu.x + 0.1125, y + 0.055, Menu.width, self.height, -1, 255, 255, 255, 255)
        --Draw.sprite(self.sprite.dict, self.sprite.name, Menu.x + ((0.034722 * 3.0) + 0.05)*0.405, y + ((0.034722 * 3.0) + 0.05)*0.52, Menu.width, self.height, -1, 255, 255, 255, 255)
        ScreenDrawPositionEnd()
    end

    if (self.doScaleform) then
        self.height = 0.093
        ScreenDrawPositionBegin(76, 84)
        ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
        Draw.scaleform(self.scaleform, Menu.x+0.45, y+0.4575, 1.0, 1.0, 255, 255, 255, 255)
        ScreenDrawPositionEnd()
    end

    if (self.showTitle) then
        local xinset = 0
        if (self.centreTitle) then
            xinset = (Menu.width / 2)
        end
        ScreenDrawPositionBegin(76, 84)
        ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
        if (self.doOffset) then
      			Draw.text("STRING", {Menu.title}, Menu.x + xinset + 0.005, y + GetTextScaleHeight(self.titleScale, self.fontType) / 2 - 0.002 + 0.0135, {
      				font = self.fontType,
      				size = self.titleScale,
      				--[[wrap = {
      					start = Menu.x,
      					stop = Menu.x + Menu.width
      				},]]
      				centre = self.centreTitle
      			})
        elseif (self.teamSelectionSettings) then
            Draw.text("STRING", {Menu.title}, Menu.x + xinset-0.045, y + GetTextScaleHeight(self.titleScale, self.fontType) / 2 + 0.002, {
              font = self.fontType,
              size = self.titleScale,
              --[[wrap = {
      					start = Menu.x,
      					stop = Menu.x + Menu.width
      				},]]
              centre = self.centreTitle
            })
	      else
      			 -- function GetTextScaleHeight(size, p1) est UI::_GET_TEXT_SCALE_HEIGHT
      			Draw.text("STRING", {Menu.title}, Menu.x + xinset, y + GetTextScaleHeight(self.titleScale, self.fontType) / 2 - 0.002, {
      				font = self.fontType,
      				size = self.titleScale,
              --[[wrap = {
      					start = Menu.x,
      					stop = Menu.x + Menu.width
      				},]]
      				centre = self.centreTitle
      			})
	      end
        ScreenDrawPositionEnd()
    end
    return self.height + 0.005
end

HeaderBar = {}
HeaderBar.__index = HeaderBar

function HeaderBar.create(text, writecount)
    local headerbar = {}
    setmetatable(headerbar, HeaderBar)
    headerbar.showIndex = true
    headerbar.text = text
    if (headerbar.text == nil) then
        headerbar.text = "MENU"
    end
    headerbar.height = 0.034722
    headerbar.opacity = 255
    headerbar.textr, headerbar.textg, headerbar.textb, headerbar.texta = GetHudColour(116)
    headerbar.textoffsets = {
        x = 0.0046875,
        y = 0.0046875
    }
    headerbar.textproportion = 0.35
    headerbar.centreTitle = true
    if writecount == nil then
        headerbar.writeCount = true
    else
        headerbar.writeCount = writecount
    end
    return headerbar
end

function HeaderBar.draw(self, y, Draw, Menu)
    ScreenDrawPositionBegin(76, 84)
    ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
    Draw.rect(Menu.x, y, Menu.width, self.height, 0, 0, 0, self.opacity)
    local t = Menu.list.subtitle
    if (t == nil or type(t) ~= "string") then
        t = self.text
    end
    local text = Menu.headertitle
    Draw.text("STRING", {text}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
        color = {
            r = self.textr,
            g = self.textg,
            b = self.textb,
            a = self.texta
        },
        size = self.textproportion
    })
    if (self.writeCount) then
      if (Menu.list ~= nil and Menu.list.elementLimit ~= 0) then
          if (tablelength(Menu.list.list) >= Menu.list.elementLimit) then
              Draw.text("STRING", {tostring(Menu:getIndex()) .. " / " .. tostring(Menu:getLength())}, Menu.x, y + self.textoffsets.y, {
                  wrap = {
                      start = Menu.x,
                      stop = Menu.x + Menu.width - self.textoffsets.x
                  },
          		    color = {
                      r = self.textr,
                      g = self.textg,
                      b = self.textb,
                      a = self.texta
                  },
                  right = true,
                  size = self.textproportion
              })
          end
      end
    end
    ScreenDrawPositionEnd()
    return self.height
end

-- Option list
OptionList = {}
OptionList.__index = OptionList

function OptionList.readoptfromserialized(self, k, v)
    local optiontype = v.type
    local eventhandler = v.event
    local handler = function(a, list, mouse)
        local ev = a.ev
        local opt = {}
        for k,v in pairs(a.serialisation) do
            opt[v] = a[v]
        end
        opt.data = a.data
        TriggerEvent(ev, opt, mouse)
    end
    if optiontype == 0 then
        opt = SimpleOption.create(v.text, handler, v.desc, v.color)
    elseif optiontype == 1 then
        opt = OptionWithCustomRightText.create(v.text, handler, v.desc, v.righttext, v.barsinfos)
    elseif optiontype == 2 then
        opt = BoolOption.create(v.text, handler, v.desc, v.value)
    elseif optiontype == 3 then
        opt = BoolSpriteOption.create(v.text, handler, v.desc, v.value, v.spriteactive, v.sprite, v.barsinfos)
    elseif optiontype == 4 then
        opt = ListOption.create(v.text, handler, v.desc, v.value, v.list, v.callHandlerEveryUpdate)
    elseif optiontype == 5 then
        opt = SimpleOption.create(v.text, handler, v.desc, v.color)--RedirectOption.create(v.text, handler, v.desc)
    end
    opt.data = {
        index = k
    }
    opt.ev = eventhandler
    return opt
end

function OptionList.readlistfromserialized(optionlist, list)
    for k,v in pairs(list) do
        if (type(v) ~= "string") then
            optionlist.list[k] = optionlist.readoptfromserialized(optionlist, k, v)
        else
            optionlist.subtitle = v
        end
    end
end

function OptionList.create(title, list, maxelements, backevent)
    local optionlist = {}
    setmetatable(optionlist, OptionList)
    optionlist.title = title or "ERROR"
    optionlist.list = {}
    optionlist.subtitle = nil
    optionlist.backevent = backevent
    if (type(list) == "table") then
        optionlist.readlistfromserialized(optionlist, list)
    end
    optionlist.elementLimit = maxelements
    optionlist.graphicalIndex = 1
    optionlist.index = 1
    optionlist.drawstart = 1
    optionlist.drawend = optionlist.elementLimit
    optionlist.draw = OptionListdraw
    optionlist.drawlimit = 1000 * 60-- frames
    optionlist.drawlimittime = 0 -- do not touch
    return optionlist
end

function OptionList.length(self)
    return tablelength(self.optionlist)
end


function OptionList.draw(self, y, Draw, Menu)
    ScreenDrawPositionBegin(76, 84)
    ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
    self:updateDrawLimit()
    local ay = 0
    for i = self.drawstart, self.drawend do
        if (self.list[i] ~= nil) then
            ay = ay + self.list[i].height
        end
    end
    Draw.sprite("commonmenu", "gradient_bgd", Menu.x + (Menu.width/2), y + (ay/2), Menu.width, ay, 0, 255, 255, 255, 255)
    if (Menu.headertitle ~= self.title) then
        Menu.headertitle = self.title
    end
    local ny = y --+ 0.00078125 --TEST
    for i = self.drawstart, self.drawend do
        local k = i
        local v = self.list[i]
        if (v ~= nil) then
            local ishovered = false
            local active = k == self.drawstart + self.graphicalIndex -1
            local mouseData = {
                clicked = false,
                x = 0,
                y = 0
            }
            if (GetControlNormal(0, 239) > Menu.x + GetSafeZone().x and GetControlNormal(0, 239) < Menu.x + Menu.width + GetSafeZone().x and GetControlNormal(0, 240) > ny + GetSafeZone().y and GetControlNormal(0, 240) < ny + GetSafeZone().y + v.height) then
                ishovered = true
                mouseData.x = GetControlNormal(2, 239)
                mouseData.y = GetControlNormal(2, 240)
            end
            if (IsControlJustReleased(2, 237) and ishovered) then
                ishovered = false
                active = true
                mouseData.clicked = true
                self.graphicalIndex = k - self.drawstart + 1
                self.index = k
            end
            v:draw(ny, Draw, Menu, self, active, ishovered, mouseData)
            ny = ny + v.height
        end
    end
    ScreenDrawPositionEnd()
    return ay + 0.00078125
end

function OptionList.push(self, option)
    local opt = option
    opt.data = {
        index = tablelength(self.list)
    }
    table.insert(self.list, opt)
end

function OptionList.updateDrawLimit(self)
    --self.drawlimittime = self.drawlimittime + 1
end

function OptionList.keyPushed(self)
    self.drawlimittime = 0
end

function OptionList.listenKey(self)
    return true
end

function OptionList.control(self, ctrl, menu)
    if (ctrl == "select") then
        if (self.list[self.index].clicked ~= nil) then
            self.list[self.index]:clicked()
        end
        if (self.list[self.index].handler(self.list[self.index], self, {
                clicked = false,
                x = 0,
                y = 0
            }, menu) == false) then
            PlaySoundFrontend(-1, "ERROR", "HUD_FRONTEND_DEFAULT_SOUNDSET")
        else
            if (type(self.list[self.index].type) == "boolean") then
                PlaySoundFrontend(-1, "TOGGLE_ON", "HUD_FRONTEND_DEFAULT_SOUNDSET")
            else
                PlaySoundFrontend(-1, "SELECT", "HUD_FRONTEND_DEFAULT_SOUNDSET")
            end
        end
    end
    if (ctrl == "right") then
        local opt = self.list[self.index]
        if (opt.leftrightsupport) then
            opt:right()
            PlaySoundFrontend(-1, "NAV_LEFT_RIGHT", "HUD_FRONTEND_DEFAULT_SOUNDSET")
        end
    end
    if (ctrl == "left") then
        local opt = self.list[self.index]
        if (opt.leftrightsupport) then
            opt:left()
            PlaySoundFrontend(-1, "NAV_LEFT_RIGHT", "HUD_FRONTEND_DEFAULT_SOUNDSET")
        end
    end
    if (ctrl == "up" and self:listenKey()) then
        PlaySoundFrontend(-1, "NAV_UP_DOWN", "HUD_FRONTEND_DEFAULT_SOUNDSET")
        self:keyPushed()
        if (self.index == 1) then
            self.index = tablelength(self.list)
            self.drawstart = tablelength(self.list) - self.elementLimit + 1
            self.drawend = tablelength(self.list)
            self.graphicalIndex = self.elementLimit
        else
            self.index = self.index - 1
            self.graphicalIndex = self.graphicalIndex - 1
            if (self.graphicalIndex == 0) then
                self.graphicalIndex = 1
                self.drawstart = self.drawstart - 1
                self.drawend = self.drawend - 1
            end
        end
        --if (self.index == tablelength(self.list) + 1) then
        --    self.index = 1
        --end
    end
    if (ctrl == "down" and self:listenKey()) then
        PlaySoundFrontend(-1, "NAV_UP_DOWN", "HUD_FRONTEND_DEFAULT_SOUNDSET")
        self:keyPushed()
        if (self.index == tablelength(self.list)) then
            self.index = 1
            self.drawstart = 1
            self.drawend = self.elementLimit
            self.graphicalIndex = 1
        else
            self.graphicalIndex = self.graphicalIndex + 1
            self.index = self.index + 1
            if (self.graphicalIndex == self.elementLimit + 1) then
                self.graphicalIndex = self.elementLimit
                self.drawstart = self.drawstart + 1
                self.drawend = self.drawend + 1
            end
        end
        --self.index = self.index - 1
        --if (self.index == 0) then
        --    self.index = tablelength(self.list)
        --end
    end
end

function OptionList.getIndexOf(self, val)
    local index = nil
    for k,v in pairs(self.list) do
        if v == val then
            index = k
        end
    end
    return index
end

-- options
  -- Simple option
SimpleOption = {}
SimpleOption.__index = SimpleOption

function SimpleOption.create(text, handler, desc, color, barsinfos)
    local simpleoption = {}
    setmetatable(simpleoption, SimpleOption)
    simpleoption.type = ""
    simpleoption.barsinfos = barsinfos
    simpleoption.text = text
    simpleoption.handler = handler
    simpleoption.height = 0.034722
    simpleoption.leftrightsupport = false
    simpleoption.serialisation = {
        "desc", "text"
    }

    if (desc == nil) then
        desc = ""
    end
    simpleoption.desc = desc
    simpleoption.textoffsets = {
        x = 0.00390625,
        y = 0.00416664
    }
    simpleoption.textsize = 0.35
    if color ~= nil then
        simpleoption.backgroundcolor = {
            r = color.hover.r,
            g = color.hover.g,
            b = color.hover.b,
            a = color.hover.a
        }
        simpleoption.backgroundcolorActive = {
            r = color.active.r,
            g = color.active.g,
            b = color.active.b,
            a = color.active.a
        }
        simpleoption.textcolorActive = {
            r = 240,
            g = 240,
            b = 240
        }
    else
        simpleoption.backgroundcolorActive = {
            r = 240,
            g = 240,
            b = 240,
            a = 200
        }
        simpleoption.backgroundcolor = {
            r = 0,
            g = 0,
            b = 0,
            a = 80
        }
        simpleoption.textcolorActive = {
            r = 0,
            g = 0,
            b = 0
        }
    end
    simpleoption.backgroundcolorHover = {
        r = 255,
        g = 255,
        b = 255,
        a = 80
    }
    simpleoption.textcolor = {
        r = 240,
        g = 240,
        b = 240
    }
    return simpleoption
end

function SimpleOption.draw(self, y, Draw, Menu, OptionList, active, hover, mouseData)
    local backgroundcolor = nil
    local textcolor = nil
    if mouseData.clicked then
        self:handler(OptionList, mouseData)
    end
    if active then
        backgroundcolor = self.backgroundcolorActive
        textcolor = self.textcolorActive
    elseif hover then
        backgroundcolor = self.backgroundcolorHover
        textcolor = self.textcolor
    else
        backgroundcolor = self.backgroundcolor
        textcolor = self.textcolor
    end
    Draw.rect(Menu.x, y, Menu.width, self.height, backgroundcolor.r, backgroundcolor.g, backgroundcolor.b, backgroundcolor.a)
    Draw.text("STRING", {self.text}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
        size = self.textsize,
        color = textcolor
    })
end

OptionWithCustomRightText = {}
OptionWithCustomRightText.__index = OptionWithCustomRightText

function OptionWithCustomRightText.create(text, handler, desc, righttext, barsinfos)
    local u = SimpleOption.create(text, handler, desc, nil, barsinfos)
    setmetatable(u, OptionWithCustomRightText)
    u.right = righttext
    u.serialisation = {
        "desc", "text", "right"
    }
    return u
end

function OptionWithCustomRightText.draw(self, y, Draw, Menu, OptionList, active, hover, mouseData)
    local backgroundcolor = nil
    local textcolor = nil
    if mouseData.clicked then
        self.value = not self.value
        self:handler(OptionList, mouseData)
    end
    if active then
        backgroundcolor = self.backgroundcolorActive
        textcolor = self.textcolorActive
    elseif hover then
        backgroundcolor = self.backgroundcolorHover
        textcolor = self.textcolor
    else
        backgroundcolor = self.backgroundcolor
        textcolor = self.textcolor
    end
    Draw.rect(Menu.x, y, Menu.width, self.height, backgroundcolor.r, backgroundcolor.g, backgroundcolor.b, backgroundcolor.a)
    Draw.text("STRING", {self.text}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
        size = self.textsize,
        color = textcolor
    })
    Draw.text("STRING", {self.right}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
        size = self.textsize,
        color = textcolor,
        right = true,
        wrap = {
            start = Menu.x + self.textoffsets.x,
            stop = Menu.x + Menu.width - self.textoffsets.x
        }
    })
end

BoolOption = {}
BoolOption.__index = BoolOption

function BoolOption.create(text, handler, desc, value, barsinfos)
    local boolopt = SimpleOption.create(text, handler, desc, nil, barsinfos)
    setmetatable(boolopt, BoolOption)
    boolopt.type = true
    boolopt.leftrightsupport = true
    boolopt.serialisation = {
        "desc", "text", "value"
    }

    boolopt.value = false
    if (type(value) == "boolean") then
        boolopt.value = value
    end
    boolopt.spriteToUse = {
        crosswhite = {
            "commonmenu",
            "shop_box_blank",
            "shop_box_cross"
        },
        tickwhite = {
            "commonmenu",
            "shop_box_blank",
            "shop_box_tick"
        },
        crossblack = {
            "commonmenu",
            "shop_box_blankb",
            "shop_box_crossb"
        },
        tickblack = {
            "commonmenu",
            "shop_box_blankb",
            "shop_box_tickb"
        },
    }
    boolopt.spriteSizeWidth = 0.0230
    boolopt.spriteSizeHeight = 0.0425
    boolopt.spritegroup = "tick"
    return boolopt
end

function BoolOption.draw(self, y, Draw, Menu, OptionList, active, hover, mouseData)
    local backgroundcolor = nil
    local textcolor = nil
    if mouseData.clicked then
        self.value = not self.value
        self:handler(OptionList, mouseData)
        PlaySoundFrontend(-1, "TOGGLE_ON", "HUD_FRONTEND_DEFAULT_SOUNDSET")
    end
    if active then
        backgroundcolor = self.backgroundcolorActive
        textcolor = self.textcolorActive
    elseif hover then
        backgroundcolor = self.backgroundcolorHover
        textcolor = self.textcolor
    else
        backgroundcolor = self.backgroundcolor
        textcolor = self.textcolor
    end
    Draw.rect(Menu.x, y, Menu.width, self.height, backgroundcolor.r, backgroundcolor.g, backgroundcolor.b, backgroundcolor.a)
    Draw.text("STRING", {self.text}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
        size = self.textsize,
        color = textcolor
    })
    local sprites = self.spriteToUse[self.spritegroup .. (active and "black" or "white")]
    local spritedict = sprites[1]
    local spritename = self.value and sprites[3] or sprites[2]
    Draw.sprite(spritedict, spritename, Menu.x + Menu.width - (self.spriteSizeWidth / 2), y + self.spriteSizeHeight / 2 - 0.004, self.spriteSizeWidth, self.spriteSizeHeight, 0, 255, 255, 255, 255)
end

function BoolOption.clicked(self)
    self.value = not self.value
end

function BoolOption.right(self)
    --self.value = not self.value
end

function BoolOption.left(self)
    --self.value = not self.value
end

BoolSpriteOption = {}
BoolSpriteOption.__index = BoolSpriteOption

function BoolSpriteOption.create(text, handler, desc, value, spriteactive, sprite, barsinfos)
    local u = BoolOption.create(text, handler, desc, value, barsinfos)
    setmetatable(u, BoolSpriteOption)
    u.spriteactive = spriteactive
    u.sprite = sprite
    return u
end

function BoolSpriteOption.draw(self, y, Draw, Menu, OptionList, active, hover, mouseData)
    local backgroundcolor = nil
    local textcolor = nil
    if mouseData.clicked then
        self.value = not self.value
        self:handler(OptionList, mouseData)
    end
    if active then
        backgroundcolor = self.backgroundcolorActive
        textcolor = self.textcolorActive
    elseif hover then
        backgroundcolor = self.backgroundcolorHover
        textcolor = self.textcolor
    else
        backgroundcolor = self.backgroundcolor
        textcolor = self.textcolor
    end
    Draw.rect(Menu.x, y, Menu.width, self.height, backgroundcolor.r, backgroundcolor.g, backgroundcolor.b, backgroundcolor.a)
    Draw.text("STRING", {self.text}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
        size = self.textsize,
        color = textcolor
    })
    if (self.value) then
        local sprites = active and self.spriteactive or self.sprite
        local spritedict = sprites[1]
        local spritename = sprites[2]
        Draw.sprite(spritedict, spritename, Menu.x + Menu.width - (self.spriteSizeWidth / 2), y + self.spriteSizeHeight / 2 - 0.005, self.spriteSizeWidth, self.spriteSizeHeight, 0, 255, 255, 255, 255)
    else
        local sprites = active and self.spriteactive or self.sprite
        local spritedict = sprites[1]
        local spritename = sprites[2]
        Draw.sprite(spritedict, spritename, Menu.x + Menu.width - (self.spriteSizeWidth / 2), y + self.spriteSizeHeight / 2 - 0.005, self.spriteSizeWidth, self.spriteSizeHeight, 0, 255, 255, 255, 255)
    end
end

function BoolSpriteOption.clicked(self)
    self.value = not self.value
end

function BoolSpriteOption.right(self)
    --self.value = not self.value
end

function BoolSpriteOption.left(self)
    --self.value = not self.value
end

ListOption = {}
ListOption.__index = ListOption
function ListOption.create(text, handler, desc, value, list, callHandlerEveryUpdate)
    local u = SimpleOption.create(text, handler, desc)
    setmetatable(u, ListOption)
    u.serialisation = {
        "desc", "text", "index", "options"
    }
    u.options = list
    u.index = 1
    if (type(value) == "number") then
        u.index = value
    end
    u.leftrightsupport = true
    u.leftTextOffset = 0.002
    u.rightTextOffset = 0.002
    local screenx, screeny = GetScreenResolution()
    local arrowrightres = vector3(32.0 * 0.5 - 2.0, 32.0 * 0.5 - 2.0, 0.0)
    local arrowrightresx, arrowrightresy = arrowrightres.x, arrowrightres.y
    local widtharrowright = ((arrowrightresx / ToFloat(screenx)) * ToFloat((screenx / screeny)))
    local heightarrowright = (((arrowrightresy / ToFloat(screeny)) / (arrowrightresx / ToFloat(screenx))) * widtharrowright)
    local arrowleftres = vector3(32.0 * 0.5 - 2.0, 32.0 * 0.5 - 2.0, 0.0)
    local arrowleftresx, arrowleftresy = arrowleftres.x, arrowleftres.y
    local widtharrowleft = ((arrowleftresx / ToFloat(screenx)) * ToFloat((screenx / screeny)))
    local heightarrowleft = (((arrowleftresy / ToFloat(screeny)) / (arrowleftresx / ToFloat(screenx))) * widtharrowleft)
    if not (GetIsWidescreen()) then
        widtharrowright = (widtharrowright * 1.33)
        widtharrowleft = (widtharrowleft * 1.33)
    end
    u.spriteRightWidth = widtharrowright*0.000000001
    u.spriteRightHeight = heightarrowright*0.000000001
    u.spriteLeftWidth = widtharrowleft*0.000000001
    u.spriteLeftHeight = heightarrowleft*0.000000001
    u.spriteSizeWidth = widtharrowright*0.000000001
    u.spriteSizeHeight = heightarrowright*0.000000001
    u.textRightOffset = 0.00078125 * 7.0
    u.textLeftOffset = 0.00078125 * 7.0
    u.callHandlerEveryUpdate = callHandlerEveryUpdate
    u.handlerParams = {
        OptionList = "",
        Menu = ""
    }
    return u
end

function ListOption.draw(self, y, Draw, Menu, OptionList, active, hover, mouseData)
    local backgroundcolor = nil
    local textcolor = nil
    if active then
        backgroundcolor = self.backgroundcolorActive
        textcolor = self.textcolorActive
		    drawsprite = true
    elseif hover then
        backgroundcolor = self.backgroundcolorHover
        textcolor = self.textcolor
		    drawsprite = false
    else
        backgroundcolor = self.backgroundcolor
        textcolor = self.textcolor
		    drawsprite = false
    end
    self.handlerParams.OptionList = OptionList
    self.handlerParams.Menu = Menu
    Draw.rect(Menu.x, y, Menu.width, self.height, backgroundcolor.r, backgroundcolor.g, backgroundcolor.b, backgroundcolor.a)
    BeginTextCommandWidth("STRING")
    AddTextComponentSubstringPlayerName(self.options[self.index])
    SetTextFont(0)
    SetTextScale(self.textsize, self.textsize)
    local textwidth = EndTextCommandGetWidth(1)
    Draw.text("STRING", {self.text}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
        size = self.textsize,
        color = textcolor
    }, true)
    -- Right part
	if drawsprite then
      Draw.text("STRING", {self.options[self.index]}, Menu.x - self.spriteLeftWidth, y + 0.00416664, {
  		size = self.textsize,
  		color = textcolor,
  		right = true,
          wrap = {
              start = Menu.x - self.spriteLeftWidth,
              stop = (((Menu.x + 0.0046875) + (0.0 + (((((Menu.x + Menu.width) - 0.0046875) - (Menu.x + 0.0046875)) - (0.0 + (0.0 + self.spriteRightWidth))) + (0.00078125 * 1.0)))) + (self.spriteRightWidth * 0.5)) - self.textRightOffset--Menu.x + Menu.width - self.spriteLeftWidth + self.rightTextOffset * 0.5 - self.textoffsets.x * 0.3725
          }
    	})
      Draw.sprite("commonmenu", "arrowright", (((Menu.x + 0.0046875) + (0.0 + (((((Menu.x + Menu.width) - 0.0046875) - (Menu.x + 0.0046875)) - (0.0 + (0.0 + self.spriteRightWidth))) + (0.00078125 * 1.0)))) + (self.spriteRightWidth * 0.5)), y + 0.034722*0.5, self.spriteRightWidth, self.spriteRightHeight, 0, textcolor.r, textcolor.g, textcolor.b, 255)
    	Draw.sprite("commonmenu", "arrowleft", --[[Menu.x + Menu.width - textwidth - self.spriteLeftWidth - 0.0046875]]Menu.x + Menu.width - ((textwidth + 0.0046875*0.5)) - self.spriteLeftWidth - self.rightTextOffset * 0.5 - self.textLeftOffset * 0.8, ((y) +(0.034722*0.5)), self.spriteLeftWidth, self.spriteLeftHeight, 0, textcolor.r, textcolor.g, textcolor.b, 255)
  else
      Draw.text("STRING", {self.options[self.index]}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
  		size = self.textsize,
  		color = textcolor,
  		right = true,
          wrap = {
              start = Menu.x,
              stop = Menu.x + Menu.width - self.spriteLeftWidth + self.rightTextOffset + 0.005
          }
  	  })
  end
	if (mouseData.clicked) then
        if (mouseData.x > (Menu.x + GetSafeZone().x + Menu.width - (self.spriteRightWidth * 0.5) - self.textoffsets.x * 0.5) - 0.0075) and (mouseData.x < (Menu.x + GetSafeZone().x + Menu.width - (self.spriteRightWidth * 0.5) - self.textoffsets.x * 0.5) + 0.0075) then
            Menu:right()
        end
        if (mouseData.x > (Menu.x + GetSafeZone().x + Menu.width - textwidth - self.spriteLeftWidth - 0.0046875 * 0.5) - 0.0075) and (mouseData.x < (Menu.x + GetSafeZone().x + Menu.width - textwidth - self.spriteLeftWidth - 0.0046875 * 0.5) + 0.0075) then
            Menu:left()
        end
    end
end

function ListOption.left(self)
    self.index = self.index - 1
    if (self.index == 0) then
        self.index = tablelength(self.options)
    end
    self:update()
end

function ListOption.right(self)
    self.index = self.index + 1
    if (self.index == tablelength(self.options) + 1) then
        self.index = 1
    end
    self:update()
end

function ListOption.update(self)
    if (self.callHandlerEveryUpdate) then
        self.handler(self, self.handlerParams.OptionList, {
            x = 0,
            y = 0,
            clicked = false
        })
    end
end

RedirectOption = {}
RedirectOption.__index = RedirectOption

function RedirectOption.create(text, handler, desc)
    local u = SimpleOption.create(text, handler, desc)
    setmetatable(u, RedirectOption)
    u.giveMenuToHandler = true
    u.spriteSizeWidth = 0.015
    u.spriteSizeHeight = 0.030
    return u
end

function RedirectOption.draw(self, y, Draw, Menu, OptionList, active, hover, mouseData)
    local backgroundcolor = nil
    local textcolor = nil
    if mouseData.clicked then
        self.value = not self.value
        self:handler(OptionList, mouseData, Menu)
    end
    if active then
        backgroundcolor = self.backgroundcolorActive
        textcolor = self.textcolorActive
    elseif hover then
        backgroundcolor = self.backgroundcolorHover
        textcolor = self.textcolor
    else
        backgroundcolor = self.backgroundcolor
        textcolor = self.textcolor
    end
    Draw.rect(Menu.x, y, Menu.width, self.height, backgroundcolor.r, backgroundcolor.g, backgroundcolor.b, backgroundcolor.a)
    Draw.sprite("commonmenu", "arrowright", Menu.x + Menu.width - (self.spriteSizeWidth / 2), y + self.spriteSizeHeight / 2, self.spriteSizeWidth, self.spriteSizeHeight, 0, textcolor.r, textcolor.g, textcolor.b, 255)
    Draw.text("STRING", {self.text}, Menu.x + self.textoffsets.x, y + self.textoffsets.y, {
        size = self.textsize,
        color = textcolor
    })
end

DescriptionBar = {}
DescriptionBar.__index = DescriptionBar

function DescriptionBar.create()
    local description = {}
    setmetatable(description, DescriptionBar)
    return description
end

function DescriptionBar.draw(self, y, Draw, Menu)
    if (Menu.list ~= nil and Menu.list ~= "" and Menu.list.index ~= nil and Menu.list.index > 0 and Menu.list.list[Menu.list.index] ~= nil and Menu.list.list[Menu.list.index].desc ~= nil and Menu.list.list[Menu.list.index].desc ~= "") then
        ScreenDrawPositionBegin(76, 84)
        ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
        Draw.rect(Menu.x, y+0.003, Menu.width, 0.00277776, GetHudColour(2))
        ScreenDrawPositionEnd()
    end
    return 0.00277776
end

-- Description reader
Description = {}
Description.__index = Description

function Description.create()
    local description = {}
    setmetatable(description, Description)
    description.font = 0
    description.scale = 0.35
    description.offsetX = 0.0046875
    description.offsetY = 0.0046875
    description.gradientOffsetY = 0.01
    description.gradientInsetY = 0.01
    return description
end

function Description.draw(self, y, Draw, Menu)
    if (Menu.list ~= "" and Menu.list.index ~= nil and Menu.list.index > 0 and Menu.list.list ~= nil and Menu.list.list[Menu.list.index] ~= nil) then
        local d = Menu.list.list[Menu.list.index].desc
        if (d ~= "") then
            ScreenDrawPositionBegin(76, 84)
            ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
            BeginTextCommandLineCount("STRING")
            AddTextComponentSubstringPlayerName(d)
            SetTextFont(self.font)
            SetTextScale(self.scale, self.scale)
            SetTextWrap(Menu.x, Menu.x + Menu.width - self.offsetX)
            local lines = GetTextScreenLineCount(Menu.x + self.offsetX, y + self.offsetY)
            Draw.sprite("CommonMenu", "Gradient_Bgd", (Menu.x + (Menu.width * 0.5)), (((y + self.offsetY) + ((((GetTextScaleHeight(self.scale, self.font) * ToFloat(lines)) + (0.00138888 * 13)) + ((0.00138888 * 5) * ToFloat((lines - 1)))) * 0.5)) - 0.00138888)-0.00277776, Menu.width, (((GetTextScaleHeight(self.scale, self.font) * ToFloat(lines)) + (0.00138888 * 13)) + ((0.00138888 * 5) * ToFloat((lines - 1)))), 0, GetHudColour(140))
            Draw.text("STRING", {d}, Menu.x + self.offsetX, y + 0.00277776*2, {
                size = self.scale,
                font = self.font,
                wrap = {
                    start = Menu.x,
                    stop = ((Menu.x + Menu.width) - self.offsetX)
                }
            })
            ScreenDrawPositionEnd()
            return (((GetTextScaleHeight(self.scale, self.font) * ToFloat(lines)) + (0.00138888 * 13)) + ((0.00138888 * 5) * ToFloat((lines - 1)))) + 0.00277776
        end
    end
    return 0.0
end

-- Up and down
UpAndDown = {}
UpAndDown.__index = UpAndDown

function UpAndDown.create()
    local u = {}
    setmetatable(u, UpAndDown)
    u.height = 0.034722
    u.backgroundColor = {
        r = 0,
        g = 0,
        b = 0,
        a = 204
    }
    return u
end

function UpAndDown.draw(self, y, Draw, Menu)
    if (Menu.list ~= nil and Menu.list.elementLimit ~= 0) then
        if (tablelength(Menu.list.list) >= Menu.list.elementLimit) then
            ScreenDrawPositionBegin(76, 84)
            ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
            Draw.rect(Menu.x, y, Menu.width, self.height, 0, 0, 0, 204)
            local ScreenX, ScreenY = GetScreenResolution()
            local UpAndDownRes = vector3(GetTextureResolution("commonmenu", "shop_arrows_upANDdown").x * 0.5, GetTextureResolution("commonmenu", "shop_arrows_upANDdown").y * 0.5, 0.0)
            Draw.sprite("CommonMenu", "shop_arrows_upANDdown", (Menu.x + (Menu.width * 0.5)), y + (self.height * 0.5), (UpAndDownRes.x / ToFloat(ScreenX)), (UpAndDownRes.y / ToFloat(ScreenY)), 0.0, GetHudColour(1))
            if IsControlJustReleased(0, 237) then
                if (GetControlNormal(0, 239) > (Menu.x + GetSafeZone().x)) and (GetControlNormal(0, 239) < (Menu.x + Menu.width + GetSafeZone().x)) and (GetControlNormal(0, 240) > y + (self.height * 0.5) + GetSafeZone().y - 0.0175) and (GetControlNormal(0, 240) < y + (self.height * 0.5) + GetSafeZone().y - 0.0025) then
                    Menu:up()
                end
                if (GetControlNormal(0, 239) > (Menu.x + GetSafeZone().x)) and (GetControlNormal(0, 239) < (Menu.x + Menu.width + GetSafeZone().x)) and (GetControlNormal(0, 240) > y + (self.height * 0.5) + GetSafeZone().y - 0.0025) and (GetControlNormal(0, 240) < y + (self.height * 0.5) + GetSafeZone().y + 0.01) then
                    Menu:down()
                end
            end
            ScreenDrawPositionEnd()
            return self.height
        end
    end
    return 0.0
end

-- Infos reader
Infos = {}
Infos.__index = Infos

function Infos.create()
    local infos = {}
    setmetatable(infos, Infos)
    infos.height = 0.034722
    infos.font = 0
    infos.scale = 0.35
    infos.offsetX = 0.0046875
    infos.offsetY = 0.0046875
    infos.gradientOffsetY = 0.01
    infos.gradientInsetY = 0.01
    return infos
end

function Infos.draw(self, y, Draw, Menu)
    if (Menu.list ~= "" and Menu.list.index ~= nil and Menu.list.index > 0 and Menu.list.list ~= nil and Menu.list.list[Menu.list.index] ~= nil) then
        if (Menu.list.list[Menu.list.index].barsinfos ~= nil) then
            if (Menu.list.list[Menu.list.index].barsinfos[1] ~= nil) then
                ScreenDrawPositionBegin(76, 84)
                ScreenDrawPositionRatio(0.0, 0.0, 0.0, 0.0)
                y = y + 0.00277776 * 0.5
                local fakeY = y
                local barsinfos = Menu.list.list[Menu.list.index].barsinfos
                BeginTextCommandDisplayText("PM_DAMAGE")
                SetTextColour(GetHudColour(1))
                SetTextScale(0.0, self.scale)
                SetTextFont(self.font)
                EndTextCommandDisplayText(Menu.x + self.offsetX, (self.offsetY + fakeY), 0)
                fakeY = (fakeY + 0.034722)
                BeginTextCommandDisplayText("PM_FIRERATE")
                SetTextColour(GetHudColour(1))
                SetTextScale(0.0, self.scale)
                SetTextFont(self.font)
                EndTextCommandDisplayText(Menu.x + self.offsetX, (self.offsetY + fakeY), 0)
                fakeY = (fakeY + 0.034722)
                BeginTextCommandDisplayText("PM_ACCURACY")
                SetTextColour(GetHudColour(1))
                SetTextScale(0.0, self.scale)
                SetTextFont(self.font)
                EndTextCommandDisplayText(Menu.x + self.offsetX, (self.offsetY + fakeY), 0)
                fakeY = (fakeY + 0.034722)
                BeginTextCommandDisplayText("PM_RANGE")
                SetTextColour(GetHudColour(1))
                SetTextScale(0.0, self.scale)
                SetTextFont(self.font)
                EndTextCommandDisplayText(Menu.x + self.offsetX, (self.offsetY + fakeY), 0)
                fakeY = (fakeY + 0.034722)
                Draw.rect(Menu.x, y, Menu.width, self.height*4 + self.offsetY, 0, 0, 0, 184)
                Draw.rect((Menu.x + (0.00078125 * 150.0)), ((0.00138888 * -89.0) + fakeY), (0.00078125 * (125 - 8)), (0.00138888 * 6.0), GetHudColour(3))
                fakeY = (fakeY + 0.034722)
                Draw.rect((Menu.x + (0.00078125 * 150.0)), ((0.00138888 * -89.0) + fakeY), (0.00078125 * (125 - 8)), (0.00138888 * 6.0), GetHudColour(3))
                fakeY = (fakeY + 0.034722)
                Draw.rect((Menu.x + (0.00078125 * 150.0)), ((0.00138888 * -89.0) + fakeY), (0.00078125 * (125 - 8)), (0.00138888 * 6.0), GetHudColour(3))
                fakeY = (fakeY + 0.034722)
                Draw.rect((Menu.x + (0.00078125 * 150.0)), ((0.00138888 * -89.0) + fakeY), (0.00078125 * (125 - 8)), (0.00138888 * 6.0), GetHudColour(3))
                local infos = {barsinfos[1], barsinfos[2], barsinfos[3], barsinfos[4]}
                infos[1] = (0.00078125 * ((((125 - 8)) / 100.0) * ToFloat(barsinfos[1])))
        				infos[1] = (infos[1] + (infos[1] * (ToFloat(0) / 100.0)))
                Draw.rect((Menu.x + (0.00078125 * 150)), ((0.00138888 * -89.0) + fakeY - (0.034722*3)), infos[1], (0.00138888 * 6.0), GetHudColour(1))
                infos[2] = (0.00078125 * ((((125 - 8)) / 100.0) * ToFloat(barsinfos[2])))
        				infos[2] = (infos[2] + (infos[2] * (ToFloat(0) / 100.0)))
                Draw.rect((Menu.x + (0.00078125 * 150)), ((0.00138888 * -89.0) + fakeY - (0.034722*2)), infos[2], (0.00138888 * 6.0), GetHudColour(1))
                infos[3] = (0.00078125 * ((((125 - 8)) / 100.0) * ToFloat(barsinfos[3])))
        				infos[3] = (infos[3] + (infos[3] * (ToFloat(0) / 100.0)))
                Draw.rect((Menu.x + (0.00078125 * 150)), ((0.00138888 * -89.0) + fakeY - (0.034722*1)), infos[3], (0.00138888 * 6.0), GetHudColour(1))
                infos[4] = (0.00078125 * ((((125 - 8)) / 100.0) * ToFloat(barsinfos[4])))
        				infos[4] = (infos[4] + (infos[4] * (ToFloat(0) / 100.0)))
                Draw.rect((Menu.x + (0.00078125 * 150)), ((0.00138888 * -89.0) + fakeY - (0.034722*0)), infos[4], (0.00138888 * 6.0), GetHudColour(1))
                ScreenDrawPositionEnd()
                return self.height*4 + self.offsetY + 0.00277776
            end
        end
    end
    return 0.0
end

-- Menu
Menu = {}
Menu.__index = Menu

function Menu.create(title)
    local menu = {}
    setmetatable(menu, Menu)
    menu.title = title
    menu.x = 0.00
    menu.y = 0.00
    menu.width = 0.225
    --local ratio = GetAspectRatio()
    --if (ratio < 1.77777) then
    --    menu.width = (0.225 * ((16.0/9.0) / ratio))
    --end
    menu.headerElements = {}
    menu.list = ""
    menu.headertitle = "ERROR"
    menu.backlist = {}
    menu.bottomElements = {}

    menu.key = 244

    menu.canUserOpenIt = false
    menu.canUserCloseIt = true

    menu.enableCamMoving = false
    menu.enableCamMovingWithRightClick = true

    menu.isOpened = false

    menu.height = 0

    menu.closeTime = 0
    menu.openTime = 0
    menu.openTimeLimit = 0 -- 60 10
    menu.listenKeys = true -- A ne pas toucher
    menu.backevent = nil
    menu.teamSelectionSettings = false
    menu.instructButtons = nil
    menu.instructButtonsIndex = 0
    return menu
end

function Menu.draw(self)
    if self.isOpened then
        local Draw = { scaleformHandles = {} }
        function Draw.rect(x,y,width,height,r,g,b,a)
            DrawRect(x + width/2, y + height/2, width, height, r, g, b, a)
        end
        function Draw.text(entry, elements, x, y, style)
            if style == nil then
                style = {}
            end
            SetTextFont(style.font == nil and 0 or style.font)
            SetTextScale(0.0, (style.size == nil) and 1.0 or style.size)
            SetTextProportional(1)
            SetTextLeading(2)
            if style.color ~= nil then
                SetTextColour(style.color.r ~= nil and style.color.r or 255, style.color.g ~= nil and style.color.g or 255, style.color.b ~= nil and style.color.b or 255, style.color.a ~= nil and style.color.a or 255)
            else
                SetTextColour(GetHudColour(1))
            end
            if style.shadow ~= nil then
                SetTextDropShadow(style.shadow.distance ~= nil and style.shadow.distance or 0, style.shadow.r ~= nil and style.shadow.r or 0, style.shadow.g ~= nil and style.shadow.g or 0, style.shadow.b ~= nil and style.shadow.b or 0, style.shadow.a ~= nil and style.shadow.a or 255)
            end
            if style.border ~= nil then
                SetTextEdge(style.border.size ~= nil and style.border.size or 1, style.border.r ~= nil and style.border.r or 0, style.border.g ~= nil and style.border.g or 0, style.border.b ~= nil and style.border.b or 0, style.border.a ~= nil and style.shadow.a or 255)
            end
            if style.wrap ~= nil then
                SetTextWrap(style.wrap.start ~= nil and style.wrap.start or 0, style.wrap.stop ~= nil and style.wrap.stop or 1)
            end
            if style.centre ~= nil and style.centre then
                SetTextCentre(true)
            end
            if style.right ~= nil and style.right then
                SetTextRightJustify(true)
            end
            if style.outline ~= nil and style.outline then
                SetTextOutline()
            end
            BeginTextCommandDisplayText(entry)
            for _, element in ipairs(elements) do
                if element == "player_name" and player_name_gui == "" then GetCorrectPlayerName() end
                if element == "player_name" then element = player_name_gui end
                AddTextComponentSubstringPlayerName(element)
            end
            EndTextCommandDisplayText(x, y)
        end
        function Draw.scaleform(scaleform, x, y, w, h, r, g, b, a)
            Draw.scaleformHandles[scaleform] = RequestScaleformMovie(scaleform)
            local handle = Draw.scaleformHandles[scaleform]
            if (scaleform == "mp_menu_glare") then
                if not IsPedInjured(PlayerPedId()) then
                    local thing = GetGoodParameterForMenuGlare(0.0, GetGameplayCamRot(2).z, 360.0)
                    PushScaleformMovieFunction(handle, "SET_DATA_SLOT")
                    PushScaleformMovieMethodParameterFloat(thing)
                    PopScaleformMovieFunctionVoid()
                end
            end
            if (HasScaleformMovieLoaded(handle)) then
                DrawScaleformMovie(handle, x, y, w, h, r, g, b, a, 0)
                --DrawScaleformMovieFullscreen(handle, r, g, b, a, 0)
            end
        end
        function Draw.sprite(dict, name, x, y, width, height, heading, r, g, b, a)
            if (HasStreamedTextureDictLoaded(dict)) then
                DrawSprite(dict, name, x, y, width, height, heading, r, g, b, a)
            else
                RequestStreamedTextureDict(dict, 0)
            end
        end
        local y = self.y
        for e, v in pairs(self.headerElements) do
            y = y + v:draw(y, Draw, self)
        end
        if (self.list ~= "") then
            y = y + self.list:draw(y, Draw, self)
        end
        for k, v in pairs(self.bottomElements) do
            y = y + v:draw(y, Draw, self)
        end
        self.height = y - self.y
    end
end

function Menu.getLength(self)
    if (self.options == "") then
        return 0
    else
        return tablelength(self.list.list)
    end
    return 0
end

function Menu.getIndex(self)
    if (self.list == "") then
        return 0
    else
        return self.list.index
    end
    return 0
end

function Menu.pushHeaderEl(self, el)
    table.insert(self.headerElements, el)
end

function Menu.getHeaderEl(self, index)
    return menu.headerElements[index]
end

function Menu.setList(self, list, clearbacklist)
    self.list = list
    if clearbacklist ~= false then
        self.backlist = {}
    end
end

function Menu.getList(self)
    return self.list
end

function Menu.pushBottomEl(self, opt)
    table.insert(self.bottomElements, opt)
end

function Menu.getBottomEl(self, index)
    return self.bottomElements[index]
end

-- Controls
function Menu.quit(self, d)
    if (self.isOpened) then
        PlaySoundFrontend(-1, "QUIT", "HUD_FRONTEND_DEFAULT_SOUNDSET")
        self.isOpened = false
    end
end
function Menu.open(self)
    --CloseAllMenus()
    if not (self.isOpened) then
        if not IsPauseMenuActive() and not IsSystemUiBeingDisplayed() and not IsWarningMessageActive() and not NetworkIsTextChatActive() and not IsPlayerSwitchInProgress() and not IsAnyMenuOpened() and not IsPlayerDead(NetworkPlayerIdToInt()) and not IsPlayerInIntroduction() and not IsPhoneOpened() then
            PlaySoundFrontend(-1, "SELECT", "HUD_FRONTEND_DEFAULT_SOUNDSET")
            self.isOpened = true
        end
    end
end

function Menu.sendCommand(self, arg)
    if (self.list ~= "") then
        self.list:control(arg, self)
    end
end
function Menu.up(self)
    self:sendCommand("up")
end
function Menu.down(self)
    self:sendCommand("down")
end
function Menu.left(self)
    self:sendCommand("left")
end
function Menu.right(self)
    self:sendCommand("right")
end
function Menu.select(self)
    self:sendCommand("select")
end

function Menu.back(self)
    if (type(self.list.backevent) == "string") then
        TriggerEvent(self.list.backevent, tablelength(self.backlist) + 1)
    end
    if (tablelength(self.backlist) == 0) then
        if (self.canUserCloseIt) then
            self:quit()
            self:callBackEvent()
            PlaySoundFrontend(-1, "QUIT", "HUD_FRONTEND_DEFAULT_SOUNDSET")
        end
    else
        local i = tablelength(self.backlist)
        self:setList(self.backlist[i], false)
        self.backlist[i] = nil
        self:callBackEvent()
    	  PlaySoundFrontend(-1, "BACK", "HUD_FRONTEND_DEFAULT_SOUNDSET")
    end
end

function Menu.callBackEvent(self)
    if (self.backevent ~= nil) then
        TriggerEvent(self.backevent, tablelength(self.backlist) + 1)
    end
end

function Menu.next(self, list)
    self.backlist[tablelength(self.backlist) + 1] = self.list
    self:setList(list, false)
  	PlaySoundFrontend(-1, "SELECT", "HUD_FRONTEND_DEFAULT_SOUNDSET")
end

function Menu.setupInstructional(self)
    if (self.instructButtons == nil) then
        self.instructButtons = RequestScaleformMovie("instructional_buttons")
    end
    self.instructButtonsIndex = 0
    PushScaleformMovieFunction(self.instructButtons, "CLEAR_ALL")
    PopScaleformMovieFunctionVoid()
    PushScaleformMovieFunction(self.instructButtons, "TOGGLE_MOUSE_BUTTONS")
    PushScaleformMovieFunctionParameterBool(true)
    PopScaleformMovieFunctionVoid()
    PushScaleformMovieFunction(self.instructButtons, "SET_CLEAR_SPEACE")
    PushScaleformMovieFunctionParameterInt(200)
    PopScaleformMovieFunctionVoid()
end

function Menu.addInstructional(self, text, button, secbutton)
    PushScaleformMovieFunction(self.instructButtons, "SET_DATA_SLOT")
    PushScaleformMovieFunctionParameterInt(self.instructButtonsIndex)
    self.instructButtonsIndex = self.instructButtonsIndex + 1
    PushScaleformMovieMethodParameterButtonName(GetControlInstructionalButton(2, button, true))
    if (secbutton ~= nil) then
        PushScaleformMovieMethodParameterButtonName(GetControlInstructionalButton(2, secbutton, true))
    end
    PushScaleformMovieFunctionParameterString(text)
    PushScaleformMovieFunctionParameterBool(true)
    PushScaleformMovieFunctionParameterInt(358)
    PopScaleformMovieFunctionVoid()
end

function Menu.closeInstructional(self)
    PushScaleformMovieFunction(self.instructButtons, "DRAW_INSTRUCTIONAL_BUTTONS")
    PushScaleformMovieFunctionParameterInt(0)
    PopScaleformMovieFunctionVoid()
    PushScaleformMovieFunction(self.instructButtons, "SET_BACKGROUND_COLOUR")
    PushScaleformMovieFunctionParameterInt(0)
    PushScaleformMovieFunctionParameterInt(0)
    PushScaleformMovieFunctionParameterInt(0)
    PushScaleformMovieFunctionParameterInt(80)
    PopScaleformMovieFunctionVoid()
    DrawScaleformMovieFullscreen(self.instructButtons, 255, 255, 255, 0)
end

function Menu.drawInstructionalButtons(self)
    if (self.isOpened) then
        self:setupInstructional()
        if (tablelength(self.backlist) == 0) then
            self:addInstructional("Back", 177)
        else
            self:addInstructional("Back", 177)
        end
        --self:addInstructional("Select", 176)
        if (self.list ~= nil) then
            if (tablelength(self.list.list) > 0) then
                --self:addInstructional("Parcourir", 173, 172)
                if (self.list.list[self.list.index].leftrightsupport) then
                    self:addInstructional("Switch", 175, 174)
                else
                    self:addInstructional("Select", 176)
                end
            end
        end
        self:closeInstructional()
    end
end

function Menu.tick(self)
    if (self.isOpened) then
        SetUiLayer(4)
        self:draw()
        if not (UpdateOnscreenKeyboard() == 0) then
            self:drawInstructionalButtons()
        end
        if (IsInputDisabled(2)) then
            SetInputExclusive(2, 237)
            SetInputExclusive(2, 238)
            SetInputExclusive(2, 241)
            SetInputExclusive(2, 242)
            SetInputExclusive(2, 239)
            SetInputExclusive(2, 240)
            SetInputExclusive(2, 172)
            SetInputExclusive(2, 173)
            SetInputExclusive(2, 174)
            SetInputExclusive(2, 175)
            EnableControlAction(2, 176, 1)
        else
            SetInputExclusive(2, 176)
            SetInputExclusive(2, 177)
            SetInputExclusive(2, 172)
            SetInputExclusive(2, 173)
            SetInputExclusive(2, 174)
            SetInputExclusive(2, 175)
        end
        DisableControlAction(0, 37, 1)
        DisableControlAction(0, 157, 1)
        DisableControlAction(0, 158, 1)
        DisableControlAction(0, 159, 1)
        DisableControlAction(0, 160, 1)
        DisableControlAction(0, 161, 1)
        DisableControlAction(0, 162, 1)
        DisableControlAction(0, 163, 1)
        DisableControlAction(0, 164, 1)
        DisableControlAction(0, 165, 1)
        DisableControlAction(0, 14, 1)
        DisableControlAction(0, 15, 1)
        DisableControlAction(0, 53, 1)
        DisableControlAction(0, 54, 1)
        DisableControlAction(0, 140, 1)
        DisableControlAction(0, 141, 1)
        DisableControlAction(0, 143, 1)
        DisableControlAction(0, 47, 1)
        DisableControlAction(0, 74, 1)
        DisableControlAction(0, 85, 1)
        DisableControlAction(0, 73, 1)
        DisableControlAction(0, 51, 1)
        DisableControlAction(0, 45, 1)
        DisableControlAction(0, 55, 1)
        DisableControlAction(0, 80, 1)
        DisableControlAction(0, 25, 1)
  			DisableControlAction(0, 24, 1)
  			DisableControlAction(0, 257, 1)
  			DisableControlAction(0, 56, 1)
  			DisableControlAction(0, 68, 1)
  			DisableControlAction(0, 69, 1)
  			DisableControlAction(0, 70, 1)
  			DisableControlAction(0, 91, 1)
  			DisableControlAction(0, 92, 1)
        DisableControlAction(2, 199, 1)
  			DisableControlAction(2, 189, 1)
  			DisableControlAction(2, 190, 1)
  			DisableControlAction(2, 187, 1)
  			ShowHudComponentThisFrame(4)
  			ShowHudComponentThisFrame(5)
  			ShowHudComponentThisFrame(13)
  			ShowHudComponentThisFrame(3)
  			ShowHudComponentThisFrame(2)
        HideHudComponentThisFrame(10)
        HideHudComponentThisFrame(6)
        HideHudComponentThisFrame(7)
        HideHudComponentThisFrame(9)
        HideHudComponentThisFrame(8)
        --[[local controlsToDisable = {
            201, 195, 196, 187, 188, 189, 190, 202, 217, 22, 23, 89, 9, 8, 90, 24, 25, 21, 14, 15, 12, 13, 16, 17
        }
        local controlsToDisableIfController = {
            0, 140, 141, 142, 143, 80, 21
        }
        local controlsToDisableIfKeyboard = {
            1, 2
        }
        local hudComponentsToHide = {
          10, 6, 7, 9, 8
        }
        local controller = GetLastInputMethod(2)
        if not (controller) then
            for k, v in pairs(controlsToDisableIfController) do
                table.insert(controlsToDisable, v)
            end
        else
            for k, v in pairs(controlsToDisableIfKeyboard) do
                table.insert(controlsToDisable, v)
            end
        end
        for k, v in pairs(controlsToDisable) do
            DisableControlAction(0, v, true)
            DisableControlAction(1, v, true)
            DisableControlAction(2, v, true)
        end]]
        if self.listenKey then
            if IsDisabledControlJustReleased(0, self.key) and self.canUserCloseIt then
                self.closeTime = self.closeTime + 1
                if (self.closeTime >= 5) then
                    self.openTime = 0
                    self:quit()
                    self.listenKey = false
                end
            end
            if IsControlJustPressed(2, 172) or IsDisabledControlJustPressed(2, 241) then
                self:up()
            end
            if IsControlJustPressed(2, 173) or IsControlJustPressed(2, 242) then
                self:down()
            end
            if IsControlJustPressed(2, 174) then
                self:left()
            end
            if IsControlJustPressed(2, 175) then
                self:right()
            end
            if IsControlJustPressed(2, 201) then
                self:select()
            end
            if IsControlJustPressed(2, 177) or IsControlJustPressed(2, 238) then
                self:back()
            end
        end
        if not IsDisabledControlPressed(0, self.key) then
            self.listenKey = true
        end
        -- cursor
        -- ((self.x + self.width < GetControlNormal(0, 239) and GetControlNormal(0, 240) > self.height + self.y)) or self.isMoving
        if self.enableCamMovingWithRightClick then
            if (GetControlNormal(2, 239) < self.x + self.width + GetSafeZone().x and GetControlNormal(2, 240) < self.height + self.y) then
                SetCursorSprite(1)
            else
                SetCursorSprite(3)
                if IsControlPressed(2, 237) then
                    EnableControlAction(0, 1, 1)
                    EnableControlAction(0, 2, 1)
                    SetCursorSprite(4)
                end
            end
        else
            SetCursorSprite(1)
            EnableControlAction(0, 1, 1)
            EnableControlAction(0, 2, 1)
        end
        if (IsInputDisabled(2)) then
            ShowCursorThisFrame()
        end
    else
        if (IsDisabledControlJustReleased(2, self.key) and self.canUserOpenIt) then
            self.openTime = self.openTime + 1
            if (self.openTime >= self.openTimeLimit) then
                self.openTime = 0
                self:open()
                self.listenKey = false
            end
        end
        EnableControlAction(2, 199, true)
    end
end

local optionsobj = {
    SimpleOption = SimpleOption,
    OptionWithCustomRightText = OptionWithCustomRightText,
    BoolOption = BoolOption,
    BoolSpriteOption = BoolSpriteOption,
    ListOption = ListOption,
    RedirectOption = RedirectOption
}

local menus = {}

function CloseAllMenus()
    for k, v in pairs(menus) do
        v.isOpened = false
    end
end

function IsAnyMenuOpened()
    for k, v in pairs(menus) do
        if v.isOpened then
            return true
        end
    end
end

AddEventHandler("theftvrp:menu:isopened", function(id, callback)
    if (menus[id] == nil) then
        callback(false, "")
    else
        callback(menus[id].isOpened, menus[id])
    end
end)

AddEventHandler("theftvrp:menu:doesmenuexist", function(id, callback)
    if (menus[id] == nil) then
        callback(false)
    else
        callback(true)
    end
end)

AddEventHandler("theftvrp:menu:closeall", function()
    CloseAllMenus()
end)

AddEventHandler("theftvrp:menu:create", function(id, name, sub, desc, writecount, infos)
    menus[id] = nil
    local m = Menu.create(name)
    if (m.list ~= nil) then
        m.list = OptionList.create()
    end
    if (name ~= "") then
        m:pushHeaderEl(Header.create())
    end
    if (sub ~= "") then
        m:pushHeaderEl(HeaderBar.create(sub, writecount))
    end
    m:pushBottomEl(UpAndDown.create())
    if (desc) then
        m:pushBottomEl(DescriptionBar:create())
        m:pushBottomEl(Description:create())
    end
    if (infos) then
        m:pushBottomEl(Infos:create())
    end
    menus[id] = m
end)

AddEventHandler("theftvrp:menu:scadminstyle", function(id)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        if (menu.headerElements[1].showTitle ~= nil) then
            menu.headerElements[1].fontType = 6
      			menu.headerElements[1].centreTitle = true
      			menu.headerElements[1].titleScale = 1.0
        end
    end
end)

AddEventHandler("theftvrp:menu:gtaostyle", function(id)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        if (menu.headerElements[1].showTitle ~= nil) then
            menu.headerElements[1].fontType = 4
      			menu.headerElements[1].centreTitle = false
      			menu.headerElements[1].titleScale = 0.7
      			menu.headerElements[1].doOffset = true
        end
    end
end)

AddEventHandler("theftvrp:menu:teamselectionstyle", function(id)
    local menu = menus[id]
    menu.teamSelectionSettings = true
    if (tablelength(menu.headerElements) ~= 0) then
        if (menu.headerElements[1].showTitle ~= nil) then
      			menu.headerElements[1].centreTitle = true
      			menu.headerElements[1].titleScale = 0.97
            menu.headerElements[1].teamSelectionSettings = true
            menu.headerElements[1].writeCount = true
        end
    end
end)

AddEventHandler("theftvrp:menu:spritecolor", function(id, colors)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        if (menu.headerElements[1].showTitle ~= nil) then
            menu.headerElements[1].spriteColor = true
            menu.headerElements[1].spriteColors = colors
        end
    end
end)

AddEventHandler("theftvrp:menu:writeText", function(id, write)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        if (menu.headerElements[1].showTitle ~= nil) then
            menu.headerElements[1].showTitle = write
        end
    end
end)

AddEventHandler("theftvrp:menu:setheadersprite", function(id, spritedict, spritetext)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        if (menu.headerElements[1].sprite ~= nil) then
            menu.headerElements[1].sprite.dict = spritedict
            menu.headerElements[1].sprite.name = spritetext
        end
    end
end)

AddEventHandler("theftvrp:menu:setheadertodosprite", function(id, dosprite)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        if (menu.headerElements[1].sprite ~= nil) then
            menu.headerElements[1].doSprite = dosprite
        end
    end
end)

AddEventHandler("theftvrp:menu:setheaderscaleform", function(id, doscaleform, scaleform)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        if (menu.headerElements[1].sprite ~= nil) then
            menu.headerElements[1].doScaleform = doscaleform
            menu.headerElements[1].scaleform = scaleform
        end
    end
end)

AddEventHandler("theftvrp:menu:setnextlist", function(id, title, list, maxelements, backevent)
    menus[id]:next(OptionList.create(title, list, maxelements, backevent))
end)

AddEventHandler("theftvrp:menu:setmainlist", function(id, title, list, maxelements)
    menus[id]:setList(OptionList.create(title, list, maxelements))
end)

AddEventHandler("theftvrp:menu:setheaderbartext", function(id, text)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        local i = nil
        for k,v in pairs(menu.headerElements) do
            if v.textr ~= nil then
                i = v
            end
        end
        if (i ~= nil) then
            i.text = text
        end
    end
end)

AddEventHandler("theftvrp:menu:setheaderbartextcolor", function(id, r, g, b, a)
    local menu = menus[id]
    if (tablelength(menu.headerElements) ~= 0) then
        local i = nil
        for k,v in pairs(menu.headerElements) do
            if v.textr ~= nil then
                i = v
            end
        end
        if (i ~= nil) then
            i.textr = r
            i.textg = g
            i.textb = b
            i.texta = a
        end
    end
end)

AddEventHandler("theftvrp:menu:setifusercanopenit", function(id, can)
    menus[id].canUserOpenIt = can
end)

AddEventHandler("theftvrp:menu:setifusercancloseit", function(id, can)
    menus[id].canUserCloseIt = can
end)

AddEventHandler("theftvrp:menu:setmenupos", function(id, x, y, width)
    menus[id].x = menus[id].x + x ~= "" and x or menus[id].x
    menus[id].y = menus[id].y + y ~= "" and y or menus[id].y
    menus[id].width = width ~= "" and width or menus[id].width
end)

AddEventHandler("theftvrp:menu:setkeytoopen", function(id, key)
    menus[id].key = key
end)

AddEventHandler("theftvrp:menu:setifcamcanmove", function(id, moving, movingwithrightclick)
    menus[id].enableCamMoving = moving
    menus[id].enableCamMovingWithRightClick = movingwithrightclick
end)

AddEventHandler("theftvrp:menu:setbackevent", function(id, event)
    menus[id].backevent = event
end)

AddEventHandler("theftvrp:menu:open", function(id)
    if (menus[id] ~= nil) then
        menus[id]:open()
    end
end)

AddEventHandler("theftvrp:menu:quit", function(id)
    if (menus[id] ~= nil) then
        menus[id]:quit()
    end
end)

AddEventHandler("theftvrp:menu:updatelist", function(id, list_)
    local menu = menus[id]
    if (tablelength(menu.backlist) == 0) then
        list = menu.list
    else
        list = menu.backlist[tablelength(menu.backlist)]
    end
    list.list = {}
    list.readlistfromserialized(list, list_)
end)

AddEventHandler("theftvrp:menu:updateoption", function(id, index, opt)
    local menu = menus[id]
    --if (tablelength(menu.backlist) == 0) then
        list = menu.list
    --else
    --    list = menu.backlist[tablelength(menu.backlist)]
    --end
    list.list[index] = list.readoptfromserialized(list, index, opt)
end)

AddEventHandler("theftvrp:menu:setvalue", function(id, index, value)
    local menu = menus[id]
    --if (tablelength(menu.backlist) == 0) then
        list = menu.list
    --else
    --    list = menu.backlist[tablelength(menu.backlist)]
    --end
    list[index].value = value
    list[index].index = value
end)

CreateThread(function()
    while true do
        Wait(0)
        if DisplayMenusThisFrame then
            for k, v in pairs(menus) do
                v:tick()
            end
        end
    end
end)
