local callbacks = {}
local lastSecond = 0

function AirportWarsThread(seconds, cb)
    callbacks[seconds] = cb
end

function GetAllConnectedPlayers()
    local connectedplayers = {}
    local players = GetPlayers()
    for _, player in ipairs(players) do
        table.insert(connectedplayers, tonumber(player))
    end
    return connectedplayers
end

function PatchPlayerName(playerteam, name)
    if playerteam == 1 then
        return "~r~<C>"..name.."</C>~w~"
    elseif playerteam == 2 then
        return "~b~<C>"..name.."</C>~w~"
    else
        return "<C>"..name.."</C>"
    end
end

function round(x)
  return x >= 0 and math.floor(x + 0.5) or math.ceil(x - 0.5)
end

function tablecontains(table, thing)
    for k, v in pairs(table) do
        if v == thing then
            return true
        end
    end
    return false
end

function UpperFirstLetter(str)
    return (str:gsub("^%l", string.upper))
end

function Count(table)
    local count = 0
    for i, veh in ipairs(table) do
        count = count + 1
    end
    return count
end

CreateThread(function()
    while true do
        Wait(0)
        local thisSecond = os.time()
        if thisSecond ~= lastSecond then
            for timer, cb in pairs(callbacks) do
                if thisSecond % timer == 0 then cb() end
            end
            lastSecond = thisSecond
        end
    end
end)
