---------------------------------------------------------
-- RESSOURCE : Gamemode - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Gamemode main functions for the Airport Wars server.
---------------------------------------------------------
--------------------------------------- MISC ------------------------------------------
-- SERVER BROWSER INFOS
SetGameType("Airport Wars")
SetMapName("San Andreas")
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
---------------------- FUNCTIONS ----------------------
-- INITIALZE MONEY
RegisterServerEvent("airportwars:network:initializecash")
AddEventHandler("airportwars:network:initializecash", function()
		TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
				Network.InitializeCash()
		end)
end)

-- ADD MONEY TO WALLET
RegisterServerEvent("airportwars:network:addtowalletbalance")
AddEventHandler("airportwars:network:addtowalletbalance", function(amount)
		TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
				Network.AddToWalletBalance(amount)
	 	end)
end)

-- REMOVE MONEY FROM WALLET
RegisterServerEvent("airportwars:network:removefromwalletbalance")
AddEventHandler("airportwars:network:removefromwalletbalance", function(amount)
		TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
				Network.RemoveFromWalletBalance(amount)
	 	end)
end)

-- ADD MONEY TO BANK
RegisterServerEvent("airportwars:network:addtobankbalance")
AddEventHandler("airportwars:network:addtobankbalance", function(amount)
		TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
				Network.AddToBankBalance(amount)
	 	end)
end)

-- REMOVE MONEY FROM BANK
RegisterServerEvent("airportwars:network:removefrombankbalance")
AddEventHandler("airportwars:network:removefrombankbalance", function(amount)
		TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
				Network.RemoveFromBankBalance(amount)
	 	end)
end)
-------------------------------------------------------


----------------------- IN-GAME -----------------------
-- PLAYERS NOTIFICATIONS (LEAVE)
AddEventHandler("playerDropped", function()
		SendDiscordMessage("**"..GetPlayerName(source).."** disconnected from Airport Wars.", true)
		local players = GetAllConnectedPlayers()
		for _, player in ipairs(players) do
				if (player ~= source) then
						TriggerClientEvent("airportwars:simplenotify", player, "TICK_LEFT", -1, {PatchPlayerName(0, GetPlayerName(source))}, false)
				end
		end
end)

-- PLAYERS NOTIFICATIONS (SUICIDE)
RegisterServerEvent("airportwars:nm:playersuicide")
AddEventHandler("airportwars:nm:playersuicide", function()
		SendDiscordMessage("**"..GetPlayerName(source).."** committed suicide.", true)
		local players = GetAllConnectedPlayers()
		for _, player in ipairs(players) do
				if (player ~= source) then
						TriggerClientEvent("airportwars:simplenotify", player, "PM_KYTKR", -1, {PatchPlayerName(0, GetPlayerName(source))}, false)
				end
		end
		TriggerClientEvent("airportwars:simplenotify", source, "DM_TK_KY1", -1, {}, false)
end)
-------------------------------------------------------
---------------------------------------------------------------------------------------
