---------------------------------------------------------
-- RESSOURCE : System Management - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Sys/DB Management script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
Users = {}
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
local function RegisterPlayerNameAndIP(identifier, name, ip)
    exports["mysql"]:QueryAsync("UPDATE apw_users SET username = @name, last_ip = @ip WHERE identifier = @identifier", {["@identifier"] = identifier, ["@name"] = name, ["@ip"] = ip})
end

local function LoadPlayerNetworkData(identifier, source)
    CreateThread(function()
        local joinedat = GetGameTimer()
        local user = exports["mysql"]:QueryResult("SELECT * FROM apw_users WHERE identifier = @identifier", {["@identifier"] = identifier})
        local stats = exports["mysql"]:QueryResult("SELECT * FROM apw_stats WHERE identifier = @identifier", {["@identifier"] = identifier})
        local identifier = user[1].identifier
        local rankid = user[1].rank
        local rank = exports["mysql"]:QueryScalar("SELECT string FROM apw_users INNER JOIN apw_ranks ON apw_users.rank = apw_ranks.rankid WHERE identifier = @identifier", {["@identifier"] = identifier})
        local userstats = {}
        userstats.wallet_balance = json.decode(stats[1].wallet_balance)
        userstats.bank_balance = json.decode(stats[1].bank_balance)
        userstats.is_tutorial_done = json.decode(stats[1].is_tutorial_done)
        userstats.has_received_bonus = json.decode(stats[1].has_received_bonus)
        userstats.warnings_amount = json.decode(stats[1].warnings_amount)
        userstats.score = json.decode(stats[1].score)
        userstats.kills = json.decode(stats[1].kills)
        userstats.deaths = json.decode(stats[1].deaths)
        userstats.planes_delivered = json.decode(stats[1].planes_delivered)
        userstats.vans_delivered = json.decode(stats[1].vans_delivered)
        userstats.apw_firstweek_helptext = json.decode(stats[1].apw_firstweek_helptext)
        userstats.apw_tips_helptexts = json.decode(stats[1].apw_tips_helptexts)
        Users[source] = NetworkPlayer(source, identifier, joinedat, rankid, rank, userstats)
        RegisterPlayerNameAndIP(identifier, GetPlayerName(source), GetPlayerIdentifiers(source)[3])
        print("\nAPW_SYSTEM: Player data loaded for : "..tostring(GetPlayerName(source)).."/"..tostring(identifier)..".")
    end)
end

local function GetPlayerNetworkData(identifier, source)
    CreateThread(function()
    		local user = exports["mysql"]:QueryResult("SELECT * FROM apw_users WHERE identifier = @identifier", {["@identifier"] = identifier})
				if (user[1] == nil) then
            exports["mysql"]:TransactionAsync({"INSERT INTO apw_users (identifier) VALUES (@identifier)", "INSERT INTO apw_stats (identifier) VALUES (@identifier)", "INSERT INTO apw_weapons (identifier) VALUES (@identifier)", "INSERT INTO apw_vehicles (identifier) VALUES (@identifier)", "INSERT INTO apw_outfits (identifier) VALUES (@identifier)"}, {['@identifier'] = identifier}, function(callback)
                print("\nAPW_SYSTEM: Player data created for : "..tostring(GetPlayerName(source)).."/"..tostring(identifier)..".")
                LoadPlayerNetworkData(identifier, source)
            end)
				else
						print("\nAPW_SYSTEM: Player data exists for : "..tostring(GetPlayerName(source)).."/"..tostring(identifier)..".")
						LoadPlayerNetworkData(identifier, source)
				end
    end)
end

local function SaveUsersStats()
		local count = 0
		for i in ipairs(Users) do
        User = Users[i]
				if User ~= nil then
						count = count + 1
            local stats = User.GetAllStats()
						for k, v in pairs(stats) do
                local v = {value = v}
                exports["mysql"]:QueryAsync("UPDATE apw_stats SET "..k.." = @v WHERE identifier = @identifier", {['@identifier'] = User.GetInfo("IDENTIFIER"), ["@v"] = json.encode(v)})
            end
				end
		end
		if count == 1 then
				print("\nAPW_SYSTEM: Stats saved for "..tostring(count).." player.")
		elseif count > 1 then
				print("\nAPW_SYSTEM: Stats saved for "..tostring(count).." players.")
		end
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:sys:userjoined")
AddEventHandler("airportwars:sys:userjoined", function()
		GetPlayerNetworkData(GetPlayerIdentifiers(source)[1], source)
end)

AddEventHandler("airportwars:sys:getuserfromid", function(user, cb)
    if (cb ~= nil) then
    		if (Users[user] ~= nil) then
    				cb(Users[user])
    		else
    				cb(nil)
    		end
    end
end)

AddEventHandler("airportwars:sys:getuserfromidentifier", function(identifier, cb)
    if (#Users > 0) then
      	for user, data in pairs(Users) do
            if (data.GetInfo("IDENTIFIER") == identifier) then
      		      cb(data)
                return
            else
                cb(nil)
            end
        end
    else
        cb(nil)
    end
end)

AddEventHandler("airportwars:sys:getusers", function(cb)
		cb(Users)
end)

AddEventHandler("playerDropped", function()
		if (Users[source]) then
        local stats = Users[source].GetAllStats()
        for k, v in pairs(stats) do
            local v = {value = v}
            exports["mysql"]:QueryAsync("UPDATE apw_stats SET "..k.." = @v WHERE identifier = @identifier", {["@identifier"] = Users[source].GetInfo("IDENTIFIER"), ["@v"] = json.encode(v)})
        end
				print("\nAPW_SYS: Player "..tostring(GetPlayerName(source)).."/"..tostring(Users[source].GetInfo("IDENTIFIER")).." left. Stats saved.")
				Users[source] = nil
				TriggerEvent("airportwars:scoreboard:refresh")
		end
end)
---------------------------------------------------------------------------------------
CreateThread(function()
    while not HasTunablesBeenDownloaded() do
        Wait(0)
    end
    TriggerEvent("airportwars:events:updatetunables")
end)
---------------------------------------------------------------------------------------
AirportWarsThread(30, SaveUsersStats)
NetworkRequestCloudTunables()
