---------------------------------------------------------
-- RESSOURCE : System Management - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Sys/DB Management script for the Airport Wars server.
---------------------------------------------------------
-------------------------------------- FUNCTIONS --------------------------------------
function NetworkPlayer(_source, _identifier, _joinedat, _rankid, _rank, _userstats)
		local self = {
				infos = {
						source = _source,
						identifier = _identifier,
						joinedat = _joinedat,
						rankid = _rankid,
						rank = _rank,
						team = 0
				},
				stats = {
						wallet_balance = _userstats.wallet_balance.value,
						bank_balance = _userstats.bank_balance.value,
						is_tutorial_done = _userstats.is_tutorial_done.value,
						has_received_bonus = _userstats.has_received_bonus.value,
						warnings_amount = _userstats.warnings_amount.value,
						score = _userstats.score.value,
						kills = _userstats.kills.value,
						deaths = _userstats.deaths.value,
						planes_delivered = _userstats.planes_delivered.value,
						vans_delivered = _userstats.vans_delivered.value,
						apw_firstweek_helptext = _userstats.apw_firstweek_helptext.value,
						apw_tips_helptexts = _userstats.apw_tips_helptexts.value
				}
		}

		local Network = {}

		function Network.InitializeCash()
				TriggerClientEvent("airportwars:sys:enablemoney", self.infos.source, self.stats.wallet_balance)
				--TriggerClientEvent("airportwars:sys:enablebank", self.infos.source, self.stats.bank_balance)
		end

		function Network.AddToWalletBalance(amount, applytunablevalue)
				if (applytunablevalue) then
						amount = round(amount * NetworkAccessTunable("CASH_MULTIPLIER"))
				end
				self.stats.wallet_balance = self.stats.wallet_balance + amount
				TriggerClientEvent("airportwars:sys:addedmoney", self.infos.source, amount, self.stats.wallet_balance)
				TriggerEvent("airportwars:scoreboard:refresh")
		end

		function Network.RemoveFromWalletBalance(amount)
				self.stats.wallet_balance = self.stats.wallet_balance - amount
				TriggerClientEvent("airportwars:sys:removedmoney", self.infos.source, amount, self.stats.wallet_balance)
				TriggerEvent("airportwars:scoreboard:refresh")
		end

		function Network.AddToBankBalance(amount, applytunablevalue)
				if (applytunablevalue) then
						amount = round(amount * NetworkAccessTunable("CASH_MULTIPLIER"))
				end
				self.stats.bank_balance = self.stats.bank_balance + amount
				TriggerClientEvent("airportwars:sys:addedbank", self.infos.source, amount, self.stats.bank_balance)
				TriggerEvent("airportwars:scoreboard:refresh")
		end

		function Network.RemoveFromBankBalance(amount)
				self.stats.bank_balance = self.stats.bank_balance - amount
				TriggerClientEvent("airportwars:sys:removedbank", self.infos.source, amount, self.stats.bank_balance)
				TriggerEvent("airportwars:scoreboard:refresh")
		end

		function Network.GetAllInfos()
				return self.infos
		end

		function Network.GetInfo(infoName)
				if (infoName == "SOURCE_ID") then
						return self.infos.source
				elseif (infoName == "IDENTIFIER") then
						return self.infos.identifier
				elseif (infoName == "JOINED_AT") then
						return self.infos.joinedat
				elseif (infoName == "RANK_ID") then
						return self.infos.rankid
				elseif (infoName == "RANK_STRING") then
						return self.infos.rank
				elseif (infoName == "TEAM") then
						return self.infos.team
				end
		end

		function Network.SetInfo(infoName, value)
				if (infoName == "RANK_ID") then
						self.infos.rankid = value
				elseif (infoName == "TEAM") then
						self.infos.team = value
				end
				TriggerEvent("airportwars:scoreboard:refresh")
		end

		function Network.GetAllStats()
				return self.stats
		end

		function Network.GetStatFromString(statName)
				if (statName == "WALLET_BALANCE") then
						return self.stats.wallet_balance
				elseif (statName == "BANK_BALANCE") then
						return self.stats.bank_balance
				elseif (statName == "IS_TUTORIAL_DONE") then
						return self.stats.is_tutorial_done
				elseif (statName == "HAS_RECEIVED_BONUS") then
						return self.stats.has_received_bonus
				elseif (statName == "WARNINGS_AMOUNT") then
						return self.stats.warnings_amount
				elseif (statName == "SCORE") then
						return self.stats.score
				elseif (statName == "KILLS") then
						return self.stats.kills
				elseif (statName == "DEATHS") then
						return self.stats.deaths
				elseif (statName == "PLANES_DELIVERED") then
						return self.stats.planes_delivered
				elseif (statName == "VANS_DELIVERED") then
						return self.stats.vans_delivered
				elseif (statName == "APW_FIRSTWEEK_HELPTEXT") then
						return self.stats.apw_firstweek_helptext
				elseif (statName == "APW_TIPS_HELPTEXTS") then
						return self.stats.apw_tips_helptexts
				end
		end

		function Network.SetStat(statName, value)
				if (statName == "IS_TUTORIAL_DONE") then
						self.stats.is_tutorial_done = value
				elseif (statName == "HAS_RECEIVED_BONUS") then
						self.stats.has_received_bonus = value
				elseif (statName == "WARNINGS_AMOUNT") then
						self.stats.warnings_amount = value
				elseif (statName == "SCORE") then
						self.stats.score = value
				elseif (statName == "KILLS") then
						self.stats.kills = value
				elseif (statName == "DEATHS") then
						self.stats.deaths = value
				elseif (statName == "PLANES_DELIVERED") then
						self.stats.planes_delivered = value
				elseif (statName == "VANS_DELIVERED") then
						self.stats.vans_delivered = value
				elseif (statName == "APW_FIRSTWEEK_HELPTEXT") then
						self.stats.apw_firstweek_helptext = value
				elseif (statName == "APW_TIPS_HELPTEXTS") then
						self.stats.apw_tips_helptexts = value
				end
				TriggerEvent("airportwars:scoreboard:refresh")
		end

		function Network.AddToStat(statName, value, type)
				if (type == "score") then
						value = round(value * NetworkAccessTunable("SCORE_MULTIPLIER"))
				end
				if (statName == "WARNINGS_AMOUNT") then
						self.stats.warnings_amount = self.stats.warnings_amount + value
				elseif (statName == "SCORE") then
						self.stats.score = self.stats.score + value
				elseif (statName == "KILLS") then
						self.stats.kills = self.stats.kills + value
				elseif (statName == "DEATHS") then
						self.stats.deaths = self.stats.deaths + value
				elseif (statName == "PLANES_DELIVERED") then
						self.stats.planes_delivered = self.stats.planes_delivered + value
				elseif (statName == "VANS_DELIVERED") then
						self.stats.vans_delivered = self.stats.vans_delivered + value
				end
				TriggerEvent("airportwars:scoreboard:refresh")
		end

		function Network.RemoveFromStat (statName, value, type)
				if (statName == "WARNINGS_AMOUNT") then
						self.stats.warnings_amount = self.stats.warnings_amount - value
				elseif (statName == "SCORE") then
						self.stats.score = self.stats.score - value
				elseif (statName == "KILLS") then
						self.stats.kills = self.stats.kills - value
				elseif (statName == "DEATHS") then
						self.stats.deaths = self.stats.deaths - value
				elseif (statName == "PLANES_DELIVERED") then
						self.stats.planes_delivered = self.stats.planes_delivered - value
				elseif (statName == "VANS_DELIVERED") then
						self.stats.vans_delivered = self.stats.vans_delivered - value
				end
				TriggerEvent("airportwars:scoreboard:refresh")
		end

		TriggerClientEvent("airportwars:spawnmanager:canstart", _source)

		return Network
end
---------------------------------------------------------------------------------------
