---------------------------------------------------------
-- RESSOURCE : Rcon Commands - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Rcon Commands script for the Airport Wars server.
---------------------------------------------------------
-------------------------------------- FUNCTIONS --------------------------------------
local function addWhiteList(identifier, name)
		exports["mysql"]:QueryAsync("INSERT INTO apw_whitelist (identifier, name) VALUES (@identifier, @name)", {['@identifier'] = identifier, ['@name'] = name})
end

local function removeWhiteList(identifier)
		exports["mysql"]:QueryAsync("DELETE FROM apw_whitelist WHERE identifier = @identifier", {['@identifier'] = identifier})
end

local function ban(identifier, reason)
    local name = "Unknown"
    TriggerEvent("airportwars:sys:getuserfromidentifier", identifier, function(Network)
        if (Network.GetInfo("SOURCE_ID") ~= nil) then
            local playerid = Network.GetInfo("SOURCE_ID")
            name = GetPlayerName(playerid)
            TriggerClientEvent("airportwars:notify", playerid, "MAN_APWBAN", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Warning", 2.0, true)
            TriggerClientEvent("airportwars:anticheat:punish", playerid, reason, "\nAPW_SYS: "..tostring(GetPlayerName(playerid)).."/"..tostring(identifier).." has been banned for ".. string.lower(reason) ..".")
        end
    end)
    exports["mysql"]:QueryAsync("INSERT INTO apw_bans (identifier, name, reason, date) VALUES (@identifier, @name, @reason, @date)", {['@identifier'] = identifier, ['@name'] = name, ['@reason'] = reason, ['@date'] = os.date("%c")})
end

local function unBan(identifier)
		exports["mysql"]:QueryAsync("DELETE FROM apw_bans WHERE identifier = @identifier", {['@identifier'] = identifier})
end

local function addMoney(playerid, amount)
    TriggerEvent("airportwars:sys:getuserfromid", tonumber(playerid), function(Network)
        Network.AddToWalletBalance(tonumber(amount), false)
        TriggerClientEvent("airportwars:notify", playerid, "MAN_ADD_CASH", -1, {amount}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
        RconPrint("Player "..playerid.." received "..amount.."$ !\n")
    end)
end

local function removeMoney(playerid, amount)
    TriggerEvent("airportwars:sys:getuserfromid", tonumber(playerid), function(Network)
        Network.RemoveFromWalletBalance(tonumber(amount))
        TriggerClientEvent("airportwars:notify", playerid, "MAN_REM_CASH", -1, {amount}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
        RconPrint("Player "..playerid.." lost "..amount.."$ !\n")
    end)
end

local function sendNotification(to, subject, text, duration)
    TriggerClientEvent("airportwars:notify", to, text, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", subject, tonumber(duration), true)
end

local function sendChatMessage(to, color, sender, tag, message)
		TriggerClientEvent("airportwars:chatmessage", to, color, sender, tag, message)
end

local function isIdentifierOnline(identifier)
    local players = GetAllConnectedPlayers()
		for _, player in ipairs(players) do
				if (GetPlayerIdentifiers(player)[1] == identifier) then
						local playername = GetPlayerName(player)
						RconPrint("Player "..identifier.." is actually connected with the server ID "..tostring(player).." and the name "..tostring(playername)..".\n")
						return
				end
		end
		RconPrint("Player "..identifier.." is not connected.\n")
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
AddEventHandler("rconCommand", function(commandName, args)
    -- START WHITELIST
		if (string.lower(commandName) == "addwhitelist") then
				if (#args ~= 2) then
						RconPrint("\nUtilisation : addwhitelist [identifier] [name]\n")
						CancelEvent()
						return
				end
        local whistelisted = exports["mysql"]:QueryResult("SELECT * FROM apw_whitelist WHERE identifier = @identifier", {['@identifier'] = args[1]})
				if (whistelisted[1] ~= nil) then
						RconPrint(args[1] .. " is already whitelisted !\n")
						CancelEvent()
				else
						addWhiteList(args[1], args[2])
						RconPrint(args[1] .. " has been whitelisted !\n")
						CancelEvent()
				end
		elseif (string.lower(commandName) == "removewhitelist") then
				if (#args ~= 1) then
						RconPrint("\nUtilisation : removewhitelist [identifier]\n")
						CancelEvent()
						return
				end
        local whistelisted = exports["mysql"]:QueryResult("SELECT * FROM apw_whitelist WHERE identifier = @identifier", {['@identifier'] = args[1]})
				if (whistelisted[1] ~= nil) then
						removeWhiteList(args[1])
						RconPrint(args[1] .. " is not more whitelisted !\n")
						CancelEvent()
				else
						RconPrint(args[1] .. " wasn't in the whitelist ! \n")
						CancelEvent()
				end
    -- START BANS
  elseif (string.lower(commandName) == "ban") then
        if (#args ~= 2) then
            RconPrint("\nUtilisation : ban [identifier] [reason]\n")
            CancelEvent()
            return
        end
        local banned = exports["mysql"]:QueryResult("SELECT * FROM apw_bans WHERE identifier = @identifier", {['@identifier'] = args[1]})
        if (banned[1] ~= nil) then
            RconPrint(args[1] .. " is already banned !\n")
            CancelEvent()
        else
            ban(args[1], args[2])
            RconPrint(args[1] .. " has been banned !\n")
            CancelEvent()
        end
    elseif (string.lower(commandName) == "unban") then
        if (#args ~= 1) then
            RconPrint("\nUtilisation : unban [identifier]\n")
            CancelEvent()
            return
        end
        local banned = exports["mysql"]:QueryResult("SELECT * FROM apw_bans WHERE identifier = @identifier", {['@identifier'] = args[1]})
        if (banned[1] ~= nil) then
            unBan(args[1])
            RconPrint(args[1] .. " is not more banned !\n")
            CancelEvent()
        else
            RconPrint(args[1] .. " wasn't banned ! \n")
            CancelEvent()
        end
    -- START MONEY
    elseif (string.lower(commandName) == "addmoney") then
        if (#args ~= 2) then
            RconPrint("\nUtilisation : addmoney [playerid] [amount]\n")
            CancelEvent()
            return
        end
        if (GetPlayerIdentifiers(tonumber(args[1]))[1] == nil) then
            RconPrint("\nSource is invalid !\n")
            CancelEvent()
            return
        end
        addMoney(args[1], args[2])
        CancelEvent()
    elseif (string.lower(commandName) == "removemoney") then
        if (#args ~= 2) then
            RconPrint("\nUtilisation : removemoney [playerid] [amount]\n")
            CancelEvent()
            return
        end
        if (GetPlayerIdentifiers(tonumber(args[1]))[1] == nil) then
            RconPrint("\nSource is invalid !\n")
            CancelEvent()
            return
        end
        removeMoney(args[1], args[2])
        CancelEvent()
    -- START NOTIFICATION
    elseif (string.lower(commandName) == "sendnotification") then
        if (#args ~= 4) then
            RconPrint("\nUtilisation : sendnotification [to] [subject] [text] [duration]\n")
            CancelEvent()
            return
        end
        sendNotification(args[1], args[2], args[3], args[4])
        CancelEvent()
		-- START CHATMESSAGE
		elseif (string.lower(commandName) == "sendchatmessage") then
				if (#args ~= 5) then
						RconPrint("\nUtilisation : sendchatmessage [to] [color] [sender] [tag] [message]\n")
						CancelEvent()
						return
				end
				sendChatMessage(args[1], tonumber(args[2]), args[3], args[4], args[5])
				CancelEvent()
    -- START IS PLAYER ONLINE
	elseif (string.lower(commandName) == "isidentifieronline") then
        if (#args ~= 1) then
            RconPrint("\nUtilisation : isidentifieronline [identifier]\n")
            CancelEvent()
            return
        end
        isIdentifierOnline(args[1])
        CancelEvent()
		end
end)
---------------------------------------------------------------------------------------
