---------------------------------------------------------
-- RESSOURCE : System Management - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Sys/DB Management script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local whitelist = true
local playerCount = 0
local list = {}
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:hardcap:playeractivated")
AddEventHandler("airportwars:hardcap:playeractivated", function()
    if not list[source] then
        playerCount = playerCount + 1
        list[source] = true
    end
end)

AddEventHandler("playerDropped", function()
    if list[source] then
        playerCount = playerCount - 1
        list[source] = nil
    end
end)

AddEventHandler("playerConnecting", function(name, reason, deferrals)
    --deferrals.defer()
    local source = source
		local identifier = GetPlayerIdentifiers(source)[1]
		local playerMax = GetConvarInt("sv_maxclients", 32)
    print("\nAPW_SYS: "..name.."/"..identifier.." is connecting.")
    --deferrals.update("Checking if you are banned...")
    if (playerCount >= playerMax) then
        print("\nAPW_SYS: Connection refused for ".. name.."/".. identifier.." : server full.")
        reason("Airport Wars is currently full, try again later.")
        CancelEvent()
        --deferrals.done("Airport Wars is currently full, try again later.")
        --return
    else
        --deferrals.update("Checking if Steam is running...")
        if string.find(identifier, "steam:") then
            local banned = MySQL.Sync.fetchAll("SELECT * FROM apw_bans WHERE identifier = @identifier", {['@identifier'] = identifier})
            if (banned[1] ~= nil) then
                print("\nAPW_SYS: Connection refused for ".. name.."/".. identifier.." : banned.")
                reason("You are banned from Airport Wars.")
                CancelEvent()
                --deferrals.done("You are banned from Airport Wars.")
                --return
            else
                if (whitelist) then
                    --deferrals.update("Checking if you are whitelisted...")
                    local whitelisted = MySQL.Sync.fetchAll("SELECT * FROM apw_whitelist WHERE identifier = @identifier", {['@identifier'] = identifier})
                    if (whitelisted[1] == nil) then
                        print("\nAPW_SYS: Connection refused for ".. name.."/".. identifier.." : not in the whitelist.")
                        reason("You can't Airport Wars for the moment.")
                        CancelEvent()
                        --deferrals.done("You can't Airport Wars for the moment.")
                        --return
                    else
                        print("\nAPW_SYS: Connection authorized for ".. name.."/".. identifier.." : everything ok.")
                        TriggerEvent("airportwars:discord:message", "**"..name.."** is joining Airport Wars.", true)
                        local players = GetAllConnectedPlayers()
                        for _, player in ipairs(players) do
                            TriggerClientEvent("airportwars:simplenotify", player, "APW_JOINED", -1, {"<C>"..name.."</C>"}, false)
                        end
                        --deferrals.done()
                    end
				else
					print("\nAPW_SYS: Connection authorized for ".. name.."/".. identifier.." : everything ok.")
					TriggerEvent("airportwars:discord:message", "**"..name.."** is joining Airport Wars.", true)
					TriggerEvent("airportwars:sys:getusers", function(players)
  						for _, player in ipairs(players) do
  							  TriggerClientEvent("airportwars:simplenotify", player, "APW_JOINED", -1, {"<C>"..name.."</C>"}, false)
  						end
					end)
					--deferrals.done()
                end
            end
        else
            print("\nAPW_SYS: Connection refused for ".. name.."/".. identifier.." : steam is not running.")
            reason("Steam must be running to join Airport Wars.")
            CancelEvent()
            --deferrals.done("Steam must be running to join Airport Wars.")
            --return
        end
		end
end)
---------------------------------------------------------------------------------------
