------------------------------------- VARIABLES ---------------------------------------
zcindex = 7
lsindex = 7
local StartedPlaying = false
local planestates = {
	{"PLANE SAFE", 185, 255, 189},
	{"PLANE STOLEN", 255, 211, 211},
	{"PLANE DELIVERED", 107, 171, 255},
	{"PLANE ABANDONED", 100, 53, 53},
	{"PLANE DESTROYED", 100, 53, 53},
	{"RESPAWNING...", 255, 244, 147},
  {"UNKNOWN", 59, 59, 59}
}
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
local function GetMinimapAnchor()
    local safezone = GetSafeZoneSize()
    local safezone_x = 1.0 / 20.0
    local safezone_y = 1.0 / 20.0
    local aspect_ratio = GetAspectRatio(0)
    local res_x, res_y = GetActiveScreenResolution()
    local xscale = 1.0 / res_x
    local yscale = 1.0 / res_y
    local Minimap = {}
    Minimap.width = xscale * (res_x / (4 * aspect_ratio))
    Minimap.height = yscale * (res_y / 5.674)
    Minimap.left_x = xscale * (res_x * (safezone_x * ((math.abs(safezone - 1.0)) * 10)))
    Minimap.bottom_y = 1.0 - yscale * (res_y * (safezone_y * ((math.abs(safezone - 1.0)) * 10)))
    Minimap.right_x = Minimap.left_x + Minimap.width
    Minimap.top_y = Minimap.bottom_y - Minimap.height
    Minimap.x = Minimap.left_x
    Minimap.y = Minimap.top_y
    Minimap.xunit = xscale
    Minimap.yunit = yscale
    return Minimap
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterNetEvent("airportwars:objectives:hud")
AddEventHandler("airportwars:objectives:hud", function(type, reason, switch)
    if (type == "zancudo") then
        if (reason == "safe") then
            zcindex = 1
				elseif (reason == "stolen") then
						zcindex = 2
        elseif (reason == "delivered") then
            zcindex = 3
				elseif (reason == "abandoned") then
						zcindex = 4
        elseif (reason == "destroyed") then
            zcindex = 5
        elseif (reason == "hostswitch") then
            zcindex = 6
        end
        if switch then
            Wait(15000)
            zcindex = 6
        end
    elseif (type == "airport") then
        if (reason == "safe") then
            lsindex = 1
				elseif (reason == "stolen") then
						lsindex = 2
        elseif (reason == "delivered") then
            lsindex = 3
				elseif (reason == "abandoned") then
						lsindex = 4
        elseif (reason == "destroyed") then
            lsindex = 5
        elseif (reason == "hostswitch") then
            lsindex = 6
        end
        if switch then
            Wait(15000)
            lsindex = 6
        end
    end
end)
---------------------------------------------------------------------------------------

-------------------------------------- THREADS ----------------------------------------
CreateThread(function()
	  while true do
	  	 Wait(0)
    		local ui = GetMinimapAnchor()
				if IsPedSittingInAnyVehicle(PlayerPedId()) then
            local speed = ""
            if (GetProfileSetting(227) == 0) then
                speed = tostring(math.ceil((GetEntitySpeed(GetVehiclePedIsIn(PlayerPedId(), false)) * 2.236936))).. " mph"
            elseif (GetProfileSetting(227) == 1) then
                speed = tostring(math.ceil((GetEntitySpeed(GetVehiclePedIsIn(PlayerPedId(), false)) * 3.6))).. " km/h"
            end
            SetTextFont(4)
            SetTextScale(1.0, 0.425)
            SetTextColour(255, 255, 255, 200)
            BeginTextCommandDisplayText("STRING")
            AddTextComponentSubstringPlayerName(speed)
            EndTextCommandDisplayText(ui.left_x + 0.005, ui.top_y + 0.005)
				end
        if not IsPlayerSwitchInProgress() and not IsWarningMessageActive() and not IsPauseMenuActive() and not IsSystemUiBeingDisplayed() and not IsPlayerDead(NetworkPlayerIdToInt()) and StartedPlaying and (GetProfileSetting(221) == 1) then
        	  SetTextColour(58,173,255, 255)
        		SetTextFont(1)
        		SetTextScale(.65, .65)
        		SetTextWrap(0.0, 1.0)
        		SetTextCentre(false)
        		SetTextDropshadow(2, 2, 0, 0, 0)
        		SetTextEdge(1, 0, 0, 0, 205)
        		SetTextEntry("STRING")
        		AddTextComponentString("Los Santos Airport")
        		DrawText(ui.right_x+.0214, ui.y + 0.032)
        		SetTextColour(planestates[lsindex][2], planestates[lsindex][3], planestates[lsindex][4], 255)
        		SetTextFont(4)
        		SetTextScale(.70, .70)
        		SetTextWrap(0.0, 1.0)
        		SetTextCentre(false)
        		SetTextDropshadow(2, 2, 0, 0, 0)
        		SetTextEdge(1, 0, 0, 0, 205)
        		SetTextEntry("STRING")
        		AddTextComponentString(planestates[lsindex][1])
        		DrawText(ui.right_x+.0214, ui.y + 0.06)
        		SetTextColour(216,93,93, 255)
        		SetTextFont(1)
        		SetTextScale(.65, .65)
        		SetTextWrap(0.0, 1.0)
        		SetTextCentre(false)
        		SetTextDropshadow(2, 2, 0, 0, 0)
        		SetTextEdge(1, 0, 0, 0, 205)
        		SetTextEntry("STRING")
        		AddTextComponentString("Fort Zancudo Airbase")
        		DrawText(ui.right_x+.0214, ui.y + 0.1)
        		SetTextColour(planestates[zcindex][2], planestates[zcindex][3], planestates[zcindex][4], 255)
        		SetTextFont(4)
        		SetTextScale(.70, .70)
        		SetTextWrap(0.0, 1.0)
        		SetTextCentre(false)
        		SetTextDropshadow(2, 2, 0, 0, 0)
        		SetTextEdge(1, 0, 0, 0, 205)
        		SetTextEntry("STRING")
        		AddTextComponentString(planestates[zcindex][1])
        		DrawText(ui.right_x+.0214, ui.y + 0.128)
        		DrawRect(ui.right_x + .09, ui.y+0.103,0.145,0.145,0,0,0,50)
        end
	  end
end)
---------------------------------------------------------------------------------------

RegisterNetEvent("airportwars:objectives:tempfix")
AddEventHandler("airportwars:objectives:tempfix", function()
		StartedPlaying = true
end)
