---------------------------------------------------------
-- RESSOURCE : Objectives - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Objectives script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local ZancudoPlaneNetID = nil
local AirportPlaneNetID = nil
local IsZancudoPlaneSpawning = false
local IsAirportPlaneSpawning = false
local ZancudoTimerStarted = false
local AirportTimerStarted = false
local ZancudoTimer = 0
local AirportTimer = 0
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:objectives:initialize")
AddEventHandler("airportwars:objectives:initialize", function(ishost)
    local source = source
    if ishost then
        TriggerClientEvent("airportwars:objectives:create", GetHostId())
        print("APW-OBJECTIVES: "..GetPlayerName(GetHostId()).." created the 2 first objectives as host.")
        return
    else
        while (ZancudoPlaneNetID == nil) and (AirportPlaneNetID == nil) do
            Wait(0)
        end
        TriggerClientEvent("airportwars:objectives:get", source, ZancudoPlaneNetID, AirportPlaneNetID)
        print("APW-OBJECTIVES: "..GetPlayerName(source).." received the objectives informations.")
    end
end)

RegisterServerEvent("airportwars:objectives:created")
AddEventHandler("airportwars:objectives:created", function(netidzancudo, netidairport)
    ZancudoPlaneNetID = netidzancudo
    AirportPlaneNetID = netidairport
    TriggerClientEvent("airportwars:objectives:get", source, ZancudoPlaneNetID, AirportPlaneNetID)
    print("APW-OBJECTIVES: "..GetPlayerName(GetHostId()).." confirmed the creation of the objectives with the ID "..netidzancudo.." for the Zancudo Plane and the ID "..netidairport.." for the Airport Plate, objectives informations sent.")
end)

RegisterServerEvent("airportwars:objectives:respawn")
AddEventHandler("airportwars:objectives:respawn", function(type, reason, hostswitch)
    if (type == "zancudo") then
        if not IsZancudoPlaneSpawning then
            IsZancudoPlaneSpawning = true
            TriggerClientEvent("airportwars:objectives:hud", -1, type, reason, true)
            TriggerClientEvent("airportwars:objectives:respawn", GetHostId(), type, hostswitch)
            print("APW-OBJECTIVES: Respawn of the "..type.." plane requested for the following reason : "..reason.." is allowed.")
        else
            print("APW-OBJECTIVES: Respawn of the "..type.." plane requested for the following reason : "..reason.." is denied.")
        end
    elseif (type == "airport") then
        if not IsAirportPlaneSpawning then
            IsAirportPlaneSpawning = true
            TriggerClientEvent("airportwars:objectives:hud", -1, type, reason, true)
            TriggerClientEvent("airportwars:objectives:respawn", GetHostId(), type, hostswitch)
            print("APW-OBJECTIVES: Respawn of the "..type.." plane requested for the following reason : "..reason.." is allowed.")
        else
            print("APW-OBJECTIVES: Respawn of the "..type.." plane requested for the following reason : "..reason.." is denied.")
        end
    end
end)

RegisterServerEvent("airportwars:objectives:respawned")
AddEventHandler("airportwars:objectives:respawned", function(netid, planetype)
    if (planetype == "zancudo") then
        ZancudoPlaneNetID = netid
        IsZancudoPlaneSpawning = false
        TriggerClientEvent("airportwars:objectives:reget", -1, ZancudoPlaneNetID, "zancudo")
    elseif (planetype == "airport") then
        AirportPlaneNetID = netid
        IsAirportPlaneSpawning = false
        TriggerClientEvent("airportwars:objectives:reget", -1, AirportPlaneNetID, "airport")
    end
    print("APW-OBJECTIVES: Host of the session confirmed : Plane "..planetype.." has been spawned and informations sent to other clients.")
end)

RegisterServerEvent("airportwars:objectives:delivered")
AddEventHandler("airportwars:objectives:delivered", function(teamofattacker)
    local source = source
    local players = GetAllConnectedPlayers()
    local minplayers = 2
    if (#players >= minplayers) then
        local score = 10
        local cash = 3000
        local cashteam = 300
        TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
            Network.AddToStat("SCORE", score, "score", true)
            Network.AddToWalletBalance(cash, true)
            TriggerClientEvent("airportwars:notify", source, "PLYSRC_SCORE_CASH", -1, {tostring(round(score * NetworkAccessTunable("SCORE_MULTIPLIER"))), tostring(round(cash * NetworkAccessTunable("CASH_MULTIPLIER")))}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
        end)
        for _, player in ipairs(players) do
            if (player ~= source) then
                if teamofattacker == 1 then
                    TriggerClientEvent("airportwars:notify", player, "PLY_DELIV_PLANE_LS", -1, {PatchPlayerName(teamofattacker, GetPlayerName(source))}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                elseif teamofattacker == 2 then
                    TriggerClientEvent("airportwars:notify", player, "PLY_DELIV_PLANE_ZC", -1, {PatchPlayerName(teamofattacker, GetPlayerName(source))}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                end
                TriggerEvent("airportwars:sys:getuserfromid", player, function(Network)
                    if (Network.GetInfo("TEAM") == teamofattacker) then
                        Network.AddToWalletBalance(cashteam, true)
                        TriggerClientEvent("airportwars:notify", player, "TEAM_DELIV_PLANE_AWRD", -1, {PatchPlayerName(teamofattacker, GetPlayerName(source)), tostring(round(cashteam * NetworkAccessTunable("CASH_MULTIPLIER")))}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                    end
                end)
            end
        end
        if teamofattacker == 1 then
            TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(source).."** has just delivered a plane from the Los Santos Airport! (earned $"..tostring(round(cash * NetworkAccessTunable("CASH_MULTIPLIER"))).."!, all players on his team have earned $"..tostring(round(cashteam * NetworkAccessTunable("CASH_MULTIPLIER")))..")", true)
        elseif teamofattacker == 2 then
            TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(source).."** has just delivered a plane from the Fort Zancudo Airbase! (earned $"..tostring(round(cash * NetworkAccessTunable("CASH_MULTIPLIER"))).."!, all players on his team have earned $"..tostring(round(cashteam * NetworkAccessTunable("CASH_MULTIPLIER")))..")", true)
        end
    else
        TriggerClientEvent("airportwars:notify", source, "PLY_DELIV_NORWRD", -1, {tostring(minplayers)}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
        if teamofattacker == 1 then
            TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(source).."** has just delivered a plane from the Los Santos Airport! (earned nothing: objectives are not rewarded unless there are more than "..tostring(minplayers).." players online)", true)
        elseif teamofattacker == 2 then
            TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(source).."** has just delivered a plane from the Fort Zancudo Airbase! (earned nothing: objectives are not rewarded unless there are more than "..tostring(minplayers).." players online)", true)
        end
        for _, player in ipairs(players) do
            if (player ~= source) then
                if teamofattacker == 1 then
                    TriggerClientEvent("airportwars:notify", player, "PLY_DELIV_PLANE_LS", -1, {1, PatchPlayerName(teamofattacker, GetPlayerName(source))}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                elseif teamofattacker == 2 then
                    TriggerClientEvent("airportwars:notify", player, "PLY_DELIV_PLANE_ZC", -1, {2, PatchPlayerName(teamofattacker, GetPlayerName(source))}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars", "Info", 1.0, true)
                end
            end
        end
    end
end)

RegisterServerEvent("airportwars:objectives:update")
AddEventHandler("airportwars:objectives:update", function(type, state)
    TriggerClientEvent("airportwars:objectives:hud", -1, type, state, false)
    print("APW-OBJECTIVES: Host requested an HUD update to everyone with the informations : plane = "..type..", state = "..state.." .")
end)

RegisterServerEvent("airportwars:objectives:preventhost")
AddEventHandler("airportwars:objectives:preventhost", function(plane)
    TriggerClientEvent("airportwars:objectives:preventhost", GetHostId(), plane, true)
end)
---------------------------------------------------------------------------------------

AirportWarsThread(5, function()
    if IsZancudoPlaneSpawning then
        if ZancudoTimerStarted then
            if GetGameTimer() - ZancudoTimer > 60000 then
                IsZancudoPlaneSpawning = false
                ZancudoTimer = 0
            end
        else
            ZancudoTimer = GetGameTimer()
            ZancudoTimerStarted = true
        end
    end
    if IsAirportPlaneSpawning then
        if AirportTimerStarted then
            if GetGameTimer() - AirportTimer > 60000 then
                IsAirportPlaneSpawning = false
                AirportTimer = 0
            end
        else
            AirportTimer = GetGameTimer()
            AirportTimerStarted = true
        end
    end
end)
